/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 27 "surface.yy"

#include <string>
#include <stack>

//      utility stuff
#include "macros.hh"
#include "vector.hh"

//	forward declarations
#include "interface.hh"
#include "core.hh"
#include "higher.hh"
#include "strategyLanguage.hh"
#include "mixfix.hh"

//	interface class definitions
#include "dagNode.hh"

//	core class definitions
#include "lineNumber.hh"
#include "module.hh"

//	higher class definitions
#include "narrowingSequenceSearch3.hh"

//	front end class definitions
#include "token.hh"
#include "renaming.hh"
#include "moduleExpression.hh"
#include "viewExpression.hh"
#include "fileTable.hh"
#include "directoryManager.hh"
#include "syntacticPreModule.hh"
#include "visibleModule.hh"
#include "syntacticView.hh"
#include "userLevelRewritingContext.hh"
#include "interpreter.hh"

#include "global.hh"
#define clear()			tokenSequence.clear();
#define store(token)		tokenSequence.append(token)
#define fragClear()		fragments.contractTo(0);
#define fragStore(token)	fragments.append(token)
//#define YYPARSE_PARAM	parseResult
//#define PARSE_RESULT	(*((UserLevelRewritingContext::ParseResult*) parseResult))
#define PARSE_RESULT	(*parseResult)

#define CM		interpreter.getCurrentModule()
#define CV		interpreter.getCurrentView()

#include "lexerAux.hh"

Vector<Token> singleton(1);
Vector<Token> tokenSequence;
Vector<Token> lexerBubble;
Vector<Token> fragments;
Vector<Token> moduleExpr;
Vector<Token> opDescription;
Vector<Token> strategyCall;

Renaming* currentRenaming = 0;
SyntaxContainer* currentSyntaxContainer = 0;
SyntaxContainer* oldSyntaxContainer = 0;
bool suppressParserErrorMessage = false;

Int64 number;
Int64 number2;
int variantOptions;

static void yyerror(UserLevelRewritingContext::ParseResult* parseResult, const char *s);

void cleanUpModuleExpression();
void cleanUpParser();
void deepSelfDestructViewExpressionVector(Vector<ViewExpression*>* viewExpressions);
void missingSpace(const Token& token);

#line 148 "surface.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "surface.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_FILE_NAME_STRING = 3,           /* FILE_NAME_STRING  */
  YYSYMBOL_UNINTERPRETED_STRING = 4,       /* UNINTERPRETED_STRING  */
  YYSYMBOL_LATEX_STRING = 5,               /* LATEX_STRING  */
  YYSYMBOL_KW_MOD = 6,                     /* KW_MOD  */
  YYSYMBOL_KW_VIEW = 7,                    /* KW_VIEW  */
  YYSYMBOL_KW_PARSE = 8,                   /* KW_PARSE  */
  YYSYMBOL_KW_NORMALIZE = 9,               /* KW_NORMALIZE  */
  YYSYMBOL_KW_REDUCE = 10,                 /* KW_REDUCE  */
  YYSYMBOL_KW_REWRITE = 11,                /* KW_REWRITE  */
  YYSYMBOL_KW_OO = 12,                     /* KW_OO  */
  YYSYMBOL_KW_LOOP = 13,                   /* KW_LOOP  */
  YYSYMBOL_KW_NARROW = 14,                 /* KW_NARROW  */
  YYSYMBOL_KW_XG_NARROW = 15,              /* KW_XG_NARROW  */
  YYSYMBOL_KW_MATCH = 16,                  /* KW_MATCH  */
  YYSYMBOL_KW_XMATCH = 17,                 /* KW_XMATCH  */
  YYSYMBOL_KW_UNIFY = 18,                  /* KW_UNIFY  */
  YYSYMBOL_KW_CHECK = 19,                  /* KW_CHECK  */
  YYSYMBOL_KW_GET = 20,                    /* KW_GET  */
  YYSYMBOL_KW_VARIANTS = 21,               /* KW_VARIANTS  */
  YYSYMBOL_KW_VARIANT = 22,                /* KW_VARIANT  */
  YYSYMBOL_KW_EREWRITE = 23,               /* KW_EREWRITE  */
  YYSYMBOL_KW_FREWRITE = 24,               /* KW_FREWRITE  */
  YYSYMBOL_KW_SREWRITE = 25,               /* KW_SREWRITE  */
  YYSYMBOL_KW_DSREWRITE = 26,              /* KW_DSREWRITE  */
  YYSYMBOL_KW_CONTINUE = 27,               /* KW_CONTINUE  */
  YYSYMBOL_KW_SEARCH = 28,                 /* KW_SEARCH  */
  YYSYMBOL_KW_SET = 29,                    /* KW_SET  */
  YYSYMBOL_KW_SHOW = 30,                   /* KW_SHOW  */
  YYSYMBOL_KW_ON = 31,                     /* KW_ON  */
  YYSYMBOL_KW_OFF = 32,                    /* KW_OFF  */
  YYSYMBOL_KW_TRACE = 33,                  /* KW_TRACE  */
  YYSYMBOL_KW_BODY = 34,                   /* KW_BODY  */
  YYSYMBOL_KW_BUILTIN = 35,                /* KW_BUILTIN  */
  YYSYMBOL_KW_WHOLE = 36,                  /* KW_WHOLE  */
  YYSYMBOL_KW_SELECT = 37,                 /* KW_SELECT  */
  YYSYMBOL_KW_DESELECT = 38,               /* KW_DESELECT  */
  YYSYMBOL_KW_CONDITION = 39,              /* KW_CONDITION  */
  YYSYMBOL_KW_SUBSTITUTION = 40,           /* KW_SUBSTITUTION  */
  YYSYMBOL_KW_PRINT = 41,                  /* KW_PRINT  */
  YYSYMBOL_KW_GRAPH = 42,                  /* KW_GRAPH  */
  YYSYMBOL_KW_MIXFIX = 43,                 /* KW_MIXFIX  */
  YYSYMBOL_KW_FLAT = 44,                   /* KW_FLAT  */
  YYSYMBOL_KW_ATTRIBUTE = 45,              /* KW_ATTRIBUTE  */
  YYSYMBOL_KW_NEWLINE = 46,                /* KW_NEWLINE  */
  YYSYMBOL_KW_WITH = 47,                   /* KW_WITH  */
  YYSYMBOL_KW_PARENS = 48,                 /* KW_PARENS  */
  YYSYMBOL_KW_ALIASES = 49,                /* KW_ALIASES  */
  YYSYMBOL_KW_GC = 50,                     /* KW_GC  */
  YYSYMBOL_KW_TIME = 51,                   /* KW_TIME  */
  YYSYMBOL_KW_STATS = 52,                  /* KW_STATS  */
  YYSYMBOL_KW_TIMING = 53,                 /* KW_TIMING  */
  YYSYMBOL_KW_CMD = 54,                    /* KW_CMD  */
  YYSYMBOL_KW_BREAKDOWN = 55,              /* KW_BREAKDOWN  */
  YYSYMBOL_KW_BREAK = 56,                  /* KW_BREAK  */
  YYSYMBOL_KW_PATH = 57,                   /* KW_PATH  */
  YYSYMBOL_KW_STATE = 58,                  /* KW_STATE  */
  YYSYMBOL_KW_CONST = 59,                  /* KW_CONST  */
  YYSYMBOL_KW_MODULE = 60,                 /* KW_MODULE  */
  YYSYMBOL_KW_MODULES = 61,                /* KW_MODULES  */
  YYSYMBOL_KW_VIEWS = 62,                  /* KW_VIEWS  */
  YYSYMBOL_KW_ALL = 63,                    /* KW_ALL  */
  YYSYMBOL_KW_SORTS = 64,                  /* KW_SORTS  */
  YYSYMBOL_KW_OPS2 = 65,                   /* KW_OPS2  */
  YYSYMBOL_KW_VARS = 66,                   /* KW_VARS  */
  YYSYMBOL_KW_MBS = 67,                    /* KW_MBS  */
  YYSYMBOL_KW_EQS = 68,                    /* KW_EQS  */
  YYSYMBOL_KW_RLS = 69,                    /* KW_RLS  */
  YYSYMBOL_KW_STRATS = 70,                 /* KW_STRATS  */
  YYSYMBOL_KW_SDS = 71,                    /* KW_SDS  */
  YYSYMBOL_KW_SUMMARY = 72,                /* KW_SUMMARY  */
  YYSYMBOL_KW_KINDS = 73,                  /* KW_KINDS  */
  YYSYMBOL_KW_ADVISE = 74,                 /* KW_ADVISE  */
  YYSYMBOL_KW_VERBOSE = 75,                /* KW_VERBOSE  */
  YYSYMBOL_KW_DO = 76,                     /* KW_DO  */
  YYSYMBOL_KW_CLEAR = 77,                  /* KW_CLEAR  */
  YYSYMBOL_KW_PROTECT = 78,                /* KW_PROTECT  */
  YYSYMBOL_KW_EXTEND = 79,                 /* KW_EXTEND  */
  YYSYMBOL_KW_GENERATE_BY = 80,            /* KW_GENERATE_BY  */
  YYSYMBOL_KW_INCLUDE = 81,                /* KW_INCLUDE  */
  YYSYMBOL_KW_EXCLUDE = 82,                /* KW_EXCLUDE  */
  YYSYMBOL_KW_CONCEAL = 83,                /* KW_CONCEAL  */
  YYSYMBOL_KW_REVEAL = 84,                 /* KW_REVEAL  */
  YYSYMBOL_KW_COMPILE = 85,                /* KW_COMPILE  */
  YYSYMBOL_KW_COUNT = 86,                  /* KW_COUNT  */
  YYSYMBOL_KW_DEBUG = 87,                  /* KW_DEBUG  */
  YYSYMBOL_KW_IRREDUNDANT = 88,            /* KW_IRREDUNDANT  */
  YYSYMBOL_KW_FILTERED = 89,               /* KW_FILTERED  */
  YYSYMBOL_KW_RESUME = 90,                 /* KW_RESUME  */
  YYSYMBOL_KW_ABORT = 91,                  /* KW_ABORT  */
  YYSYMBOL_KW_STEP = 92,                   /* KW_STEP  */
  YYSYMBOL_KW_WHERE = 93,                  /* KW_WHERE  */
  YYSYMBOL_KW_CREDUCE = 94,                /* KW_CREDUCE  */
  YYSYMBOL_KW_SREDUCE = 95,                /* KW_SREDUCE  */
  YYSYMBOL_KW_DUMP = 96,                   /* KW_DUMP  */
  YYSYMBOL_KW_PROFILE = 97,                /* KW_PROFILE  */
  YYSYMBOL_KW_NUMBER = 98,                 /* KW_NUMBER  */
  YYSYMBOL_KW_RAT = 99,                    /* KW_RAT  */
  YYSYMBOL_KW_COLOR = 100,                 /* KW_COLOR  */
  YYSYMBOL_KW_IMPLIED_STEP = 101,          /* KW_IMPLIED_STEP  */
  YYSYMBOL_SIMPLE_NUMBER = 102,            /* SIMPLE_NUMBER  */
  YYSYMBOL_KW_PWD = 103,                   /* KW_PWD  */
  YYSYMBOL_KW_CD = 104,                    /* KW_CD  */
  YYSYMBOL_KW_PUSHD = 105,                 /* KW_PUSHD  */
  YYSYMBOL_KW_POPD = 106,                  /* KW_POPD  */
  YYSYMBOL_KW_LS = 107,                    /* KW_LS  */
  YYSYMBOL_KW_LL = 108,                    /* KW_LL  */
  YYSYMBOL_KW_LOAD = 109,                  /* KW_LOAD  */
  YYSYMBOL_KW_SLOAD = 110,                 /* KW_SLOAD  */
  YYSYMBOL_KW_QUIT = 111,                  /* KW_QUIT  */
  YYSYMBOL_KW_EOF = 112,                   /* KW_EOF  */
  YYSYMBOL_KW_TEST = 113,                  /* KW_TEST  */
  YYSYMBOL_KW_SMT_SEARCH = 114,            /* KW_SMT_SEARCH  */
  YYSYMBOL_KW_VU_NARROW = 115,             /* KW_VU_NARROW  */
  YYSYMBOL_KW_FVU_NARROW = 116,            /* KW_FVU_NARROW  */
  YYSYMBOL_KW_FOLD = 117,                  /* KW_FOLD  */
  YYSYMBOL_KW_DESUGARED = 118,             /* KW_DESUGARED  */
  YYSYMBOL_KW_PROCESSED = 119,             /* KW_PROCESSED  */
  YYSYMBOL_KW_ENDM = 120,                  /* KW_ENDM  */
  YYSYMBOL_KW_IMPORT = 121,                /* KW_IMPORT  */
  YYSYMBOL_KW_ENDV = 122,                  /* KW_ENDV  */
  YYSYMBOL_KW_SORT = 123,                  /* KW_SORT  */
  YYSYMBOL_KW_SUBSORT = 124,               /* KW_SUBSORT  */
  YYSYMBOL_KW_OP = 125,                    /* KW_OP  */
  YYSYMBOL_KW_OPS = 126,                   /* KW_OPS  */
  YYSYMBOL_KW_MSGS = 127,                  /* KW_MSGS  */
  YYSYMBOL_KW_VAR = 128,                   /* KW_VAR  */
  YYSYMBOL_KW_CLASS = 129,                 /* KW_CLASS  */
  YYSYMBOL_KW_SUBCLASS = 130,              /* KW_SUBCLASS  */
  YYSYMBOL_KW_DSTRAT = 131,                /* KW_DSTRAT  */
  YYSYMBOL_KW_MB = 132,                    /* KW_MB  */
  YYSYMBOL_KW_CMB = 133,                   /* KW_CMB  */
  YYSYMBOL_KW_EQ = 134,                    /* KW_EQ  */
  YYSYMBOL_KW_CEQ = 135,                   /* KW_CEQ  */
  YYSYMBOL_KW_RL = 136,                    /* KW_RL  */
  YYSYMBOL_KW_CRL = 137,                   /* KW_CRL  */
  YYSYMBOL_KW_SD = 138,                    /* KW_SD  */
  YYSYMBOL_KW_CSD = 139,                   /* KW_CSD  */
  YYSYMBOL_KW_ATTR = 140,                  /* KW_ATTR  */
  YYSYMBOL_KW_IS = 141,                    /* KW_IS  */
  YYSYMBOL_KW_FROM = 142,                  /* KW_FROM  */
  YYSYMBOL_KW_ARROW = 143,                 /* KW_ARROW  */
  YYSYMBOL_KW_ARROW2 = 144,                /* KW_ARROW2  */
  YYSYMBOL_KW_PARTIAL = 145,               /* KW_PARTIAL  */
  YYSYMBOL_KW_IF = 146,                    /* KW_IF  */
  YYSYMBOL_KW_ASSIGN = 147,                /* KW_ASSIGN  */
  YYSYMBOL_148_ = 148,                     /* ':'  */
  YYSYMBOL_149_ = 149,                     /* '='  */
  YYSYMBOL_150_ = 150,                     /* '('  */
  YYSYMBOL_151_ = 151,                     /* ')'  */
  YYSYMBOL_152_ = 152,                     /* '.'  */
  YYSYMBOL_153_ = 153,                     /* '<'  */
  YYSYMBOL_154_ = 154,                     /* '['  */
  YYSYMBOL_155_ = 155,                     /* ']'  */
  YYSYMBOL_156_ = 156,                     /* ','  */
  YYSYMBOL_157_ = 157,                     /* '|'  */
  YYSYMBOL_158_ = 158,                     /* '@'  */
  YYSYMBOL_KW_LABEL = 159,                 /* KW_LABEL  */
  YYSYMBOL_KW_TO = 160,                    /* KW_TO  */
  YYSYMBOL_KW_COLON2 = 161,                /* KW_COLON2  */
  YYSYMBOL_162_ = 162,                     /* '+'  */
  YYSYMBOL_163_ = 163,                     /* '*'  */
  YYSYMBOL_164_ = 164,                     /* '{'  */
  YYSYMBOL_165_ = 165,                     /* '}'  */
  YYSYMBOL_KW_ASSOC = 166,                 /* KW_ASSOC  */
  YYSYMBOL_KW_COMM = 167,                  /* KW_COMM  */
  YYSYMBOL_KW_ID = 168,                    /* KW_ID  */
  YYSYMBOL_KW_IDEM = 169,                  /* KW_IDEM  */
  YYSYMBOL_KW_ITER = 170,                  /* KW_ITER  */
  YYSYMBOL_KW_PCONST = 171,                /* KW_PCONST  */
  YYSYMBOL_KW_LEFT = 172,                  /* KW_LEFT  */
  YYSYMBOL_KW_RIGHT = 173,                 /* KW_RIGHT  */
  YYSYMBOL_KW_PREC = 174,                  /* KW_PREC  */
  YYSYMBOL_KW_GATHER = 175,                /* KW_GATHER  */
  YYSYMBOL_KW_METADATA = 176,              /* KW_METADATA  */
  YYSYMBOL_KW_STRAT = 177,                 /* KW_STRAT  */
  YYSYMBOL_KW_ASTRAT = 178,                /* KW_ASTRAT  */
  YYSYMBOL_KW_POLY = 179,                  /* KW_POLY  */
  YYSYMBOL_KW_MEMO = 180,                  /* KW_MEMO  */
  YYSYMBOL_KW_FROZEN = 181,                /* KW_FROZEN  */
  YYSYMBOL_KW_CTOR = 182,                  /* KW_CTOR  */
  YYSYMBOL_KW_LATEX = 183,                 /* KW_LATEX  */
  YYSYMBOL_KW_SPECIAL = 184,               /* KW_SPECIAL  */
  YYSYMBOL_KW_CONFIG = 185,                /* KW_CONFIG  */
  YYSYMBOL_KW_OBJ = 186,                   /* KW_OBJ  */
  YYSYMBOL_KW_MSG = 187,                   /* KW_MSG  */
  YYSYMBOL_KW_DITTO = 188,                 /* KW_DITTO  */
  YYSYMBOL_KW_FORMAT = 189,                /* KW_FORMAT  */
  YYSYMBOL_KW_ID_HOOK = 190,               /* KW_ID_HOOK  */
  YYSYMBOL_KW_OP_HOOK = 191,               /* KW_OP_HOOK  */
  YYSYMBOL_KW_TERM_HOOK = 192,             /* KW_TERM_HOOK  */
  YYSYMBOL_KW_IN = 193,                    /* KW_IN  */
  YYSYMBOL_KW_FILTER = 194,                /* KW_FILTER  */
  YYSYMBOL_KW_DELAY = 195,                 /* KW_DELAY  */
  YYSYMBOL_IDENTIFIER = 196,               /* IDENTIFIER  */
  YYSYMBOL_NUMERIC_ID = 197,               /* NUMERIC_ID  */
  YYSYMBOL_ENDS_IN_DOT = 198,              /* ENDS_IN_DOT  */
  YYSYMBOL_FORCE_LOOKAHEAD = 199,          /* FORCE_LOOKAHEAD  */
  YYSYMBOL_CHANGE_FILE = 200,              /* CHANGE_FILE  */
  YYSYMBOL_END_OF_INPUT = 201,             /* END_OF_INPUT  */
  YYSYMBOL_YYACCEPT = 202,                 /* $accept  */
  YYSYMBOL_top = 203,                      /* top  */
  YYSYMBOL_item = 204,                     /* item  */
  YYSYMBOL_directive = 205,                /* directive  */
  YYSYMBOL_206_1 = 206,                    /* $@1  */
  YYSYMBOL_207_2 = 207,                    /* $@2  */
  YYSYMBOL_208_3 = 208,                    /* $@3  */
  YYSYMBOL_209_4 = 209,                    /* $@4  */
  YYSYMBOL_210_5 = 210,                    /* $@5  */
  YYSYMBOL_211_6 = 211,                    /* $@6  */
  YYSYMBOL_212_7 = 212,                    /* $@7  */
  YYSYMBOL_moduleExprDot = 213,            /* moduleExprDot  */
  YYSYMBOL_moduleExpr = 214,               /* moduleExpr  */
  YYSYMBOL_moduleExpr2 = 215,              /* moduleExpr2  */
  YYSYMBOL_moduleExpr3 = 216,              /* moduleExpr3  */
  YYSYMBOL_renameExpr = 217,               /* renameExpr  */
  YYSYMBOL_instantExpr = 218,              /* instantExpr  */
  YYSYMBOL_parenExpr = 219,                /* parenExpr  */
  YYSYMBOL_viewExpr = 220,                 /* viewExpr  */
  YYSYMBOL_instantArgs = 221,              /* instantArgs  */
  YYSYMBOL_renaming = 222,                 /* renaming  */
  YYSYMBOL_223_8 = 223,                    /* $@8  */
  YYSYMBOL_224_9 = 224,                    /* $@9  */
  YYSYMBOL_renaming2 = 225,                /* renaming2  */
  YYSYMBOL_mappingList = 226,              /* mappingList  */
  YYSYMBOL_mapping = 227,                  /* mapping  */
  YYSYMBOL_228_10 = 228,                   /* $@10  */
  YYSYMBOL_229_11 = 229,                   /* $@11  */
  YYSYMBOL_230_12 = 230,                   /* $@12  */
  YYSYMBOL_231_13 = 231,                   /* $@13  */
  YYSYMBOL_232_14 = 232,                   /* $@14  */
  YYSYMBOL_233_15 = 233,                   /* $@15  */
  YYSYMBOL_fromSpec = 234,                 /* fromSpec  */
  YYSYMBOL_235_16 = 235,                   /* $@16  */
  YYSYMBOL_fromAttrSpec = 236,             /* fromAttrSpec  */
  YYSYMBOL_fromStratSpec = 237,            /* fromStratSpec  */
  YYSYMBOL_toAttributes = 238,             /* toAttributes  */
  YYSYMBOL_239_17 = 239,                   /* $@17  */
  YYSYMBOL_toAttributeList = 240,          /* toAttributeList  */
  YYSYMBOL_toAttribute = 241,              /* toAttribute  */
  YYSYMBOL_242_18 = 242,                   /* $@18  */
  YYSYMBOL_243_19 = 243,                   /* $@19  */
  YYSYMBOL_244_20 = 244,                   /* $@20  */
  YYSYMBOL_view = 245,                     /* view  */
  YYSYMBOL_246_21 = 246,                   /* $@21  */
  YYSYMBOL_247_22 = 247,                   /* $@22  */
  YYSYMBOL_viewDecList = 248,              /* viewDecList  */
  YYSYMBOL_skipStrayArrow = 249,           /* skipStrayArrow  */
  YYSYMBOL_viewDeclaration = 250,          /* viewDeclaration  */
  YYSYMBOL_251_23 = 251,                   /* $@23  */
  YYSYMBOL_252_24 = 252,                   /* $@24  */
  YYSYMBOL_253_25 = 253,                   /* $@25  */
  YYSYMBOL_sortDot = 254,                  /* sortDot  */
  YYSYMBOL_viewEndOpMap = 255,             /* viewEndOpMap  */
  YYSYMBOL_256_26 = 256,                   /* $@26  */
  YYSYMBOL_257_27 = 257,                   /* $@27  */
  YYSYMBOL_258_28 = 258,                   /* $@28  */
  YYSYMBOL_endMsgMap = 259,                /* endMsgMap  */
  YYSYMBOL_260_29 = 260,                   /* $@29  */
  YYSYMBOL_261_30 = 261,                   /* $@30  */
  YYSYMBOL_262_31 = 262,                   /* $@31  */
  YYSYMBOL_strategyCall = 263,             /* strategyCall  */
  YYSYMBOL_264_32 = 264,                   /* $@32  */
  YYSYMBOL_viewStratMap = 265,             /* viewStratMap  */
  YYSYMBOL_266_33 = 266,                   /* $@33  */
  YYSYMBOL_267_34 = 267,                   /* $@34  */
  YYSYMBOL_endBubble = 268,                /* endBubble  */
  YYSYMBOL_parenBubble = 269,              /* parenBubble  */
  YYSYMBOL_270_35 = 270,                   /* $@35  */
  YYSYMBOL_module = 271,                   /* module  */
  YYSYMBOL_272_36 = 272,                   /* $@36  */
  YYSYMBOL_273_37 = 273,                   /* $@37  */
  YYSYMBOL_dot = 274,                      /* dot  */
  YYSYMBOL_parameters = 275,               /* parameters  */
  YYSYMBOL_parameterList = 276,            /* parameterList  */
  YYSYMBOL_parameter = 277,                /* parameter  */
  YYSYMBOL_colon2 = 278,                   /* colon2  */
  YYSYMBOL_badType = 279,                  /* badType  */
  YYSYMBOL_typeDot = 280,                  /* typeDot  */
  YYSYMBOL_decList = 281,                  /* decList  */
  YYSYMBOL_declaration = 282,              /* declaration  */
  YYSYMBOL_283_38 = 283,                   /* $@38  */
  YYSYMBOL_284_39 = 284,                   /* $@39  */
  YYSYMBOL_285_40 = 285,                   /* $@40  */
  YYSYMBOL_286_41 = 286,                   /* $@41  */
  YYSYMBOL_287_42 = 287,                   /* $@42  */
  YYSYMBOL_288_43 = 288,                   /* $@43  */
  YYSYMBOL_289_44 = 289,                   /* $@44  */
  YYSYMBOL_290_45 = 290,                   /* $@45  */
  YYSYMBOL_291_46 = 291,                   /* $@46  */
  YYSYMBOL_292_47 = 292,                   /* $@47  */
  YYSYMBOL_293_48 = 293,                   /* $@48  */
  YYSYMBOL_294_49 = 294,                   /* $@49  */
  YYSYMBOL_295_50 = 295,                   /* $@50  */
  YYSYMBOL_296_51 = 296,                   /* $@51  */
  YYSYMBOL_297_52 = 297,                   /* $@52  */
  YYSYMBOL_298_53 = 298,                   /* $@53  */
  YYSYMBOL_299_54 = 299,                   /* $@54  */
  YYSYMBOL_300_55 = 300,                   /* $@55  */
  YYSYMBOL_301_56 = 301,                   /* $@56  */
  YYSYMBOL_302_57 = 302,                   /* $@57  */
  YYSYMBOL_303_58 = 303,                   /* $@58  */
  YYSYMBOL_304_59 = 304,                   /* $@59  */
  YYSYMBOL_305_60 = 305,                   /* $@60  */
  YYSYMBOL_306_61 = 306,                   /* $@61  */
  YYSYMBOL_307_62 = 307,                   /* $@62  */
  YYSYMBOL_308_63 = 308,                   /* $@63  */
  YYSYMBOL_309_64 = 309,                   /* $@64  */
  YYSYMBOL_310_65 = 310,                   /* $@65  */
  YYSYMBOL_classDecl = 311,                /* classDecl  */
  YYSYMBOL_312_66 = 312,                   /* $@66  */
  YYSYMBOL_classDef = 313,                 /* classDef  */
  YYSYMBOL_finalPair = 314,                /* finalPair  */
  YYSYMBOL_cPairList = 315,                /* cPairList  */
  YYSYMBOL_cPair = 316,                    /* cPair  */
  YYSYMBOL_varNameList = 317,              /* varNameList  */
  YYSYMBOL_opNameList = 318,               /* opNameList  */
  YYSYMBOL_simpleOpName = 319,             /* simpleOpName  */
  YYSYMBOL_domainRangeAttr = 320,          /* domainRangeAttr  */
  YYSYMBOL_stratDeclKeyword = 321,         /* stratDeclKeyword  */
  YYSYMBOL_stratIdList = 322,              /* stratIdList  */
  YYSYMBOL_stratId = 323,                  /* stratId  */
  YYSYMBOL_stratSignature = 324,           /* stratSignature  */
  YYSYMBOL_stratAttributes = 325,          /* stratAttributes  */
  YYSYMBOL_stratAttrList = 326,            /* stratAttrList  */
  YYSYMBOL_skipStrayColon = 327,           /* skipStrayColon  */
  YYSYMBOL_dra2 = 328,                     /* dra2  */
  YYSYMBOL_rangeAttr = 329,                /* rangeAttr  */
  YYSYMBOL_typeAttr = 330,                 /* typeAttr  */
  YYSYMBOL_arrow = 331,                    /* arrow  */
  YYSYMBOL_typeList = 332,                 /* typeList  */
  YYSYMBOL_typeName1 = 333,                /* typeName1  */
  YYSYMBOL_typeName1Dot = 334,             /* typeName1Dot  */
  YYSYMBOL_kind = 335,                     /* kind  */
  YYSYMBOL_336_67 = 336,                   /* $@67  */
  YYSYMBOL_typeName = 337,                 /* typeName  */
  YYSYMBOL_338_68 = 338,                   /* $@68  */
  YYSYMBOL_sortNames = 339,                /* sortNames  */
  YYSYMBOL_attributes = 340,               /* attributes  */
  YYSYMBOL_attributeList = 341,            /* attributeList  */
  YYSYMBOL_idKeyword = 342,                /* idKeyword  */
  YYSYMBOL_attribute = 343,                /* attribute  */
  YYSYMBOL_344_69 = 344,                   /* $@69  */
  YYSYMBOL_345_70 = 345,                   /* $@70  */
  YYSYMBOL_346_71 = 346,                   /* $@71  */
  YYSYMBOL_347_72 = 347,                   /* $@72  */
  YYSYMBOL_348_73 = 348,                   /* $@73  */
  YYSYMBOL_349_74 = 349,                   /* $@74  */
  YYSYMBOL_350_75 = 350,                   /* $@75  */
  YYSYMBOL_351_76 = 351,                   /* $@76  */
  YYSYMBOL_identity = 352,                 /* identity  */
  YYSYMBOL_idList = 353,                   /* idList  */
  YYSYMBOL_hookList = 354,                 /* hookList  */
  YYSYMBOL_hook = 355,                     /* hook  */
  YYSYMBOL_expectedIs = 356,               /* expectedIs  */
  YYSYMBOL_expectedDot = 357,              /* expectedDot  */
  YYSYMBOL_sortNameList = 358,             /* sortNameList  */
  YYSYMBOL_endSortNameList = 359,          /* endSortNameList  */
  YYSYMBOL_subsortList = 360,              /* subsortList  */
  YYSYMBOL_endSubsortList = 361,           /* endSubsortList  */
  YYSYMBOL_sortName = 362,                 /* sortName  */
  YYSYMBOL_sortNameFrag = 363,             /* sortNameFrag  */
  YYSYMBOL_364_77 = 364,                   /* $@77  */
  YYSYMBOL_sortNameFrags = 365,            /* sortNameFrags  */
  YYSYMBOL_366_78 = 366,                   /* $@78  */
  YYSYMBOL_tokenDot = 367,                 /* tokenDot  */
  YYSYMBOL_sortToken = 368,                /* sortToken  */
  YYSYMBOL_token = 369,                    /* token  */
  YYSYMBOL_stratName = 370,                /* stratName  */
  YYSYMBOL_attributeName = 371,            /* attributeName  */
  YYSYMBOL_tokenBarColon = 372,            /* tokenBarColon  */
  YYSYMBOL_tokenBarDot = 373,              /* tokenBarDot  */
  YYSYMBOL_endsInDot = 374,                /* endsInDot  */
  YYSYMBOL_command = 375,                  /* command  */
  YYSYMBOL_376_79 = 376,                   /* $@79  */
  YYSYMBOL_377_80 = 377,                   /* $@80  */
  YYSYMBOL_378_81 = 378,                   /* $@81  */
  YYSYMBOL_379_82 = 379,                   /* $@82  */
  YYSYMBOL_380_83 = 380,                   /* $@83  */
  YYSYMBOL_381_84 = 381,                   /* $@84  */
  YYSYMBOL_382_85 = 382,                   /* $@85  */
  YYSYMBOL_383_86 = 383,                   /* $@86  */
  YYSYMBOL_384_87 = 384,                   /* $@87  */
  YYSYMBOL_385_88 = 385,                   /* $@88  */
  YYSYMBOL_386_89 = 386,                   /* $@89  */
  YYSYMBOL_387_90 = 387,                   /* $@90  */
  YYSYMBOL_388_91 = 388,                   /* $@91  */
  YYSYMBOL_389_92 = 389,                   /* $@92  */
  YYSYMBOL_390_93 = 390,                   /* $@93  */
  YYSYMBOL_391_94 = 391,                   /* $@94  */
  YYSYMBOL_392_95 = 392,                   /* $@95  */
  YYSYMBOL_393_96 = 393,                   /* $@96  */
  YYSYMBOL_394_97 = 394,                   /* $@97  */
  YYSYMBOL_395_98 = 395,                   /* $@98  */
  YYSYMBOL_396_99 = 396,                   /* $@99  */
  YYSYMBOL_397_100 = 397,                  /* $@100  */
  YYSYMBOL_398_101 = 398,                  /* $@101  */
  YYSYMBOL_399_102 = 399,                  /* $@102  */
  YYSYMBOL_400_103 = 400,                  /* $@103  */
  YYSYMBOL_401_104 = 401,                  /* $@104  */
  YYSYMBOL_402_105 = 402,                  /* $@105  */
  YYSYMBOL_403_106 = 403,                  /* $@106  */
  YYSYMBOL_404_107 = 404,                  /* $@107  */
  YYSYMBOL_405_108 = 405,                  /* $@108  */
  YYSYMBOL_406_109 = 406,                  /* $@109  */
  YYSYMBOL_407_110 = 407,                  /* $@110  */
  YYSYMBOL_408_111 = 408,                  /* $@111  */
  YYSYMBOL_409_112 = 409,                  /* $@112  */
  YYSYMBOL_410_113 = 410,                  /* $@113  */
  YYSYMBOL_411_114 = 411,                  /* $@114  */
  YYSYMBOL_412_115 = 412,                  /* $@115  */
  YYSYMBOL_413_116 = 413,                  /* $@116  */
  YYSYMBOL_414_117 = 414,                  /* $@117  */
  YYSYMBOL_415_118 = 415,                  /* $@118  */
  YYSYMBOL_416_119 = 416,                  /* $@119  */
  YYSYMBOL_417_120 = 417,                  /* $@120  */
  YYSYMBOL_418_121 = 418,                  /* $@121  */
  YYSYMBOL_419_122 = 419,                  /* $@122  */
  YYSYMBOL_420_123 = 420,                  /* $@123  */
  YYSYMBOL_421_124 = 421,                  /* $@124  */
  YYSYMBOL_422_125 = 422,                  /* $@125  */
  YYSYMBOL_423_126 = 423,                  /* $@126  */
  YYSYMBOL_424_127 = 424,                  /* $@127  */
  YYSYMBOL_printOption = 425,              /* printOption  */
  YYSYMBOL_traceOption = 426,              /* traceOption  */
  YYSYMBOL_polarity = 427,                 /* polarity  */
  YYSYMBOL_select = 428,                   /* select  */
  YYSYMBOL_exclude = 429,                  /* exclude  */
  YYSYMBOL_conceal = 430,                  /* conceal  */
  YYSYMBOL_search = 431,                   /* search  */
  YYSYMBOL_match = 432,                    /* match  */
  YYSYMBOL_optDebug = 433,                 /* optDebug  */
  YYSYMBOL_optIrredundant = 434,           /* optIrredundant  */
  YYSYMBOL_optNumber = 435,                /* optNumber  */
  YYSYMBOL_optOptions = 436,               /* optOptions  */
  YYSYMBOL_optionsList = 437,              /* optionsList  */
  YYSYMBOL_option = 438,                   /* option  */
  YYSYMBOL_importMode = 439,               /* importMode  */
  YYSYMBOL_moduleAndTerm = 440,            /* moduleAndTerm  */
  YYSYMBOL_441_128 = 441,                  /* $@128  */
  YYSYMBOL_inEnd = 442,                    /* inEnd  */
  YYSYMBOL_443_129 = 443,                  /* $@129  */
  YYSYMBOL_numberModuleTerm = 444,         /* numberModuleTerm  */
  YYSYMBOL_445_130 = 445,                  /* $@130  */
  YYSYMBOL_446_131 = 446,                  /* $@131  */
  YYSYMBOL_numberModuleTerm1 = 447,        /* numberModuleTerm1  */
  YYSYMBOL_448_132 = 448,                  /* $@132  */
  YYSYMBOL_449_133 = 449,                  /* $@133  */
  YYSYMBOL_numberModuleTerm2 = 450,        /* numberModuleTerm2  */
  YYSYMBOL_451_134 = 451,                  /* $@134  */
  YYSYMBOL_452_135 = 452,                  /* $@135  */
  YYSYMBOL_optionsNumbersModuleTerm = 453, /* optionsNumbersModuleTerm  */
  YYSYMBOL_454_136 = 454,                  /* $@136  */
  YYSYMBOL_455_137 = 455,                  /* $@137  */
  YYSYMBOL_456_138 = 456,                  /* $@138  */
  YYSYMBOL_optionsNumbersModuleTerm1 = 457, /* optionsNumbersModuleTerm1  */
  YYSYMBOL_458_139 = 458,                  /* $@139  */
  YYSYMBOL_459_140 = 459,                  /* $@140  */
  YYSYMBOL_460_141 = 460,                  /* $@141  */
  YYSYMBOL_optionsNumbersModuleTerm2 = 461, /* optionsNumbersModuleTerm2  */
  YYSYMBOL_462_142 = 462,                  /* $@142  */
  YYSYMBOL_463_143 = 463,                  /* $@143  */
  YYSYMBOL_numbersModuleTerm = 464,        /* numbersModuleTerm  */
  YYSYMBOL_465_144 = 465,                  /* $@144  */
  YYSYMBOL_466_145 = 466,                  /* $@145  */
  YYSYMBOL_numbersModuleTerm1 = 467,       /* numbersModuleTerm1  */
  YYSYMBOL_468_146 = 468,                  /* $@146  */
  YYSYMBOL_469_147 = 469,                  /* $@147  */
  YYSYMBOL_470_148 = 470,                  /* $@148  */
  YYSYMBOL_numbersModuleTerm2 = 471,       /* numbersModuleTerm2  */
  YYSYMBOL_472_149 = 472,                  /* $@149  */
  YYSYMBOL_473_150 = 473,                  /* $@150  */
  YYSYMBOL_474_151 = 474,                  /* $@151  */
  YYSYMBOL_numbersModuleTerm3 = 475,       /* numbersModuleTerm3  */
  YYSYMBOL_476_152 = 476,                  /* $@152  */
  YYSYMBOL_477_153 = 477,                  /* $@153  */
  YYSYMBOL_numbersModuleTerm4 = 478,       /* numbersModuleTerm4  */
  YYSYMBOL_479_154 = 479,                  /* $@154  */
  YYSYMBOL_480_155 = 480,                  /* $@155  */
  YYSYMBOL_numbersModuleTerm5 = 481,       /* numbersModuleTerm5  */
  YYSYMBOL_482_156 = 482,                  /* $@156  */
  YYSYMBOL_483_157 = 483,                  /* $@157  */
  YYSYMBOL_numbersModuleTerm6 = 484,       /* numbersModuleTerm6  */
  YYSYMBOL_485_158 = 485,                  /* $@158  */
  YYSYMBOL_486_159 = 486,                  /* $@159  */
  YYSYMBOL_miscEndBubble = 487,            /* miscEndBubble  */
  YYSYMBOL_488_160 = 488,                  /* $@160  */
  YYSYMBOL_initialEndBubble = 489,         /* initialEndBubble  */
  YYSYMBOL_490_161 = 490,                  /* $@161  */
  YYSYMBOL_491_162 = 491,                  /* $@162  */
  YYSYMBOL_cTokenBarIn = 492,              /* cTokenBarIn  */
  YYSYMBOL_cTokenBarLeftIn = 493,          /* cTokenBarLeftIn  */
  YYSYMBOL_cTokenBarOpenLeftIn = 494,      /* cTokenBarOpenLeftIn  */
  YYSYMBOL_cTokenBarDotNumber = 495,       /* cTokenBarDotNumber  */
  YYSYMBOL_cTokenBarDotRight = 496,        /* cTokenBarDotRight  */
  YYSYMBOL_cTokenBarDotCommaNumber = 497,  /* cTokenBarDotCommaNumber  */
  YYSYMBOL_cTokenBarDotCommaRight = 498,   /* cTokenBarDotCommaRight  */
  YYSYMBOL_cTokenBarDotCommaClose = 499,   /* cTokenBarDotCommaClose  */
  YYSYMBOL_cTokenBarDotOptionToken = 500,  /* cTokenBarDotOptionToken  */
  YYSYMBOL_opSelect = 501,                 /* opSelect  */
  YYSYMBOL_endSelect = 502,                /* endSelect  */
  YYSYMBOL_badSelect = 503,                /* badSelect  */
  YYSYMBOL_cOpNameList = 504,              /* cOpNameList  */
  YYSYMBOL_cSimpleOpName = 505,            /* cSimpleOpName  */
  YYSYMBOL_cSimpleTokenBarDot = 506,       /* cSimpleTokenBarDot  */
  YYSYMBOL_cOptionToken = 507              /* cOptionToken  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 123 "surface.yy"

int yylex(YYSTYPE* lvalp);

#line 693 "surface.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  124
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3476

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  202
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  306
/* YYNRULES -- Number of rules.  */
#define YYNRULES  820
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1213

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   441


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     150,   151,   163,   162,   156,     2,   152,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   148,     2,
     153,   149,     2,     2,   158,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   154,     2,   155,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   164,   157,   165,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   159,   160,   161,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   266,   266,   267,   272,   281,   292,   293,   294,   295,
     296,   308,   308,   318,   318,   328,   328,   338,   342,   342,
     353,   353,   364,   375,   375,   380,   380,   385,   390,   423,
     427,   431,   432,   433,   434,   445,   449,   455,   456,   462,
     463,   466,   467,   468,   475,   482,   489,   498,   503,   509,
     514,   526,   531,   525,   537,   538,   541,   542,   545,   549,
     553,   554,   553,   556,   556,   559,   564,   563,   572,   576,
     571,   588,   588,   590,   593,   597,   600,   601,   607,   607,
     609,   612,   613,   616,   617,   617,   619,   619,   621,   621,
     628,   630,   628,   650,   651,   654,   659,   662,   666,   668,
     667,   672,   673,   678,   677,   686,   685,   690,   691,   698,
     707,   708,   712,   720,   711,   729,   728,   761,   769,   760,
     779,   778,   811,   816,   816,   830,   829,   838,   837,   865,
     866,   869,   869,   876,   878,   876,   891,   892,   895,   896,
     899,   900,   903,   909,   910,   918,   927,   928,   931,   932,
     935,   946,   946,   949,   949,   952,   953,   952,   956,   958,
     960,   961,   960,   964,   965,   966,   964,   969,   970,   969,
     973,   974,   975,   973,   978,   979,   978,   982,   983,   984,
     982,   987,   988,   987,   991,   992,   993,   991,   996,   996,
    1002,  1003,  1002,  1008,  1013,  1015,  1015,  1018,  1027,  1034,
    1044,  1043,  1050,  1056,  1057,  1060,  1064,  1070,  1071,  1074,
    1078,  1084,  1085,  1088,  1089,  1092,  1093,  1096,  1097,  1098,
    1105,  1105,  1107,  1108,  1111,  1114,  1116,  1122,  1123,  1126,
    1132,  1138,  1141,  1142,  1147,  1154,  1161,  1162,  1165,  1166,
    1169,  1170,  1173,  1178,  1184,  1189,  1194,  1200,  1200,  1204,
    1209,  1209,  1216,  1217,  1220,  1221,  1224,  1225,  1228,  1232,
    1236,  1242,  1246,  1250,  1250,  1252,  1256,  1260,  1261,  1261,
    1263,  1263,  1265,  1265,  1267,  1267,  1269,  1269,  1271,  1275,
    1279,  1284,  1284,  1286,  1290,  1294,  1298,  1302,  1302,  1304,
    1305,  1309,  1319,  1320,  1323,  1324,  1327,  1328,  1331,  1332,
    1333,  1334,  1340,  1342,  1348,  1350,  1358,  1359,  1363,  1364,
    1370,  1371,  1374,  1380,  1392,  1393,  1393,  1397,  1397,  1399,
    1402,  1434,  1436,  1436,  1436,  1436,  1436,  1436,  1437,  1437,
    1438,  1438,  1438,  1438,  1438,  1439,  1439,  1439,  1439,  1439,
    1439,  1440,  1440,  1441,  1441,  1443,  1443,  1443,  1443,  1443,
    1445,  1445,  1445,  1445,  1445,  1445,  1446,  1446,  1446,  1446,
    1446,  1446,  1447,  1447,  1447,  1447,  1448,  1448,  1448,  1448,
    1449,  1449,  1449,  1449,  1451,  1451,  1451,  1451,  1451,  1457,
    1457,  1457,  1458,  1458,  1458,  1458,  1458,  1458,  1458,  1458,
    1458,  1459,  1459,  1459,  1459,  1467,  1467,  1467,  1468,  1468,
    1468,  1468,  1468,  1468,  1468,  1469,  1469,  1469,  1469,  1477,
    1477,  1477,  1478,  1478,  1478,  1478,  1479,  1479,  1479,  1479,
    1487,  1487,  1487,  1488,  1488,  1488,  1488,  1488,  1488,  1488,
    1488,  1489,  1489,  1489,  1489,  1498,  1498,  1499,  1499,  1499,
    1499,  1499,  1499,  1499,  1499,  1500,  1500,  1500,  1500,  1503,
    1503,  1530,  1530,  1535,  1535,  1542,  1541,  1554,  1553,  1566,
    1565,  1578,  1577,  1590,  1589,  1602,  1601,  1615,  1614,  1628,
    1627,  1640,  1639,  1653,  1652,  1665,  1664,  1678,  1677,  1695,
    1694,  1707,  1706,  1719,  1718,  1731,  1730,  1743,  1742,  1756,
    1755,  1767,  1772,  1771,  1788,  1787,  1798,  1804,  1804,  1810,
    1810,  1816,  1816,  1822,  1822,  1828,  1828,  1837,  1837,  1843,
    1843,  1849,  1849,  1855,  1855,  1861,  1861,  1867,  1867,  1873,
    1877,  1881,  1881,  1887,  1887,  1893,  1893,  1899,  1899,  1905,
    1905,  1911,  1911,  1917,  1917,  1923,  1923,  1929,  1929,  1935,
    1935,  1941,  1945,  1949,  1953,  1957,  1957,  1966,  1970,  1974,
    1978,  1982,  1986,  1990,  1994,  1998,  2002,  2006,  2010,  2014,
    2018,  2019,  2018,  2024,  2025,  2024,  2030,  2034,  2038,  2042,
    2046,  2050,  2057,  2061,  2065,  2069,  2073,  2080,  2084,  2091,
    2091,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,
    2107,  2108,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,
    2119,  2120,  2121,  2122,  2125,  2126,  2129,  2130,  2133,  2134,
    2137,  2138,  2143,  2144,  2145,  2146,  2147,  2150,  2151,  2154,
    2155,  2158,  2159,  2162,  2163,  2166,  2167,  2170,  2171,  2174,
    2177,  2178,  2179,  2180,  2189,  2190,  2190,  2194,  2194,  2196,
    2206,  2206,  2208,  2209,  2209,  2214,  2214,  2216,  2216,  2218,
    2222,  2222,  2224,  2224,  2226,  2240,  2240,  2242,  2242,  2244,
    2245,  2245,  2251,  2250,  2257,  2256,  2262,  2262,  2264,  2268,
    2270,  2270,  2272,  2272,  2274,  2281,  2281,  2283,  2284,  2284,
    2293,  2293,  2295,  2295,  2297,  2297,  2299,  2307,  2307,  2309,
    2309,  2311,  2311,  2313,  2321,  2321,  2323,  2323,  2325,  2334,
    2333,  2340,  2340,  2342,  2350,  2350,  2352,  2352,  2354,  2362,
    2362,  2364,  2364,  2366,  2369,  2369,  2371,  2380,  2380,  2382,
    2382,  2384,  2395,  2395,  2395,  2395,  2395,  2395,  2395,  2395,
    2395,  2395,  2398,  2398,  2398,  2398,  2398,  2398,  2398,  2398,
    2398,  2402,  2402,  2402,  2402,  2402,  2402,  2402,  2402,  2406,
    2406,  2406,  2406,  2406,  2406,  2406,  2406,  2406,  2410,  2410,
    2410,  2410,  2410,  2410,  2410,  2410,  2410,  2414,  2414,  2414,
    2414,  2414,  2414,  2414,  2414,  2418,  2418,  2418,  2418,  2418,
    2418,  2418,  2418,  2422,  2422,  2422,  2422,  2422,  2422,  2422,
    2422,  2426,  2426,  2426,  2426,  2426,  2426,  2426,  2426,  2426,
    2432,  2433,  2436,  2437,  2440,  2447,  2448,  2451,  2456,  2463,
    2463,  2463,  2463,  2463,  2463,  2463,  2463,  2463,  2463,  2466,
    2467
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "FILE_NAME_STRING",
  "UNINTERPRETED_STRING", "LATEX_STRING", "KW_MOD", "KW_VIEW", "KW_PARSE",
  "KW_NORMALIZE", "KW_REDUCE", "KW_REWRITE", "KW_OO", "KW_LOOP",
  "KW_NARROW", "KW_XG_NARROW", "KW_MATCH", "KW_XMATCH", "KW_UNIFY",
  "KW_CHECK", "KW_GET", "KW_VARIANTS", "KW_VARIANT", "KW_EREWRITE",
  "KW_FREWRITE", "KW_SREWRITE", "KW_DSREWRITE", "KW_CONTINUE", "KW_SEARCH",
  "KW_SET", "KW_SHOW", "KW_ON", "KW_OFF", "KW_TRACE", "KW_BODY",
  "KW_BUILTIN", "KW_WHOLE", "KW_SELECT", "KW_DESELECT", "KW_CONDITION",
  "KW_SUBSTITUTION", "KW_PRINT", "KW_GRAPH", "KW_MIXFIX", "KW_FLAT",
  "KW_ATTRIBUTE", "KW_NEWLINE", "KW_WITH", "KW_PARENS", "KW_ALIASES",
  "KW_GC", "KW_TIME", "KW_STATS", "KW_TIMING", "KW_CMD", "KW_BREAKDOWN",
  "KW_BREAK", "KW_PATH", "KW_STATE", "KW_CONST", "KW_MODULE", "KW_MODULES",
  "KW_VIEWS", "KW_ALL", "KW_SORTS", "KW_OPS2", "KW_VARS", "KW_MBS",
  "KW_EQS", "KW_RLS", "KW_STRATS", "KW_SDS", "KW_SUMMARY", "KW_KINDS",
  "KW_ADVISE", "KW_VERBOSE", "KW_DO", "KW_CLEAR", "KW_PROTECT",
  "KW_EXTEND", "KW_GENERATE_BY", "KW_INCLUDE", "KW_EXCLUDE", "KW_CONCEAL",
  "KW_REVEAL", "KW_COMPILE", "KW_COUNT", "KW_DEBUG", "KW_IRREDUNDANT",
  "KW_FILTERED", "KW_RESUME", "KW_ABORT", "KW_STEP", "KW_WHERE",
  "KW_CREDUCE", "KW_SREDUCE", "KW_DUMP", "KW_PROFILE", "KW_NUMBER",
  "KW_RAT", "KW_COLOR", "KW_IMPLIED_STEP", "SIMPLE_NUMBER", "KW_PWD",
  "KW_CD", "KW_PUSHD", "KW_POPD", "KW_LS", "KW_LL", "KW_LOAD", "KW_SLOAD",
  "KW_QUIT", "KW_EOF", "KW_TEST", "KW_SMT_SEARCH", "KW_VU_NARROW",
  "KW_FVU_NARROW", "KW_FOLD", "KW_DESUGARED", "KW_PROCESSED", "KW_ENDM",
  "KW_IMPORT", "KW_ENDV", "KW_SORT", "KW_SUBSORT", "KW_OP", "KW_OPS",
  "KW_MSGS", "KW_VAR", "KW_CLASS", "KW_SUBCLASS", "KW_DSTRAT", "KW_MB",
  "KW_CMB", "KW_EQ", "KW_CEQ", "KW_RL", "KW_CRL", "KW_SD", "KW_CSD",
  "KW_ATTR", "KW_IS", "KW_FROM", "KW_ARROW", "KW_ARROW2", "KW_PARTIAL",
  "KW_IF", "KW_ASSIGN", "':'", "'='", "'('", "')'", "'.'", "'<'", "'['",
  "']'", "','", "'|'", "'@'", "KW_LABEL", "KW_TO", "KW_COLON2", "'+'",
  "'*'", "'{'", "'}'", "KW_ASSOC", "KW_COMM", "KW_ID", "KW_IDEM",
  "KW_ITER", "KW_PCONST", "KW_LEFT", "KW_RIGHT", "KW_PREC", "KW_GATHER",
  "KW_METADATA", "KW_STRAT", "KW_ASTRAT", "KW_POLY", "KW_MEMO",
  "KW_FROZEN", "KW_CTOR", "KW_LATEX", "KW_SPECIAL", "KW_CONFIG", "KW_OBJ",
  "KW_MSG", "KW_DITTO", "KW_FORMAT", "KW_ID_HOOK", "KW_OP_HOOK",
  "KW_TERM_HOOK", "KW_IN", "KW_FILTER", "KW_DELAY", "IDENTIFIER",
  "NUMERIC_ID", "ENDS_IN_DOT", "FORCE_LOOKAHEAD", "CHANGE_FILE",
  "END_OF_INPUT", "$accept", "top", "item", "directive", "$@1", "$@2",
  "$@3", "$@4", "$@5", "$@6", "$@7", "moduleExprDot", "moduleExpr",
  "moduleExpr2", "moduleExpr3", "renameExpr", "instantExpr", "parenExpr",
  "viewExpr", "instantArgs", "renaming", "$@8", "$@9", "renaming2",
  "mappingList", "mapping", "$@10", "$@11", "$@12", "$@13", "$@14", "$@15",
  "fromSpec", "$@16", "fromAttrSpec", "fromStratSpec", "toAttributes",
  "$@17", "toAttributeList", "toAttribute", "$@18", "$@19", "$@20", "view",
  "$@21", "$@22", "viewDecList", "skipStrayArrow", "viewDeclaration",
  "$@23", "$@24", "$@25", "sortDot", "viewEndOpMap", "$@26", "$@27",
  "$@28", "endMsgMap", "$@29", "$@30", "$@31", "strategyCall", "$@32",
  "viewStratMap", "$@33", "$@34", "endBubble", "parenBubble", "$@35",
  "module", "$@36", "$@37", "dot", "parameters", "parameterList",
  "parameter", "colon2", "badType", "typeDot", "decList", "declaration",
  "$@38", "$@39", "$@40", "$@41", "$@42", "$@43", "$@44", "$@45", "$@46",
  "$@47", "$@48", "$@49", "$@50", "$@51", "$@52", "$@53", "$@54", "$@55",
  "$@56", "$@57", "$@58", "$@59", "$@60", "$@61", "$@62", "$@63", "$@64",
  "$@65", "classDecl", "$@66", "classDef", "finalPair", "cPairList",
  "cPair", "varNameList", "opNameList", "simpleOpName", "domainRangeAttr",
  "stratDeclKeyword", "stratIdList", "stratId", "stratSignature",
  "stratAttributes", "stratAttrList", "skipStrayColon", "dra2",
  "rangeAttr", "typeAttr", "arrow", "typeList", "typeName1",
  "typeName1Dot", "kind", "$@67", "typeName", "$@68", "sortNames",
  "attributes", "attributeList", "idKeyword", "attribute", "$@69", "$@70",
  "$@71", "$@72", "$@73", "$@74", "$@75", "$@76", "identity", "idList",
  "hookList", "hook", "expectedIs", "expectedDot", "sortNameList",
  "endSortNameList", "subsortList", "endSubsortList", "sortName",
  "sortNameFrag", "$@77", "sortNameFrags", "$@78", "tokenDot", "sortToken",
  "token", "stratName", "attributeName", "tokenBarColon", "tokenBarDot",
  "endsInDot", "command", "$@79", "$@80", "$@81", "$@82", "$@83", "$@84",
  "$@85", "$@86", "$@87", "$@88", "$@89", "$@90", "$@91", "$@92", "$@93",
  "$@94", "$@95", "$@96", "$@97", "$@98", "$@99", "$@100", "$@101",
  "$@102", "$@103", "$@104", "$@105", "$@106", "$@107", "$@108", "$@109",
  "$@110", "$@111", "$@112", "$@113", "$@114", "$@115", "$@116", "$@117",
  "$@118", "$@119", "$@120", "$@121", "$@122", "$@123", "$@124", "$@125",
  "$@126", "$@127", "printOption", "traceOption", "polarity", "select",
  "exclude", "conceal", "search", "match", "optDebug", "optIrredundant",
  "optNumber", "optOptions", "optionsList", "option", "importMode",
  "moduleAndTerm", "$@128", "inEnd", "$@129", "numberModuleTerm", "$@130",
  "$@131", "numberModuleTerm1", "$@132", "$@133", "numberModuleTerm2",
  "$@134", "$@135", "optionsNumbersModuleTerm", "$@136", "$@137", "$@138",
  "optionsNumbersModuleTerm1", "$@139", "$@140", "$@141",
  "optionsNumbersModuleTerm2", "$@142", "$@143", "numbersModuleTerm",
  "$@144", "$@145", "numbersModuleTerm1", "$@146", "$@147", "$@148",
  "numbersModuleTerm2", "$@149", "$@150", "$@151", "numbersModuleTerm3",
  "$@152", "$@153", "numbersModuleTerm4", "$@154", "$@155",
  "numbersModuleTerm5", "$@156", "$@157", "numbersModuleTerm6", "$@158",
  "$@159", "miscEndBubble", "$@160", "initialEndBubble", "$@161", "$@162",
  "cTokenBarIn", "cTokenBarLeftIn", "cTokenBarOpenLeftIn",
  "cTokenBarDotNumber", "cTokenBarDotRight", "cTokenBarDotCommaNumber",
  "cTokenBarDotCommaRight", "cTokenBarDotCommaClose",
  "cTokenBarDotOptionToken", "opSelect", "endSelect", "badSelect",
  "cOpNameList", "cSimpleOpName", "cSimpleTokenBarDot", "cOptionToken", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1068)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-623)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1018,    47, -1068, -1068, -1068, -1068, -1068, -1068, -1068,   578,
     636,    37, -1068,   278,   317,    18, -1068, -1068,   -93,   -87,
     -43,   -32, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068,   148, -1068, -1068, -1068, -1068, -1068, -1068, -1068,   558,
     137, -1068, -1068,    38,  1416,  1416,   587,   587,   587,   129,
      97,   408,     4,   193,   367,   367,   367,   -44, -1068, -1068,
   -1068, -1068,   175,   367, -1068, -1068, -1068,   225,   -25, -1068,
     122,   128, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068,   288, -1068, -1068, -1068, -1068,
   -1068, -1068,   -90, -1068, -1068, -1068, -1068,   161, -1068, -1068,
   -1068, -1068,   587,   587,   -90,   306,   322,   343,   354,   362,
     370,   587,   228,   390, -1068,   649, -1068, -1068, -1068, -1068,
     320,   145, -1068, -1068, -1068, -1068,   325, -1068,   384, -1068,
   -1068,   303, -1068,   331, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068,   350,   367,   367,   367,   367,   367,   367,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068,   367, -1068, -1068, -1068,   134,   388,   411, -1068, -1068,
   -1068, -1068, -1068,   367,   367, -1068, -1068,   319,   321,   326,
     367,   367,   367,   367,   332,  1008,   -90,   -90,   333,   372,
     341,   393,   -90, -1068, -1068,   -90,   -90,   -90,   -90,   -90,
     -90,   -90,   -90,   -90,   -90,   -90,   -90,   -90, -1068,  3254,
    3254, -1068, -1068, -1068, -1068,  3254,  3254, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068,   587,   649,   448, -1068, -1068,   672,   672,
     649,   649, -1068,   344,   480, -1068,   -76, -1068,   672, -1068,
     649,   335,   335,   -90,   -82,   -90,  1008,   367,   367,   348,
     349,   353,   355,   356,   357,   358,   367,   359, -1068, -1068,
     438,   364,   366, -1068, -1068, -1068,   368,   373,   374,   375,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068,   376, -1068,   377, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068,   -90, -1068, -1068, -1068, -1068,   734, -1068, -1068,
   -1068, -1068, -1068,   -90,   752,   -90, -1068, -1068, -1068,   649,
     649, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
     303, -1068, -1068,   770, -1068,  1416,   365,   380, -1068, -1068,
   -1068, -1068, -1068, -1068,   381,   382, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068,   383, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068,   367, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068,   649, -1068, -1068,
     990,   -90,   649, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068,    23, -1068,    -3,
   -1068, -1068,  1100,   -90,   367, -1068, -1068, -1068,   385,   -90,
    3110,   -90, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,   990,  3128,
     -90,  1416, -1068, -1068, -1068,  1100,   422,  1100,   229,   351,
     360, -1068, -1068, -1068, -1068, -1068,   386, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068,  3146,  3164,   -90, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068,   378,  -109, -1068,  1179, -1068, -1068, -1068,
    1495,  1495,  1811,  2601, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,   -78,  1100,
    1100,   389,  1416, -1068,   587,   -90, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068,  3182,  3182,   -90, -1068, -1068, -1068,
     189,   205,   208,   220,    92,   224,   233,   250,   271,   290,
     293,   298,   301,   304,   114, -1068,   379,   107,   135,   186,
   -1068,   318,   410,   412,  2601,  3065,   415, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068,  1258, -1068, -1068, -1068,  1337,  1574, -1068, -1068,
   -1068,   407, -1068, -1068,  3065,   429,   431,   387,   439,   443,
     445,   444,   450,   447,  1890, -1068,     2, -1068, -1068, -1068,
     434,   146, -1068, -1068, -1068,  3200,   -90,   587,  3218,   -90,
   -1068, -1068, -1068, -1068, -1068,   672, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068,  1179, -1068, -1068, -1068, -1068,
   -1068, -1068,  2364, -1068, -1068, -1068,  2834,  2601, -1068, -1068,
    2048, -1068,  2048,   457, -1068,    35, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
    1653, -1068, -1068, -1068, -1068,   156,  1416,  1416, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
    3128, -1068,   -90, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
    2206, -1068,  2048, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
    2443, -1068, -1068, -1068, -1068,  2443, -1068, -1068, -1068,  3065,
     -90,   455,   -90,   456,   -90,   459,   -90,   460,  2048, -1068,
    2911, -1068,   449,   252, -1068,  3065, -1068,  3065,  1416,  1416,
    1890, -1068, -1068,   451, -1068,   158,   434,   587,   -90,  3236,
     -90, -1068, -1068, -1068, -1068,  3065, -1068, -1068,   458,  2127,
   -1068, -1068,   410,  1969,   407,   179, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068,  2757, -1068,   437,   -81,  -100,
   -1068,  3065, -1068,  1811,  3065,  1416,  1890, -1068, -1068,   454,
     462,   463, -1068,   464, -1068,   462,   465,   217, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068,   260, -1068,   811,   410,
   -1068, -1068, -1068,   163, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,   466, -1068,
    2285, -1068, -1068,   -90,   -90,   -90,   -90,  2911,   336,   470,
   -1068, -1068, -1068, -1068,   467,    -4,  1732,   469, -1068,   471,
   -1068,    59,    60,  3065, -1068,   472,  3065,   478,  1416,    83,
     475, -1068, -1068,   587,   -90, -1068,  3065, -1068, -1068, -1068,
   -1068, -1068, -1068,   468,   473,   419,   489,   453,   490,   494,
     496, -1068,   500, -1068,   501,   502, -1068, -1068, -1068, -1068,
     504,  3287, -1068, -1068, -1068, -1068, -1068,  2522, -1068, -1068,
   -1068,   116,   138, -1068,  3065, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068,  2601, -1068, -1068, -1068,   457,  2601,   478, -1068,
   -1068,    83, -1068, -1068, -1068, -1068, -1068, -1068, -1068,  2988,
     505, -1068,   507, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,   299, -1068,
   -1068, -1068,   461, -1068, -1068,  3065, -1068, -1068,   407, -1068,
     410, -1068, -1068,   -90,  2443, -1068,   508,   -90,   510,   509,
   -1068,   -90,  2680,   519, -1068, -1068, -1068,  1416,  1890,   519,
     481,   481,   481,   481,   481,   613,  1416,  1416,  1416,    -9,
   -1068,   481, -1068, -1068,   294, -1068,  2680, -1068, -1068,  1416,
   -1068, -1068,  1890,  2680, -1068,  2911, -1068, -1068, -1068, -1068,
   -1068, -1068,   -69,   -58,   -55,   -36,   -23,   511,   526,   526,
     526, -1068, -1068,   -19, -1068,  2911,   410,   527,  2911, -1068,
     130, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068,   518, -1068, -1068,   520,   485,   532,   533,   534,
     118, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
     -90,   -90,   481,   680,   481, -1068, -1068,   -18,   535,   -12,
   -1068, -1068, -1068
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,   579,   133,    90,   455,   494,   618,   617,   473,     0,
       0,     0,   451,     0,     0,     0,   619,   621,     0,     0,
       0,     0,   457,   459,   453,   575,    17,    18,    20,    22,
      23,    25,    13,    15,    27,    28,   492,   131,    11,    10,
       3,     0,     2,     8,     7,   496,     6,     9,   479,   626,
       0,     5,     4,     0,     0,     0,     0,     0,     0,     0,
       0,   592,     0,     0,     0,     0,     0,     0,   630,   631,
     632,   633,     0,     0,   560,   507,   515,     0,     0,   509,
       0,     0,   511,   521,   523,   525,   527,   529,   531,   533,
     535,   537,   539,   545,   513,     0,   606,   607,   609,   608,
     497,   499,     0,   610,   611,   503,   501,     0,   572,   573,
     574,   576,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     0,   461,   463,   612,   613,
     622,     0,   465,   467,   469,   471,   624,   614,     0,   615,
     616,     0,   475,     0,   481,   580,   343,   322,   344,   323,
     324,   325,   326,   334,   327,   330,   331,   329,   335,   336,
     337,   338,   339,   340,   341,   342,   332,   346,   347,   391,
     378,   392,   345,   394,   382,   374,   386,   384,   387,   388,
     385,   375,   383,   349,   348,   393,   376,   377,   389,   390,
     350,   351,   381,   352,   353,   373,   354,   355,   356,   357,
     365,   328,   358,   359,   360,   364,   361,   362,   363,   366,
     367,   333,   368,   369,   370,   371,   372,   321,   380,   379,
     134,    91,   729,   717,   730,   727,   728,   731,   725,   726,
     719,   819,   820,   723,   724,   721,   456,   634,   635,   722,
     495,   474,   563,     0,     0,     0,     0,     0,     0,     0,
     601,   602,   603,   594,   596,   593,   595,   597,   598,   599,
     600,     0,   585,   581,   582,     0,     0,     0,   586,   587,
     588,   589,   590,     0,     0,   604,   605,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   519,   520,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   517,     0,
       0,   129,   320,   452,   130,     0,     0,   505,   458,   460,
     454,    19,    21,    24,    26,    14,    16,   493,   132,    12,
     738,   739,   640,   737,   740,   735,   736,   733,   734,   480,
     642,   643,   732,     0,     0,     0,   487,   483,     0,     0,
       0,     0,   623,     0,     0,   629,     0,   627,     0,   477,
       0,   139,   139,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   584,   583,
       0,     0,     0,   578,   559,   566,     0,     0,     0,     0,
     570,   817,   814,   815,   818,   812,   813,   816,   810,   811,
     561,   809,   508,   516,   544,     0,   541,     0,   510,   512,
     522,   524,   526,   528,   530,   532,   534,   536,   538,   540,
     546,   514,     0,   804,   808,   498,   801,     0,   806,   807,
     500,   504,   502,     0,     0,     0,   462,   464,   489,     0,
       0,   675,   466,   677,   678,   468,   470,   472,   491,   485,
       0,   625,   476,     0,   482,     0,   303,     0,   718,   637,
     639,   720,   636,   564,     0,     0,   554,   548,   550,   553,
     551,   547,   558,     0,   556,   591,   555,   577,   568,   571,
     567,   569,     0,   542,   543,   518,   802,   800,   803,   805,
     506,   756,   714,   753,   754,   757,   751,   752,   755,   750,
     645,   716,   641,   649,   647,   749,   644,     0,   488,   484,
       0,     0,     0,   628,   746,   747,   657,   745,   748,   655,
     744,   742,   743,   478,   659,   660,   741,     0,   141,     0,
     302,   149,     0,     0,     0,   549,   552,   557,     0,     0,
       0,     0,   490,   774,   771,   772,   682,   769,   770,   773,
     768,   680,   676,   686,   684,   767,   679,   486,     0,     0,
       0,     0,   138,   144,   143,     0,     0,     0,     0,    37,
      39,    40,    42,    41,    43,   638,     0,   562,   715,   765,
     763,   650,   766,   761,   762,   764,   759,   760,   646,   654,
     652,   758,   648,     0,     0,     0,   658,   798,   795,   796,
     799,   793,   794,   797,   662,   664,   791,   792,   656,   668,
     666,   661,   140,   142,     0,   135,     0,   151,   153,   155,
       0,     0,     0,     0,   195,   221,   160,   163,   167,   170,
     174,   177,   181,   184,   220,   190,   148,   188,     0,     0,
       0,     0,     0,   565,     0,     0,   704,   683,   708,   706,
     782,   780,   687,   689,   778,   779,   781,   776,   777,   681,
     693,   691,   775,   685,     0,     0,     0,   197,   199,   198,
     445,   446,   448,   437,    36,   439,   441,   442,   440,   438,
     447,   443,   444,   436,   320,   150,     0,   305,   305,   305,
      35,   435,   305,     0,     0,     0,     0,   431,   432,   434,
     426,   424,   427,   428,   425,   423,   433,   429,   430,   422,
     421,   216,     0,   214,   420,   215,     0,     0,   212,   194,
     200,   313,   202,   314,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,   303,    38,    51,    44,
      50,     0,    48,   651,   653,     0,     0,     0,     0,     0,
     790,   787,   788,   670,   786,     0,   789,   784,   785,   663,
     674,   672,   783,   665,   667,     0,   304,    32,    33,    31,
      29,    30,     0,   152,   307,   308,     0,     0,   154,   156,
       0,   213,     0,    96,   211,   305,   315,   196,   161,   164,
     168,   171,   175,   178,   182,   185,   191,   405,   406,   408,
     400,   398,   401,   402,   399,   407,   403,   404,   397,   396,
       0,   223,   395,   224,    94,     0,     0,     0,    45,   709,
     705,   713,   711,   707,   688,   694,   690,   698,   696,   692,
       0,   669,     0,    34,    38,   136,   309,   306,   137,   311,
       0,   312,     0,   238,   239,   250,   145,   219,   158,   218,
       0,   241,   249,   193,    95,     0,   208,   201,   203,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   241,
       0,   222,   228,     0,    55,     0,    60,     0,     0,     0,
       0,    68,    52,    54,    57,     0,    49,     0,     0,     0,
       0,   671,   673,   310,   157,     0,   237,   235,   255,   231,
     147,   159,   305,     0,   319,     0,   162,   165,   169,   172,
     176,   179,   183,   186,   192,     0,   225,     0,     0,     0,
      92,     0,    99,     0,     0,     0,     0,   105,    93,     0,
      73,     0,    66,     0,    63,    73,     0,     0,    47,   710,
     712,   699,   695,   703,   701,   697,     0,   253,     0,   305,
     230,   233,   234,     0,   217,   240,   146,   416,   417,   419,
     412,   415,   414,   413,   418,   411,   410,   204,     0,   409,
       0,   317,   316,     0,     0,     0,     0,     0,     0,     0,
     189,   107,   109,   108,     0,     0,     0,     0,   103,     0,
     101,   125,     0,     0,    71,     0,     0,    75,     0,    77,
       0,    53,    56,     0,     0,   251,     0,   261,   262,   258,
     265,   266,   291,     0,     0,     0,     0,     0,     0,     0,
       0,   278,   280,   279,     0,     0,   283,   284,   285,   290,
       0,     0,   263,   257,   236,   232,   207,     0,   247,   210,
     206,   305,   305,   245,     0,   166,   173,   180,   187,   226,
     229,   227,     0,   112,   115,   100,    96,     0,    75,   127,
     123,     0,   117,   120,   106,    58,   241,    61,    65,     0,
       0,    59,     0,    76,    69,   700,   702,   252,   259,   260,
     267,   268,   286,   272,   274,   276,   281,   287,     0,   270,
     254,   256,   293,   209,   205,     0,   246,   244,   318,    97,
     305,   111,   241,     0,     0,   102,     0,     0,     0,     0,
     241,     0,     0,    80,    74,   243,   242,     0,     0,    80,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     297,     0,   292,   264,     0,   110,     0,   116,    98,     0,
     128,   124,     0,     0,   121,     0,    78,    62,    67,    64,
      70,   295,     0,     0,     0,     0,     0,     0,   298,     0,
       0,   289,   296,     0,   248,     0,   305,     0,     0,    72,
       0,   269,   294,   273,   275,   277,   282,   288,   299,   300,
     301,   271,     0,   104,   126,     0,     0,     0,     0,     0,
       0,    82,   113,   118,    83,    84,    88,    86,    79,    81,
       0,     0,     0,     0,     0,   114,   119,     0,     0,     0,
      85,    89,    87
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068,   -75,  -526, -1068, -1068,  -596,  -593,  -589,  -130,  -127,
   -1068, -1068, -1068, -1068, -1068,  -246, -1068, -1068, -1068, -1068,
   -1068, -1068,  -243, -1068,  -364, -1068,  -409, -1068, -1068,  -479,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068,  -343, -1068, -1068,
   -1068, -1068,  -342, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068,  -101,     0, -1068, -1068,
   -1068, -1068,  -204,   361, -1068,   164, -1068,  -818,  -387, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068,  -199,   105,  -392,  -737, -1068,
   -1068,   -83,  -949, -1068, -1068, -1068, -1068,  -225, -1068,  -990,
    -845,  -970,  -308,  -339, -1068,  -744, -1068,  -363, -1068, -1068,
   -1068,  -297, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1067, -1068,  -393,     8,  -678,  -654,   -39, -1068,    16,
    -565,  -855, -1068, -1068, -1068,  -540,   -46,   -38,  -858, -1068,
    -620, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068,   -31,   731, -1068, -1068, -1068,
   -1068, -1068,   616, -1068, -1068, -1068,   297, -1068,   -52, -1068,
   -1068, -1068,  -272, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068,   -80, -1068, -1068, -1068,    84,
   -1068, -1068,  -337, -1068, -1068,   190, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068, -1068,
   -1068, -1068, -1068, -1068, -1068,  -419, -1068,  -122, -1068, -1068,
   -1068,  -330, -1068,  -586,  -719, -1068, -1068, -1068, -1068,    12,
   -1068,   329, -1068,   330,  -241,   -27
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    41,    42,    43,   123,   119,   120,   115,   116,   117,
     118,   685,   568,   569,   570,   571,   572,   573,   740,   741,
     739,   815,   936,   882,   883,   884,   930,  1113,   999,   997,
     935,  1119,   995,  1066,  1070,  1072,  1147,  1170,  1190,  1191,
    1202,  1204,  1203,    44,    55,   362,   873,   855,   928,   985,
    1058,   992,  1099,  1055,  1102,  1200,  1103,  1064,  1110,  1201,
    1111,   989,  1108,   990,  1061,  1107,   501,   424,   122,    46,
      54,   361,   836,   456,   527,   528,   565,   847,   901,   566,
     636,   694,   695,   696,   842,   725,   860,   726,   861,   973,
     727,   862,   728,   863,   974,   729,   864,   730,   865,   975,
     731,   866,   732,   867,   976,   734,   733,   868,   724,   719,
     785,   857,   967,   903,   968,   717,   712,   713,   848,   637,
     810,   811,   872,   918,   979,   953,   954,   849,   897,   850,
     899,  1039,  1040,  1041,  1095,   955,   895,   946,   949,  1031,
    1032,  1033,  1092,  1120,  1131,  1121,  1122,  1123,  1124,  1125,
    1133,  1152,  1129,  1130,   531,   767,   776,   773,   777,   778,
     852,   721,   859,   905,  1044,   314,   723,   574,   813,   970,
     715,   692,   693,    47,   102,   114,    56,   112,   113,   343,
     344,   348,   349,   350,   351,    58,   358,   453,   125,   360,
     440,   512,   439,   507,   121,    57,   309,   310,   316,   315,
     433,   286,   292,   295,   307,   287,   422,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   285,   482,
     366,   534,    53,   273,   261,   277,   100,   101,   105,   142,
      48,    49,    50,   353,   143,   356,   357,    74,   236,   365,
     461,   533,   339,   434,   435,   502,   540,   541,   588,   644,
     645,   523,   559,   558,   560,   608,   664,   665,   666,   759,
     830,   832,   442,   510,   511,   552,   594,   593,   595,   659,
     747,   748,   749,   826,   889,   890,   942,  1003,  1004,   647,
     745,   746,   820,   887,   888,   553,   539,   237,   363,   364,
     238,   341,   525,   504,   590,   554,   661,   761,   610,   425,
     487,   426,   427,   428,   429,   342
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      45,   313,   718,   340,   904,   240,   241,   649,   219,   219,
     768,   769,   445,   320,   770,   503,   220,   221,   444,   444,
     687,   452,   934,   688,   915,   280,   822,   689,   444,   239,
     239,   239,   896,   289,   278,   279,   851,   900,   851,   613,
     772,   638,   284,   667,   400,   853,   262,   263,   264,   265,
    1073,   266,   981,   281,  1153,  1154,  1155,  1156,   720,   108,
     318,   319,   311,   267,  1163,   109,   459,  1093,   991,   327,
     311,   835,   437,   735,    96,    97,   690,   290,   446,   447,
     450,   952,  1171,   722,   640,   239,   239,   268,   454,   451,
     686,   668,   669,  1173,   239,   107,  1174,   784,   851,  1114,
     982,   983,   269,   270,   271,   894,   898,   858,   312,   110,
     243,   902,  1109,   736,   737,  1175,   312,   312,    98,    99,
     111,   589,  1145,   840,   851,   463,   916,  1172,  1176,   774,
     774,   914,  1181,  1210,   291,  1207,   282,  1209,  1172,  1212,
     609,  1172,  1161,   530,  1053,   563,  1165,   244,   124,   245,
     246,   247,   248,  1168,   775,   144,  1054,   874,   564,   774,
    1172,   346,   828,   347,   640,   275,   276,   508,   509,   687,
     944,   249,   688,  1172,   648,   660,   689,  1172,  1172,   561,
     376,  1126,  1127,  1128,  1172,   402,   403,   766,   562,  1098,
     145,   408,   856,   272,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   837,  1062,  1060,
     242,   837,   774,   369,   370,   371,   372,   373,   374,  -122,
    1063,  1112,   340,   274,   956,   690,   443,   443,   340,   340,
     375,   869,   838,  1049,   377,   542,   443,   775,   340,   834,
     557,   870,   381,   382,  -449,   760,   760,    51,    52,   386,
     387,   388,   389,   919,  -386,  -386,  -386,  1136,   401,   766,
    1149,   283,   458,   460,   462,  1143,  -450,   288,   766,   -40,
     -40,  1034,  -243,  1198,   293,   837,  -380,  -380,  -380,   875,
     294,   876,   401,   401,  1167,   877,   900,   766,   401,   401,
     766,   436,  1186,  1187,  -242,   308,   878,   -42,   -42,   -42,
     838,  1188,   817,   718,  1186,  1187,   843,  1189,   844,   321,
     929,   818,   931,  1188,   817,   879,   239,   340,   340,  1189,
     781,   485,   430,   938,   781,   322,   821,   431,   432,   827,
     947,   524,   490,   880,   506,   971,   464,   465,   766,   401,
     875,   317,   876,   881,   972,   473,   877,   323,   -41,   -41,
     -41,  -391,  -391,  -391,    96,    97,   984,   878,   324,   987,
     902,   103,   104,  1096,  1097,   325,   784,  -392,  -392,  -392,
    -394,  -394,  -394,   326,   920,   921,   879,   922,   838,   328,
     923,   924,  -382,  -382,  -382,   340,  -384,  -384,  -384,   639,
     340,   640,   925,   329,   880,  -387,  -387,  -387,   275,   276,
     401,  1169,   367,   368,   881,  1042,   354,   505,    17,   219,
     556,   609,  -388,  -388,  -388,  1005,  1006,   529,   831,   250,
     355,  1182,  1135,   614,  1185,   444,   526,   352,  1065,   926,
    1043,  1068,   575,  -385,  -385,  -385,   378,   379,   578,   927,
     592,  1077,   251,   252,   253,   254,   359,   255,   256,  1164,
    1006,   538,  -383,  -383,  -383,  -393,  -393,  -393,   380,   611,
    -389,  -389,  -389,  -390,  -390,  -390,  -381,  -381,  -381,   438,
     943,   383,  1042,   384,   405,   257,   258,   259,   385,   260,
    -379,  -379,  -379,   555,   390,   404,   219,  1100,  1183,  1126,
    1127,  1128,  1100,   406,   663,   407,   448,  1043,   449,   455,
     466,   467,   475,   576,  1116,   468,   530,   469,   470,   471,
     472,   474,  1101,   591,   641,   219,   476,  1101,   477,   219,
     478,   219,   532,   529,   642,   479,   480,   481,   483,   484,
     947,   555,  1050,   535,   536,   537,   790,   577,   643,   738,
     640,   765,   615,   616,   744,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   766,   779,   771,   764,   505,   662,   126,   127,
     691,   786,   128,   129,   714,   714,   714,   788,   130,   789,
     131,   132,   133,   134,   135,   136,   137,   792,   791,   793,
      59,   794,   743,   219,   219,   796,   219,   795,   816,   634,
     854,   907,   909,   917,   742,   911,   913,   937,    60,   635,
     994,    61,   948,   978,   993,  1080,  1001,   239,  1157,    62,
     711,   711,  1036,   996,   998,  1051,  1069,  1052,    63,  1057,
      64,  1059,  1067,   443,    65,  1074,  1078,   762,   762,  1081,
    1083,  1079,    75,    76,  1084,   823,  1085,   138,   829,  1082,
    1086,  1087,  1088,    66,  1089,    67,    68,    69,    70,    71,
    1132,  1141,  1177,    72,    77,  1117,   714,  1118,  1139,  1142,
     714,   714,   139,  1146,   140,    73,    37,  1151,  1192,  1184,
    1193,  1194,  1195,  1196,  1197,  1208,  1211,   886,   812,   885,
     833,  1002,  1000,    78,  1106,   824,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    1150,  1199,   711,  1104,   980,  1105,   711,  1138,   591,   691,
     239,   505,   141,   457,   986,   612,   716,   871,  1035,  1094,
    1115,   892,  1134,    93,  1091,   222,  1162,   223,   841,   224,
     787,   225,   226,   227,   814,   106,   345,   513,   596,   763,
     891,   228,   229,     0,    94,    95,   488,   489,     0,   906,
       0,   908,     0,   910,   812,   912,     0,     0,     0,     0,
     219,   219,     0,     0,     0,     0,     0,     0,   742,   742,
     230,   231,   232,   233,   234,   235,     0,   940,     0,   945,
       0,     0,     0,     0,     0,     0,     0,   330,     0,   223,
       0,   331,     0,   332,   333,   334,     0,     0,     0,     0,
       0,     0,     0,   335,   336,     0,     0,     0,     0,     0,
     330,     0,   223,     0,   331,     0,   441,   333,   334,     0,
       0,     0,   219,   219,   812,   939,   335,   336,     0,     0,
     932,   933,   230,   231,   232,   337,   338,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   969,     0,     0,
     239,     0,   591,     0,     0,   230,   231,   232,   337,   338,
     235,     0,  1045,  1046,  1047,  1048,     0,   714,     0,   219,
     812,     0,   391,     0,    37,     0,   486,   988,   392,   393,
     394,     0,     0,     0,     0,     0,     0,     0,   395,   396,
     491,     0,   492,  1076,   311,     0,   493,   494,   495,     0,
       0,     0,     0,     0,     0,     0,   496,   497,   514,     0,
     223,     0,   515,     0,   516,   517,   518,   397,   231,   232,
     398,   399,   423,     0,   519,   520,     0,     0,     0,     0,
     714,     0,     0,     0,     0,   498,   231,   232,   499,   500,
     312,  1075,   219,     0,     0,     0,     0,     0,     0,     0,
    1071,     0,     0,   230,   231,   232,   521,   522,   235,     0,
       0,     0,     0,     0,     0,     0,   239,  1007,  1008,  1009,
    1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,
    1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,     0,  1137,     0,     0,     0,  1140,     0,     0,     0,
    1144,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     2,     3,     4,     0,  -620,  -620,
       0,     5,  -620,  -620,     6,     7,  -622,     8,  -620,     0,
    -620,  -620,  -620,  -620,  -620,  -620,  -620,     9,    10,     0,
       0,    11,     0,     0,     0,    12,     0,     0,     0,    13,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   219,   812,     0,    14,     0,     0,     0,     0,  1148,
     219,   219,   219,     0,     0,     0,     0,     0,  1158,  1159,
    1160,     0,     0,   219,    15,     0,   812,     0,     0,  1205,
    1206,  1166,     0,     0,     0,    16,    17,  -620,    18,    19,
      20,    21,    22,    23,    24,     0,     0,     0,     0,    25,
       0,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,  -620,  -620,  -620,     0,     0,     0,   543,     0,
     492,     0,   311,     0,   544,   545,   546,     0,     0,     0,
       0,     0,     0,     0,   547,   548,   391,     0,  1178,  1179,
    1180,     0,   392,   393,   394,     0,     0,     0,    37,     0,
       0,     0,   395,   396,     0,     0,     0,     0,     0,     0,
       0,     0,  -620,   549,   231,   232,   550,   551,   312,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   397,   231,   232,   398,   399,     0,     0,     0,     0,
       0,    38,     0,     0,     0,     0,     0,     0,    39,    40,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     567,     0,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,     0,     0,     0,   217,     0,   218,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   670,   170,   671,   172,   672,   673,   175,   567,
       0,   674,   675,   676,   677,   678,   181,   679,   183,   184,
     680,   186,   187,   681,   682,   190,   191,   683,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,     0,     0,     0,   217,     0,   684,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   697,   170,   698,   172,   699,   780,   175,    37,     0,
     700,   701,   702,   703,   704,   181,   705,   183,   184,   706,
     186,   187,   707,   708,   190,   191,   709,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,     0,     0,     0,   217,     0,   710,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     697,   170,   698,   172,   699,   782,   175,    37,     0,   700,
     701,   702,   703,   704,   181,   705,   183,   184,   706,   186,
     187,   707,   708,   190,   191,   709,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
       0,     0,     0,   217,     0,   710,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,     0,     0,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,     0,
       0,     0,   217,     0,   218,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   697,   170,
     698,   172,   699,     0,   175,    37,     0,   700,   701,   702,
     703,   704,   181,   705,   183,   184,   706,   186,   187,   707,
     708,   190,   191,   709,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,     0,     0,
       0,   217,     0,   710,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   697,   170,   698,
     172,   699,   783,   175,     0,     0,   700,   701,   702,   703,
     704,   181,   705,   183,   184,   706,   186,   187,   707,   708,
     190,   191,   709,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,     0,     0,     0,
     217,     0,   710,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   797,   170,   798,   172,
     799,   869,   175,     0,     0,   800,   801,   802,   803,   804,
     181,   870,   183,   184,   805,   186,   187,   806,   807,   190,
     191,   808,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,     0,     0,     0,   217,
       0,   809,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   697,   170,   698,   172,   699,
    1056,   175,     0,     0,   700,   701,   702,   703,   704,   181,
     705,   183,   184,   706,   186,   187,   707,   708,   190,   191,
     709,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,     0,     0,     0,   217,     0,
     710,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   697,   170,   698,   172,   699,     0,
     175,     0,     0,   700,   701,   702,   703,   704,   181,   705,
     183,   184,   706,   186,   187,   707,   708,   190,   191,   709,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,     0,     0,     0,   217,     0,   710,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   797,   170,   798,   172,   799,     0,   175,
       0,     0,   800,   801,   802,   803,   804,   181,     0,   183,
     184,   805,   186,   187,   806,   807,   190,   191,   808,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,     0,     0,     0,   217,     0,   809,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   957,   170,   958,   172,   959,   960,   175,     0,
       0,   961,   962,     0,     0,     0,   181,   963,   183,   184,
     964,   186,   187,     0,     0,   190,   191,   965,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,     0,     0,     0,   217,     0,   966,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   843,   170,   844,   172,     0,     0,   175,     0,     0,
       0,     0,   845,     0,     0,   181,     0,   183,   184,     0,
     186,   187,     0,     0,   190,   191,     0,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,     0,     0,     0,   217,     0,   846,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   170,     0,   172,     0,   950,   175,     0,     0,   951,
       0,   845,     0,     0,   181,     0,   183,   184,     0,   186,
     187,     0,     0,   190,   191,     0,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
       0,     0,     0,   217,     0,   846,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,     0,
     170,     0,   172,     0,     0,   175,     0,     0,   835,   893,
       0,     0,     0,   181,     0,   183,   184,     0,   186,   187,
       0,     0,   190,   191,     0,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,     0,
       0,     0,   217,     0,   312,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,     0,   170,
       0,   172,     0,  1037,   175,     0,     0,     0,     0,  1038,
       0,     0,   181,     0,   183,   184,     0,   186,   187,     0,
       0,   190,   191,     0,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,     0,     0,
       0,   217,     0,   312,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,     0,   170,     0,
     172,     0,     0,   175,     0,     0,   835,     0,     0,     0,
       0,   181,     0,   183,   184,     0,   186,   187,     0,     0,
     190,   191,     0,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,     0,     0,     0,
     217,     0,   312,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,     0,   170,     0,   172,
       0,     0,   175,     0,     0,     0,     0,   845,     0,     0,
     181,     0,   183,   184,     0,   186,   187,     0,     0,   190,
     191,     0,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,     0,     0,     0,   217,
       0,   846,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,     0,   170,     0,   172,     0,
       0,   175,     0,     0,     0,     0,  1038,     0,     0,   181,
       0,   183,   184,     0,   186,   187,     0,     0,   190,   191,
       0,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,     0,     0,     0,   217,     0,
     312,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,     0,   170,     0,   172,     0,     0,
     175,     0,     0,     0,     0,     0,     0,     0,   181,     0,
     183,   184,     0,   186,   187,     0,     0,   190,   191,     0,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,     0,     0,     0,   217,     0,   312,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   843,   170,   844,   172,     0,     0,   175,
       0,     0,     0,     0,   845,     0,     0,   181,     0,   183,
     184,     0,   186,   187,     0,     0,   190,   191,     0,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,     0,     0,     0,   217,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
       0,   170,     0,   172,     0,     0,   175,     0,     0,     0,
       0,   845,     0,     0,   181,   977,   183,   184,     0,   186,
     187,     0,     0,   190,   191,     0,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
       0,     0,     0,   217,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,     0,   170,     0,
     172,     0,     0,   175,     0,     0,     0,   839,     0,     0,
       0,   181,     0,   183,   184,     0,   186,   187,     0,     0,
     190,   191,     0,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,     0,     0,     0,
     217,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,     0,   170,     0,   172,     0,     0,
     175,     0,     0,     0,     0,   845,     0,     0,   181,     0,
     183,   184,     0,   186,   187,     0,     0,   190,   191,     0,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,     0,     0,     0,   217,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,     0,   170,     0,   172,     0,     0,   175,     0,     0,
       0,     0,  1038,     0,     0,   181,     0,   183,   184,     0,
     186,   187,     0,     0,   190,   191,     0,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,     0,     0,     0,   217,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,     0,   170,
       0,   172,     0,     0,   175,     0,     0,     0,     0,     0,
       0,     0,   181,     0,   183,   184,     0,   186,   187,     0,
       0,   190,   191,     0,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   579,     0,
     492,   217,   311,     0,   580,   581,   582,     0,     0,     0,
       0,     0,     0,     0,   583,   584,   597,     0,   492,     0,
     311,     0,   598,   599,   600,     0,     0,     0,     0,     0,
       0,     0,   601,   602,   491,     0,   492,     0,   311,     0,
     493,   494,   495,   585,   231,   232,   586,   587,   312,     0,
     496,   497,   650,     0,   492,     0,   311,     0,   651,   652,
     653,   603,   604,   605,   606,   607,   312,     0,   654,   655,
     750,     0,   492,     0,   311,     0,   751,   752,   753,   498,
     231,   232,   499,   646,   312,     0,   754,   755,   579,     0,
     492,     0,   311,     0,   580,   819,   582,   656,   231,   232,
     657,   658,   312,     0,   583,   584,   491,     0,   492,     0,
     311,     0,   493,   494,   495,   756,   231,   232,   757,   758,
     312,     0,   496,   497,   579,     0,   492,     0,   311,     0,
     580,   941,   582,   585,   231,   232,   586,   587,   312,     0,
     583,   584,   391,     0,    37,     0,     0,     0,   392,   393,
     394,   498,   231,   232,   499,   825,   312,     0,   395,   396,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   585,
     231,   232,   586,   587,   312,     0,     0,     0,     0,     0,
       0,     0,  1090,     0,     0,     0,     0,   397,   231,   232,
     398,   399,   423,  1007,  1008,  1009,  1010,  1011,  1012,  1013,
    1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030
};

static const yytype_int16 yycheck[] =
{
       0,   102,   622,   125,   859,    57,    58,   593,    54,    55,
     688,   689,   349,   114,   692,   434,    54,    55,   348,   349,
     616,   358,   880,   616,   869,    69,   745,   616,   358,    56,
      57,    58,   850,    58,    65,    66,   780,   855,   782,   565,
     694,   567,    73,   152,   285,   782,    42,    43,    44,    45,
     999,    47,   152,    97,  1121,  1122,  1123,  1124,   623,   152,
     112,   113,   152,    59,  1131,   152,   148,  1037,   926,   121,
     152,   152,   344,   151,    37,    38,   616,   102,   350,   351,
     156,   899,   151,   623,   162,   112,   113,    83,   360,   165,
     616,   200,   201,   151,   121,    77,   151,   717,   842,  1069,
     200,   201,    98,    99,   100,   842,   850,   785,   198,   152,
      13,   855,  1061,   639,   640,   151,   198,   198,    81,    82,
     152,   540,  1112,   777,   868,   366,   870,   196,   151,   694,
     695,   868,   151,   151,   159,  1202,   180,  1204,   196,   151,
     559,   196,   151,   141,   148,   148,  1136,    50,     0,    52,
      53,    54,    55,  1143,   694,    18,   160,     1,   161,   724,
     196,    16,   748,    18,   162,    31,    32,   439,   440,   765,
     889,    74,   765,   196,   593,   594,   765,   196,   196,   156,
      46,   190,   191,   192,   196,   286,   287,   152,   165,  1044,
     152,   292,   157,   189,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   772,   148,   150,
      81,   776,   777,   244,   245,   246,   247,   248,   249,   160,
     160,  1066,   344,    30,   902,   765,   348,   349,   350,   351,
     261,   148,   772,   977,   265,   507,   358,   777,   360,   765,
     512,   158,   273,   274,   152,   664,   665,   200,   201,   280,
     281,   282,   283,     1,   162,   163,   164,  1102,   285,   152,
    1118,    86,   363,   364,   365,  1110,   152,    42,   152,   162,
     163,   949,   156,   155,   152,   840,   162,   163,   164,   123,
     152,   125,   309,   310,  1142,   129,  1104,   152,   315,   316,
     152,   343,   174,   175,   156,     7,   140,   162,   163,   164,
     840,   183,   156,   923,   174,   175,   143,   189,   145,     3,
     875,   165,   877,   183,   156,   159,   343,   439,   440,   189,
     712,   422,   310,   165,   716,     3,   745,   315,   316,   748,
     895,   453,   433,   177,   435,   156,   367,   368,   152,   366,
     123,   180,   125,   187,   165,   376,   129,     4,   162,   163,
     164,   162,   163,   164,    37,    38,   921,   140,     4,   924,
    1104,    83,    84,  1041,  1042,     3,   986,   162,   163,   164,
     162,   163,   164,     3,   122,   123,   159,   125,   918,   151,
     128,   129,   162,   163,   164,   507,   162,   163,   164,   160,
     512,   162,   140,     3,   177,   162,   163,   164,    31,    32,
     427,  1145,    52,    53,   187,   970,    22,   434,    88,   455,
     511,   830,   162,   163,   164,   155,   156,   455,   755,    11,
     117,  1165,  1100,     1,  1168,   755,   453,   102,   993,   177,
     970,   996,   533,   162,   163,   164,    48,    49,   539,   187,
     541,  1006,    34,    35,    36,    37,   115,    39,    40,   155,
     156,   482,   162,   163,   164,   162,   163,   164,    47,   560,
     162,   163,   164,   162,   163,   164,   162,   163,   164,    21,
     889,   152,  1037,   152,   102,    67,    68,    69,   152,    71,
     162,   163,   164,   510,   152,   152,   532,  1052,  1166,   190,
     191,   192,  1057,   152,   595,   102,   152,  1037,    18,   164,
     152,   152,    64,   534,  1069,   152,   141,   152,   152,   152,
     152,   152,  1052,   540,   163,   561,   152,  1057,   152,   565,
     152,   567,   142,   561,   164,   152,   152,   152,   152,   152,
    1095,   558,   196,   152,   152,   152,   149,   152,   152,   150,
     162,   162,   120,   121,   645,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   152,   148,   152,   666,   593,   594,    10,    11,
     616,   164,    14,    15,   620,   621,   622,   148,    20,   148,
      22,    23,    24,    25,    26,    27,    28,   144,   149,   144,
      12,   147,   644,   639,   640,   148,   642,   147,   164,   177,
     143,   146,   146,   154,   642,   146,   146,   156,    30,   187,
     148,    33,   154,   176,   160,   196,   151,   644,     5,    41,
     620,   621,   156,   160,   160,   155,   148,   160,    50,   160,
      52,   160,   160,   755,    56,   160,   168,   664,   665,   150,
     150,   168,     6,     7,   150,   746,   150,    89,   749,   196,
     150,   150,   150,    75,   150,    77,    78,    79,    80,    81,
     199,   151,   151,    85,    28,   160,   712,   160,   160,   160,
     716,   717,   114,   154,   116,    97,   150,   196,   160,   152,
     160,   196,   150,   150,   150,     5,   151,   817,   734,   816,
     765,   937,   935,    57,  1058,   747,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    1119,  1190,   712,  1056,   918,  1057,   716,  1104,   745,   765,
     747,   748,   164,   362,   923,   561,   621,   810,   953,  1037,
    1069,   832,  1095,    97,  1031,   148,  1129,   150,   777,   152,
     724,   154,   155,   156,   736,    14,   130,   450,   558,   665,
     830,   164,   165,    -1,   118,   119,   427,   427,    -1,   860,
      -1,   862,    -1,   864,   810,   866,    -1,    -1,    -1,    -1,
     816,   817,    -1,    -1,    -1,    -1,    -1,    -1,   816,   817,
     193,   194,   195,   196,   197,   198,    -1,   888,    -1,   890,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,   150,
      -1,   152,    -1,   154,   155,   156,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   164,   165,    -1,    -1,    -1,    -1,    -1,
     148,    -1,   150,    -1,   152,    -1,   154,   155,   156,    -1,
      -1,    -1,   878,   879,   880,   887,   164,   165,    -1,    -1,
     878,   879,   193,   194,   195,   196,   197,   198,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   903,    -1,    -1,
     887,    -1,   889,    -1,    -1,   193,   194,   195,   196,   197,
     198,    -1,   973,   974,   975,   976,    -1,   923,    -1,   925,
     926,    -1,   148,    -1,   150,    -1,   152,   925,   154,   155,
     156,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   164,   165,
     148,    -1,   150,  1004,   152,    -1,   154,   155,   156,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   164,   165,   148,    -1,
     150,    -1,   152,    -1,   154,   155,   156,   193,   194,   195,
     196,   197,   198,    -1,   164,   165,    -1,    -1,    -1,    -1,
     986,    -1,    -1,    -1,    -1,   193,   194,   195,   196,   197,
     198,  1003,   998,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     998,    -1,    -1,   193,   194,   195,   196,   197,   198,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1003,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,  1103,    -1,    -1,    -1,  1107,    -1,    -1,    -1,
    1111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,    -1,    -1,    -1,     6,     7,     8,    -1,    10,    11,
      -1,    13,    14,    15,    16,    17,    18,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,    -1,    -1,    -1,    37,    -1,    -1,    -1,    41,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1117,  1118,    -1,    56,    -1,    -1,    -1,    -1,  1117,
    1126,  1127,  1128,    -1,    -1,    -1,    -1,    -1,  1126,  1127,
    1128,    -1,    -1,  1139,    76,    -1,  1142,    -1,    -1,  1200,
    1201,  1139,    -1,    -1,    -1,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    -1,    -1,    -1,    -1,   101,
      -1,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,    -1,    -1,    -1,   148,    -1,
     150,    -1,   152,    -1,   154,   155,   156,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   164,   165,   148,    -1,  1158,  1159,
    1160,    -1,   154,   155,   156,    -1,    -1,    -1,   150,    -1,
      -1,    -1,   164,   165,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   193,   194,   195,   196,   197,   198,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   193,   194,   195,   196,   197,    -1,    -1,    -1,    -1,
      -1,   193,    -1,    -1,    -1,    -1,    -1,    -1,   200,   201,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,    -1,    -1,    -1,   196,    -1,   198,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,    -1,    -1,    -1,   196,    -1,   198,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,    -1,    -1,    -1,   196,    -1,   198,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
      -1,    -1,    -1,   196,    -1,   198,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,    -1,    -1,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,    -1,
      -1,    -1,   196,    -1,   198,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,    -1,    -1,
      -1,   196,    -1,   198,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,    -1,    -1,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,    -1,    -1,    -1,
     196,    -1,   198,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,    -1,    -1,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,    -1,    -1,    -1,   196,
      -1,   198,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,    -1,    -1,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,    -1,    -1,    -1,   196,    -1,
     198,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,    -1,
     149,    -1,    -1,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,    -1,    -1,    -1,   196,    -1,   198,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,    -1,   149,
      -1,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,    -1,    -1,    -1,   196,    -1,   198,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
      -1,   152,   153,    -1,    -1,    -1,   157,   158,   159,   160,
     161,   162,   163,    -1,    -1,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,    -1,    -1,    -1,   196,    -1,   198,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,    -1,    -1,   157,    -1,   159,   160,    -1,
     162,   163,    -1,    -1,   166,   167,    -1,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,    -1,    -1,    -1,   196,    -1,   198,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
      -1,   144,    -1,   146,    -1,   148,   149,    -1,    -1,   152,
      -1,   154,    -1,    -1,   157,    -1,   159,   160,    -1,   162,
     163,    -1,    -1,   166,   167,    -1,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
      -1,    -1,    -1,   196,    -1,   198,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,    -1,
     144,    -1,   146,    -1,    -1,   149,    -1,    -1,   152,   153,
      -1,    -1,    -1,   157,    -1,   159,   160,    -1,   162,   163,
      -1,    -1,   166,   167,    -1,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,    -1,
      -1,    -1,   196,    -1,   198,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
      -1,   146,    -1,   148,   149,    -1,    -1,    -1,    -1,   154,
      -1,    -1,   157,    -1,   159,   160,    -1,   162,   163,    -1,
      -1,   166,   167,    -1,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,    -1,    -1,
      -1,   196,    -1,   198,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,    -1,   144,    -1,
     146,    -1,    -1,   149,    -1,    -1,   152,    -1,    -1,    -1,
      -1,   157,    -1,   159,   160,    -1,   162,   163,    -1,    -1,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,    -1,    -1,    -1,
     196,    -1,   198,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,    -1,   146,
      -1,    -1,   149,    -1,    -1,    -1,    -1,   154,    -1,    -1,
     157,    -1,   159,   160,    -1,   162,   163,    -1,    -1,   166,
     167,    -1,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,    -1,    -1,    -1,   196,
      -1,   198,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,    -1,   144,    -1,   146,    -1,
      -1,   149,    -1,    -1,    -1,    -1,   154,    -1,    -1,   157,
      -1,   159,   160,    -1,   162,   163,    -1,    -1,   166,   167,
      -1,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,    -1,    -1,    -1,   196,    -1,
     198,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,    -1,    -1,
     149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,
     159,   160,    -1,   162,   163,    -1,    -1,   166,   167,    -1,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,    -1,    -1,    -1,   196,    -1,   198,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,    -1,    -1,   149,
      -1,    -1,    -1,    -1,   154,    -1,    -1,   157,    -1,   159,
     160,    -1,   162,   163,    -1,    -1,   166,   167,    -1,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,    -1,    -1,    -1,   196,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
      -1,   144,    -1,   146,    -1,    -1,   149,    -1,    -1,    -1,
      -1,   154,    -1,    -1,   157,   158,   159,   160,    -1,   162,
     163,    -1,    -1,   166,   167,    -1,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
      -1,    -1,    -1,   196,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,    -1,   144,    -1,
     146,    -1,    -1,   149,    -1,    -1,    -1,   153,    -1,    -1,
      -1,   157,    -1,   159,   160,    -1,   162,   163,    -1,    -1,
     166,   167,    -1,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,    -1,    -1,    -1,
     196,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,    -1,   144,    -1,   146,    -1,    -1,
     149,    -1,    -1,    -1,    -1,   154,    -1,    -1,   157,    -1,
     159,   160,    -1,   162,   163,    -1,    -1,   166,   167,    -1,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,    -1,    -1,    -1,   196,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,    -1,   146,    -1,    -1,   149,    -1,    -1,
      -1,    -1,   154,    -1,    -1,   157,    -1,   159,   160,    -1,
     162,   163,    -1,    -1,   166,   167,    -1,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,    -1,    -1,    -1,   196,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
      -1,   146,    -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   157,    -1,   159,   160,    -1,   162,   163,    -1,
      -1,   166,   167,    -1,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   148,    -1,
     150,   196,   152,    -1,   154,   155,   156,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   164,   165,   148,    -1,   150,    -1,
     152,    -1,   154,   155,   156,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   164,   165,   148,    -1,   150,    -1,   152,    -1,
     154,   155,   156,   193,   194,   195,   196,   197,   198,    -1,
     164,   165,   148,    -1,   150,    -1,   152,    -1,   154,   155,
     156,   193,   194,   195,   196,   197,   198,    -1,   164,   165,
     148,    -1,   150,    -1,   152,    -1,   154,   155,   156,   193,
     194,   195,   196,   197,   198,    -1,   164,   165,   148,    -1,
     150,    -1,   152,    -1,   154,   155,   156,   193,   194,   195,
     196,   197,   198,    -1,   164,   165,   148,    -1,   150,    -1,
     152,    -1,   154,   155,   156,   193,   194,   195,   196,   197,
     198,    -1,   164,   165,   148,    -1,   150,    -1,   152,    -1,
     154,   155,   156,   193,   194,   195,   196,   197,   198,    -1,
     164,   165,   148,    -1,   150,    -1,    -1,    -1,   154,   155,
     156,   193,   194,   195,   196,   197,   198,    -1,   164,   165,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   193,
     194,   195,   196,   197,   198,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   155,    -1,    -1,    -1,    -1,   193,   194,   195,
     196,   197,   198,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,     6,     7,     8,    13,    16,    17,    19,    29,
      30,    33,    37,    41,    56,    76,    87,    88,    90,    91,
      92,    93,    94,    95,    96,   101,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   150,   193,   200,
     201,   203,   204,   205,   245,   269,   271,   375,   432,   433,
     434,   200,   201,   424,   272,   246,   378,   397,   387,    12,
      30,    33,    41,    50,    52,    56,    75,    77,    78,    79,
      80,    81,    85,    97,   439,     6,     7,    28,    57,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    97,   118,   119,    37,    38,    81,    82,
     428,   429,   376,    83,    84,   430,   428,    77,   152,   152,
     152,   152,   379,   380,   377,   209,   210,   211,   212,   207,
     208,   396,   270,   206,     0,   390,    10,    11,    14,    15,
      20,    22,    23,    24,    25,    26,    27,    28,    89,   114,
     116,   164,   431,   436,    18,   152,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   196,   198,   368,
     369,   369,   148,   150,   152,   154,   155,   156,   164,   165,
     193,   194,   195,   196,   197,   198,   440,   489,   492,   507,
     440,   440,    81,    13,    50,    52,    53,    54,    55,    74,
      11,    34,    35,    36,    37,    39,    40,    67,    68,    69,
      71,   426,    42,    43,    44,    45,    47,    59,    83,    98,
      99,   100,   189,   425,    30,    31,    32,   427,   427,   427,
      69,    97,   180,    86,   427,   420,   403,   407,    42,    58,
     102,   159,   404,   152,   152,   405,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   406,     7,   398,
     399,   152,   198,   268,   367,   401,   400,   180,   440,   440,
     268,     3,     3,     4,     4,     3,     3,   440,   151,     3,
     148,   152,   154,   155,   156,   164,   165,   196,   197,   444,
     489,   493,   507,   381,   382,   434,    16,    18,   383,   384,
     385,   386,   102,   435,    22,   117,   437,   438,   388,   115,
     391,   273,   247,   490,   491,   441,   422,    52,    53,   427,
     427,   427,   427,   427,   427,   427,    46,   427,    48,    49,
      47,   427,   427,   152,   152,   152,   427,   427,   427,   427,
     152,   148,   154,   155,   156,   164,   165,   193,   196,   197,
     506,   507,   268,   268,   152,   102,   152,   102,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   268,
     268,   268,   408,   198,   269,   501,   503,   504,   505,   506,
     501,   501,   501,   402,   445,   446,   440,   444,    21,   394,
     392,   154,   464,   489,   493,   464,   444,   444,   152,    18,
     156,   165,   464,   389,   444,   164,   275,   275,   268,   148,
     268,   442,   268,   506,   427,   427,   152,   152,   152,   152,
     152,   152,   152,   427,   152,    64,   152,   152,   152,   152,
     152,   152,   421,   152,   152,   268,   152,   502,   503,   505,
     268,   148,   150,   154,   155,   156,   164,   165,   193,   196,
     197,   268,   447,   487,   495,   507,   268,   395,   444,   444,
     465,   466,   393,   438,   148,   152,   154,   155,   156,   164,
     165,   196,   197,   453,   489,   494,   507,   276,   277,   369,
     141,   356,   142,   443,   423,   152,   152,   152,   427,   488,
     448,   449,   444,   148,   154,   155,   156,   164,   165,   193,
     196,   197,   467,   487,   497,   507,   268,   444,   455,   454,
     456,   156,   165,   148,   161,   278,   281,   150,   214,   215,
     216,   217,   218,   219,   369,   268,   427,   152,   268,   148,
     154,   155,   156,   164,   165,   193,   196,   197,   450,   487,
     496,   507,   268,   469,   468,   470,   467,   148,   154,   155,
     156,   164,   165,   193,   194,   195,   196,   197,   457,   487,
     500,   268,   277,   214,     1,   120,   121,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   177,   187,   282,   321,   214,   160,
     162,   163,   164,   152,   451,   452,   197,   481,   487,   495,
     148,   154,   155,   156,   164,   165,   193,   196,   197,   471,
     487,   498,   507,   268,   458,   459,   460,   152,   200,   201,
     143,   145,   147,   148,   152,   153,   154,   155,   156,   158,
     161,   164,   165,   168,   198,   213,   214,   217,   218,   219,
     367,   368,   373,   374,   283,   284,   285,   143,   145,   147,
     152,   153,   154,   155,   156,   158,   161,   164,   165,   168,
     198,   269,   318,   319,   368,   372,   318,   317,   372,   311,
     362,   363,   367,   368,   310,   287,   289,   292,   294,   297,
     299,   302,   304,   308,   307,   151,   214,   214,   150,   222,
     220,   221,   369,   440,   268,   482,   483,   472,   473,   474,
     148,   154,   155,   156,   164,   165,   193,   196,   197,   461,
     487,   499,   507,   461,   268,   162,   152,   357,   357,   357,
     357,   152,   358,   359,   362,   367,   358,   360,   361,   148,
     148,   319,   148,   148,   372,   312,   164,   361,   148,   148,
     149,   149,   144,   144,   147,   147,   148,   143,   145,   147,
     152,   153,   154,   155,   156,   161,   164,   165,   168,   198,
     322,   323,   368,   370,   356,   223,   164,   156,   165,   155,
     484,   487,   496,   268,   440,   197,   475,   487,   495,   268,
     462,   464,   463,   213,   214,   152,   274,   362,   367,   153,
     358,   359,   286,   143,   145,   154,   198,   279,   320,   329,
     331,   337,   362,   320,   143,   249,   157,   313,   357,   364,
     288,   290,   293,   295,   298,   300,   303,   305,   309,   148,
     158,   323,   324,   248,     1,   123,   125,   129,   140,   159,
     177,   187,   225,   226,   227,   221,   220,   485,   486,   476,
     477,   457,   268,   153,   320,   338,   279,   330,   337,   332,
     279,   280,   337,   315,   363,   365,   268,   146,   268,   146,
     268,   146,   268,   146,   320,   332,   337,   154,   325,     1,
     122,   123,   125,   128,   129,   140,   177,   187,   250,   362,
     228,   362,   369,   369,   370,   232,   224,   156,   165,   440,
     268,   155,   478,   487,   496,   268,   339,   362,   154,   340,
     148,   152,   279,   327,   328,   337,   357,   143,   145,   147,
     148,   152,   153,   158,   161,   168,   198,   314,   316,   368,
     371,   156,   165,   291,   296,   301,   306,   158,   176,   326,
     274,   152,   200,   201,   362,   251,   317,   362,   369,   263,
     265,   370,   253,   160,   148,   234,   160,   231,   160,   230,
     234,   151,   227,   479,   480,   155,   156,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   341,   342,   343,   357,   329,   156,   148,   154,   333,
     334,   335,   362,   367,   366,   268,   268,   268,   268,   337,
     196,   155,   160,   148,   160,   255,   148,   160,   252,   160,
     150,   266,   148,   160,   259,   362,   235,   160,   362,   148,
     236,   369,   237,   324,   160,   440,   268,   362,   168,   168,
     196,   150,   196,   150,   150,   150,   150,   150,   150,   150,
     155,   343,   344,   333,   334,   336,   357,   357,   363,   254,
     362,   367,   256,   258,   249,   254,   236,   267,   264,   324,
     260,   262,   332,   229,   333,   335,   362,   160,   160,   233,
     345,   347,   348,   349,   350,   351,   190,   191,   192,   354,
     355,   346,   199,   352,   339,   357,   332,   268,   280,   160,
     268,   151,   160,   332,   268,   331,   154,   238,   369,   370,
     238,   196,   353,   353,   353,   353,   353,     5,   369,   369,
     369,   151,   355,   353,   155,   331,   369,   370,   331,   337,
     239,   151,   196,   151,   151,   151,   151,   151,   269,   269,
     269,   151,   337,   357,   152,   337,   174,   175,   183,   189,
     240,   241,   160,   160,   196,   150,   150,   150,   155,   241,
     257,   261,   242,   244,   243,   268,   268,   353,     5,   353,
     151,   151,   151
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   202,   203,   203,   203,   203,   204,   204,   204,   204,
     204,   206,   205,   207,   205,   208,   205,   205,   209,   205,
     210,   205,   205,   211,   205,   212,   205,   205,   205,   213,
     213,   213,   213,   213,   213,   213,   213,   214,   214,   215,
     215,   216,   216,   216,   217,   218,   219,   220,   220,   221,
     221,   223,   224,   222,   225,   225,   226,   226,   227,   227,
     228,   229,   227,   230,   227,   227,   231,   227,   232,   233,
     227,   235,   234,   234,   236,   236,   237,   237,   239,   238,
     238,   240,   240,   241,   242,   241,   243,   241,   244,   241,
     246,   247,   245,   248,   248,   249,   249,   250,   250,   251,
     250,   250,   250,   252,   250,   253,   250,   250,   250,   250,
     254,   254,   256,   257,   255,   258,   255,   260,   261,   259,
     262,   259,   263,   264,   263,   266,   265,   267,   265,   268,
     268,   270,   269,   272,   273,   271,   274,   274,   275,   275,
     276,   276,   277,   278,   278,   279,   280,   280,   281,   281,
     282,   283,   282,   284,   282,   285,   286,   282,   282,   282,
     287,   288,   282,   289,   290,   291,   282,   292,   293,   282,
     294,   295,   296,   282,   297,   298,   282,   299,   300,   301,
     282,   302,   303,   282,   304,   305,   306,   282,   307,   282,
     308,   309,   282,   282,   282,   310,   282,   282,   282,   282,
     312,   311,   311,   313,   313,   314,   314,   315,   315,   316,
     316,   317,   317,   318,   318,   319,   319,   320,   320,   320,
     321,   321,   322,   322,   323,   324,   324,   325,   325,   326,
     327,   327,   328,   328,   328,   329,   330,   330,   331,   331,
     332,   332,   333,   333,   334,   334,   334,   336,   335,   337,
     338,   337,   339,   339,   340,   340,   341,   341,   342,   342,
     342,   343,   343,   344,   343,   343,   343,   343,   345,   343,
     346,   343,   347,   343,   348,   343,   349,   343,   343,   343,
     343,   350,   343,   343,   343,   343,   343,   351,   343,   343,
     343,   343,   352,   352,   353,   353,   354,   354,   355,   355,
     355,   355,   356,   356,   357,   357,   358,   358,   359,   359,
     360,   360,   361,   362,   363,   364,   363,   366,   365,   365,
     367,   368,   368,   368,   368,   368,   368,   368,   368,   368,
     368,   368,   368,   368,   368,   368,   368,   368,   368,   368,
     368,   368,   368,   368,   368,   368,   368,   368,   368,   368,
     368,   368,   368,   368,   368,   368,   368,   368,   368,   368,
     368,   368,   368,   368,   368,   368,   368,   368,   368,   368,
     368,   368,   368,   368,   368,   368,   368,   368,   368,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   370,   370,   370,   370,   370,
     370,   370,   370,   370,   370,   370,   370,   370,   370,   371,
     371,   371,   371,   371,   371,   371,   371,   371,   371,   371,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   373,   373,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   374,
     374,   376,   375,   377,   375,   378,   375,   379,   375,   380,
     375,   381,   375,   382,   375,   383,   375,   384,   375,   385,
     375,   386,   375,   387,   375,   388,   375,   389,   375,   390,
     375,   391,   375,   392,   375,   393,   375,   394,   375,   395,
     375,   375,   396,   375,   397,   375,   375,   398,   375,   399,
     375,   400,   375,   401,   375,   402,   375,   403,   375,   404,
     375,   405,   375,   406,   375,   407,   375,   408,   375,   375,
     375,   409,   375,   410,   375,   411,   375,   412,   375,   413,
     375,   414,   375,   415,   375,   416,   375,   417,   375,   418,
     375,   375,   375,   375,   375,   419,   375,   375,   375,   375,
     375,   375,   375,   375,   375,   375,   375,   375,   375,   375,
     420,   421,   375,   422,   423,   375,   375,   375,   375,   375,
     375,   375,   375,   375,   375,   375,   375,   375,   375,   424,
     375,   425,   425,   425,   425,   425,   425,   425,   425,   425,
     425,   425,   426,   426,   426,   426,   426,   426,   426,   426,
     426,   426,   426,   426,   427,   427,   428,   428,   429,   429,
     430,   430,   431,   431,   431,   431,   431,   432,   432,   433,
     433,   434,   434,   435,   435,   436,   436,   437,   437,   438,
     439,   439,   439,   439,   440,   441,   440,   443,   442,   442,
     445,   444,   444,   446,   444,   448,   447,   449,   447,   447,
     451,   450,   452,   450,   450,   454,   453,   455,   453,   453,
     456,   453,   458,   457,   459,   457,   460,   457,   457,   461,
     462,   461,   463,   461,   461,   465,   464,   464,   466,   464,
     468,   467,   469,   467,   470,   467,   467,   472,   471,   473,
     471,   474,   471,   471,   476,   475,   477,   475,   475,   479,
     478,   480,   478,   478,   482,   481,   483,   481,   481,   485,
     484,   486,   484,   484,   488,   487,   487,   490,   489,   491,
     489,   489,   492,   492,   492,   492,   492,   492,   492,   492,
     492,   492,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   494,   494,   494,   494,   494,   494,   494,   494,   495,
     495,   495,   495,   495,   495,   495,   495,   495,   496,   496,
     496,   496,   496,   496,   496,   496,   496,   497,   497,   497,
     497,   497,   497,   497,   497,   498,   498,   498,   498,   498,
     498,   498,   498,   499,   499,   499,   499,   499,   499,   499,
     499,   500,   500,   500,   500,   500,   500,   500,   500,   500,
     501,   501,   502,   502,   503,   504,   504,   505,   505,   506,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   507,
     507
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     0,     3,     0,     3,     0,     3,     1,     0,     3,
       0,     3,     1,     0,     3,     0,     3,     1,     1,     2,
       2,     2,     2,     2,     3,     1,     1,     1,     3,     1,
       1,     1,     1,     1,     3,     4,     3,     4,     1,     3,
       1,     0,     0,     5,     1,     1,     3,     1,     4,     4,
       0,     0,     6,     0,     6,     4,     0,     6,     0,     0,
       6,     0,     5,     0,     2,     0,     1,     0,     0,     4,
       0,     2,     1,     2,     0,     5,     0,     5,     0,     5,
       0,     0,    12,     2,     0,     1,     0,     4,     5,     0,
       3,     2,     4,     0,     7,     0,     3,     2,     2,     2,
       2,     1,     0,     0,     8,     0,     3,     0,     0,     8,
       0,     3,     1,     0,     4,     0,     6,     0,     4,     1,
       1,     0,     3,     0,     0,     8,     1,     1,     3,     0,
       3,     1,     3,     1,     1,     1,     2,     1,     2,     0,
       2,     0,     3,     0,     3,     0,     0,     5,     4,     5,
       0,     0,     5,     0,     0,     0,     7,     0,     0,     5,
       0,     0,     0,     7,     0,     0,     5,     0,     0,     0,
       7,     0,     0,     5,     0,     0,     0,     7,     0,     6,
       0,     0,     5,     4,     2,     0,     3,     2,     2,     2,
       0,     3,     1,     1,     3,     3,     2,     3,     0,     3,
       2,     2,     1,     2,     1,     1,     1,     3,     1,     1,
       1,     1,     2,     1,     1,     2,     4,     3,     0,     2,
       1,     0,     2,     1,     1,     2,     3,     1,     1,     1,
       2,     0,     1,     1,     2,     1,     2,     0,     4,     1,
       0,     4,     3,     1,     3,     0,     2,     1,     1,     2,
       2,     1,     1,     0,     3,     1,     1,     2,     0,     5,
       0,     5,     0,     5,     0,     5,     0,     5,     1,     1,
       1,     0,     5,     1,     1,     1,     2,     0,     5,     4,
       1,     1,     1,     0,     2,     1,     2,     1,     2,     3,
       3,     3,     1,     0,     1,     0,     2,     1,     1,     2,
       3,     2,     2,     1,     1,     0,     5,     0,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     3,     0,     3,     0,     3,     0,     3,     0,
       3,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     3,     0,     4,     0,     5,     0,
       3,     0,     4,     0,     5,     0,     6,     0,     5,     0,
       6,     4,     0,     3,     0,     3,     1,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     5,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     5,     3,
       3,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     4,     5,     5,     4,     0,     4,     5,     5,     6,
       5,     5,     6,     5,     5,     5,     5,     6,     5,     4,
       0,     0,     7,     0,     0,     8,     4,     5,     5,     5,
       4,     5,     2,     2,     2,     1,     2,     5,     4,     0,
       3,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     3,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     0,     1,     0,     3,     0,     1,     3,     1,
       1,     1,     1,     1,     1,     0,     3,     0,     3,     1,
       0,     3,     1,     0,     3,     0,     3,     0,     3,     1,
       0,     3,     0,     3,     1,     0,     3,     0,     3,     1,
       0,     3,     0,     3,     0,     3,     0,     3,     1,     2,
       0,     3,     0,     3,     1,     0,     3,     1,     0,     3,
       0,     3,     0,     3,     0,     3,     1,     0,     3,     0,
       3,     0,     3,     1,     0,     3,     0,     3,     1,     0,
       3,     0,     3,     1,     0,     3,     0,     3,     1,     0,
       3,     0,     3,     1,     0,     3,     1,     0,     3,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (parseResult, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, parseResult); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, UserLevelRewritingContext::ParseResult* parseResult)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (parseResult);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, UserLevelRewritingContext::ParseResult* parseResult)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, parseResult);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, UserLevelRewritingContext::ParseResult* parseResult)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], parseResult);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, parseResult); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, UserLevelRewritingContext::ParseResult* parseResult)
{
  YY_USE (yyvaluep);
  YY_USE (parseResult);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_moduleExprDot: /* moduleExprDot  */
#line 121 "surface.yy"
            { ((*yyvaluep).yyModuleExpression)->deepSelfDestruct(); }
#line 2844 "surface.c"
        break;

    case YYSYMBOL_moduleExpr: /* moduleExpr  */
#line 121 "surface.yy"
            { ((*yyvaluep).yyModuleExpression)->deepSelfDestruct(); }
#line 2850 "surface.c"
        break;

    case YYSYMBOL_moduleExpr2: /* moduleExpr2  */
#line 121 "surface.yy"
            { ((*yyvaluep).yyModuleExpression)->deepSelfDestruct(); }
#line 2856 "surface.c"
        break;

    case YYSYMBOL_moduleExpr3: /* moduleExpr3  */
#line 121 "surface.yy"
            { ((*yyvaluep).yyModuleExpression)->deepSelfDestruct(); }
#line 2862 "surface.c"
        break;

    case YYSYMBOL_renameExpr: /* renameExpr  */
#line 121 "surface.yy"
            { ((*yyvaluep).yyModuleExpression)->deepSelfDestruct(); }
#line 2868 "surface.c"
        break;

    case YYSYMBOL_instantExpr: /* instantExpr  */
#line 121 "surface.yy"
            { ((*yyvaluep).yyModuleExpression)->deepSelfDestruct(); }
#line 2874 "surface.c"
        break;

    case YYSYMBOL_parenExpr: /* parenExpr  */
#line 121 "surface.yy"
            { ((*yyvaluep).yyModuleExpression)->deepSelfDestruct(); }
#line 2880 "surface.c"
        break;

    case YYSYMBOL_viewExpr: /* viewExpr  */
#line 121 "surface.yy"
            { ((*yyvaluep).yyViewExpression)->deepSelfDestruct(); }
#line 2886 "surface.c"
        break;

    case YYSYMBOL_instantArgs: /* instantArgs  */
#line 122 "surface.yy"
            { deepSelfDestructViewExpressionVector(((*yyvaluep).yyViewExpressionVector)); }
#line 2892 "surface.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (UserLevelRewritingContext::ParseResult* parseResult)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* top: item  */
#line 266 "surface.yy"
                             { YYACCEPT; }
#line 3168 "surface.c"
    break;

  case 3: /* top: END_OF_INPUT  */
#line 268 "surface.yy"
                        {
			  PARSE_RESULT = UserLevelRewritingContext::QUIT;
			  YYACCEPT;
			}
#line 3177 "surface.c"
    break;

  case 4: /* top: error END_OF_INPUT  */
#line 273 "surface.yy"
                        {
			  //
			  //	This is the back stop if we see a END_OF_INPUT when we're part way
			  //	through the item, and justifies suppressing the yyerror() message.
			  //
			  IssueWarning(LineNumber(lineNumber) << ": unexpected end-of-input.");
			  YYABORT;
			}
#line 3190 "surface.c"
    break;

  case 5: /* top: error CHANGE_FILE  */
#line 282 "surface.yy"
                        {
			  //
			  //	This is the back stop if we see a CHANGE_FILE when we're part way
			  //	through an item, and justifies suppressing the yyerror() message.
			  //
			  IssueWarning(LineNumber(lineNumber) << ": unexpected end-of-file.");
			  YYABORT;
			}
#line 3203 "surface.c"
    break;

  case 10: /* item: CHANGE_FILE  */
#line 297 "surface.yy"
                        {
			  //
			  //	Benign change of file; reenable yyerror() message.
			  //
			  suppressParserErrorMessage = false;
			}
#line 3214 "surface.c"
    break;

  case 11: /* $@1: %empty  */
#line 308 "surface.yy"
                                        { lexerFileNameMode(); }
#line 3220 "surface.c"
    break;

  case 12: /* directive: KW_IN $@1 FILE_NAME_STRING  */
#line 310 "surface.yy"
                        {
			  int lineNr = lineNumber;
			  //eatComment(false); // eat \n so that line number is correct
			  string directory;
			  string fileName;
			  if (findFile((yyvsp[0].yyString), directory, fileName, lineNr))
			    includeFile(directory, fileName, false, lineNr);
			}
#line 3233 "surface.c"
    break;

  case 13: /* $@2: %empty  */
#line 318 "surface.yy"
                                        { lexerFileNameMode(); }
#line 3239 "surface.c"
    break;

  case 14: /* directive: KW_LOAD $@2 FILE_NAME_STRING  */
#line 320 "surface.yy"
                        {
			  int lineNr = lineNumber;
			  //eatComment(false); // eat \n so that line number is correct
			  string directory;
			  string fileName;
			  if (findFile((yyvsp[0].yyString), directory, fileName, lineNr))
			    includeFile(directory, fileName, true, lineNr);
			}
#line 3252 "surface.c"
    break;

  case 15: /* $@3: %empty  */
#line 328 "surface.yy"
                                                { lexerFileNameMode(); }
#line 3258 "surface.c"
    break;

  case 16: /* directive: KW_SLOAD $@3 FILE_NAME_STRING  */
#line 330 "surface.yy"
                        {
			  int lineNr = lineNumber;
			  string directory;
			  string fileName;
			  if (findFile((yyvsp[0].yyString), directory, fileName, lineNr) &&
			      !directoryManager.alreadySeen(directory, fileName))
			    includeFile(directory, fileName, true, lineNr);
			}
#line 3271 "surface.c"
    break;

  case 17: /* directive: KW_PWD  */
#line 339 "surface.yy"
                        {
			  cout << directoryManager.getCwd() << '\n';
			}
#line 3279 "surface.c"
    break;

  case 18: /* $@4: %empty  */
#line 342 "surface.yy"
                                        { lexerFileNameMode(); }
#line 3285 "surface.c"
    break;

  case 19: /* directive: KW_CD $@4 FILE_NAME_STRING  */
#line 344 "surface.yy"
                        {
			  string directory;
			  directoryManager.realPath((yyvsp[0].yyString), directory);
			  if (!directoryManager.cd(directory))
			    {
			      IssueWarning(LineNumber(lineNumber) <<
					   ": cd failed");
			    }
			}
#line 3299 "surface.c"
    break;

  case 20: /* $@5: %empty  */
#line 353 "surface.yy"
                                        { lexerFileNameMode(); }
#line 3305 "surface.c"
    break;

  case 21: /* directive: KW_PUSHD $@5 FILE_NAME_STRING  */
#line 355 "surface.yy"
                        {
			  string directory;
			  directoryManager.realPath((yyvsp[0].yyString), directory);
			  if (directoryManager.pushd(directory) == UNDEFINED)
			    {
			      IssueWarning(LineNumber(lineNumber) <<
					   ": pushd failed");
			    }
			}
#line 3319 "surface.c"
    break;

  case 22: /* directive: KW_POPD  */
#line 365 "surface.yy"
                        {
			  const char* path = directoryManager.popd();
			  if (path != 0)
			    cout << path << '\n';
			  else
			    {
			      IssueWarning(LineNumber(lineNumber) <<
					   ": popd failed");
			    }
			}
#line 3334 "surface.c"
    break;

  case 23: /* $@6: %empty  */
#line 375 "surface.yy"
                                        { lexerStringMode(); }
#line 3340 "surface.c"
    break;

  case 24: /* directive: KW_LS $@6 UNINTERPRETED_STRING  */
#line 377 "surface.yy"
                        {
			  returnValueDump = system((string("ls") + (yyvsp[0].yyString)).c_str());
			}
#line 3348 "surface.c"
    break;

  case 25: /* $@7: %empty  */
#line 380 "surface.yy"
                                        { lexerStringMode(); }
#line 3354 "surface.c"
    break;

  case 26: /* directive: KW_LL $@7 UNINTERPRETED_STRING  */
#line 382 "surface.yy"
                        {
			  returnValueDump = system((string("ls -l") + (yyvsp[0].yyString)).c_str());
			}
#line 3362 "surface.c"
    break;

  case 27: /* directive: KW_QUIT  */
#line 386 "surface.yy"
                        {
			  PARSE_RESULT = UserLevelRewritingContext::QUIT;
			  YYACCEPT;
			}
#line 3371 "surface.c"
    break;

  case 28: /* directive: KW_EOF  */
#line 391 "surface.yy"
                        {
			  if(!handleEof())
			    {
			      PARSE_RESULT = UserLevelRewritingContext::QUIT;
			    }
			}
#line 3382 "surface.c"
    break;

  case 29: /* moduleExprDot: tokenBarDot expectedDot  */
#line 424 "surface.yy"
                        {
                          (yyval.yyModuleExpression) =  new ModuleExpression((yyvsp[-1].yyToken));
                        }
#line 3390 "surface.c"
    break;

  case 30: /* moduleExprDot: endsInDot '.'  */
#line 428 "surface.yy"
                        {
                          (yyval.yyModuleExpression) = new ModuleExpression((yyvsp[-1].yyToken));
                        }
#line 3398 "surface.c"
    break;

  case 34: /* moduleExprDot: moduleExpr '+' moduleExprDot  */
#line 435 "surface.yy"
                        {
			  if ((yyvsp[0].yyModuleExpression))
			    (yyval.yyModuleExpression) = new ModuleExpression((yyvsp[-2].yyModuleExpression), (yyvsp[0].yyModuleExpression));
			  else
			    {
			      IssueWarning(LineNumber((yyvsp[-1].yyToken).lineNumber()) <<
			                   ": missing module expression after " << QUOTE((yyvsp[-1].yyToken)) << ".");
			      (yyval.yyModuleExpression) = (yyvsp[-2].yyModuleExpression);
			    }
			}
#line 3413 "surface.c"
    break;

  case 35: /* moduleExprDot: tokenDot  */
#line 446 "surface.yy"
                        {
			  (yyval.yyModuleExpression) = new ModuleExpression((yyvsp[0].yyToken));
			}
#line 3421 "surface.c"
    break;

  case 36: /* moduleExprDot: '.'  */
#line 450 "surface.yy"
                        {
			  (yyval.yyModuleExpression) = 0;
			}
#line 3429 "surface.c"
    break;

  case 38: /* moduleExpr: moduleExpr '+' moduleExpr  */
#line 457 "surface.yy"
                        {
			  (yyval.yyModuleExpression) = new ModuleExpression((yyvsp[-2].yyModuleExpression), (yyvsp[0].yyModuleExpression));
			}
#line 3437 "surface.c"
    break;

  case 43: /* moduleExpr3: token  */
#line 469 "surface.yy"
                        {
                          (yyval.yyModuleExpression) = new ModuleExpression((yyvsp[0].yyToken));
                        }
#line 3445 "surface.c"
    break;

  case 44: /* renameExpr: moduleExpr2 '*' renaming  */
#line 476 "surface.yy"
                        {
			  (yyval.yyModuleExpression) = new ModuleExpression((yyvsp[-2].yyModuleExpression), currentRenaming);
			  currentRenaming = 0;
			}
#line 3454 "surface.c"
    break;

  case 45: /* instantExpr: moduleExpr3 '{' instantArgs '}'  */
#line 483 "surface.yy"
                        {
			  (yyval.yyModuleExpression) = new ModuleExpression((yyvsp[-3].yyModuleExpression), *((yyvsp[-1].yyViewExpressionVector)));
			  delete (yyvsp[-1].yyViewExpressionVector);
			}
#line 3463 "surface.c"
    break;

  case 46: /* parenExpr: '(' moduleExpr ')'  */
#line 490 "surface.yy"
                        {
			  (yyval.yyModuleExpression) = (yyvsp[-1].yyModuleExpression);
			}
#line 3471 "surface.c"
    break;

  case 47: /* viewExpr: viewExpr '{' instantArgs '}'  */
#line 499 "surface.yy"
                        {
			  (yyval.yyViewExpression) = new ViewExpression((yyvsp[-3].yyViewExpression), *((yyvsp[-1].yyViewExpressionVector)));
			  delete (yyvsp[-1].yyViewExpressionVector);
			}
#line 3480 "surface.c"
    break;

  case 48: /* viewExpr: token  */
#line 504 "surface.yy"
                        {
			  (yyval.yyViewExpression) = new ViewExpression((yyvsp[0].yyToken));
			}
#line 3488 "surface.c"
    break;

  case 49: /* instantArgs: instantArgs ',' viewExpr  */
#line 510 "surface.yy"
                        {
			  (yyvsp[-2].yyViewExpressionVector)->append((yyvsp[0].yyViewExpression));
			  (yyval.yyViewExpressionVector) = (yyvsp[-2].yyViewExpressionVector);
			}
#line 3497 "surface.c"
    break;

  case 50: /* instantArgs: viewExpr  */
#line 515 "surface.yy"
                        {
			  Vector<ViewExpression*>* t =  new Vector<ViewExpression*>();
			  t->append((yyvsp[0].yyViewExpression));
			  (yyval.yyViewExpressionVector) = t;
			}
#line 3507 "surface.c"
    break;

  case 51: /* $@8: %empty  */
#line 526 "surface.yy"
                        {
			  oldSyntaxContainer = currentSyntaxContainer;
			  currentSyntaxContainer = currentRenaming = new Renaming;
			}
#line 3516 "surface.c"
    break;

  case 52: /* $@9: %empty  */
#line 531 "surface.yy"
                        {
			  currentSyntaxContainer = oldSyntaxContainer;
			}
#line 3524 "surface.c"
    break;

  case 58: /* mapping: KW_SORT sortName KW_TO sortName  */
#line 546 "surface.yy"
                        {
			  currentRenaming->addSortMapping((yyvsp[-2].yyToken), (yyvsp[0].yyToken));
			}
#line 3532 "surface.c"
    break;

  case 59: /* mapping: KW_LABEL token KW_TO token  */
#line 550 "surface.yy"
                        {
			  currentRenaming->addLabelMapping((yyvsp[-2].yyToken), (yyvsp[0].yyToken));
			}
#line 3540 "surface.c"
    break;

  case 60: /* $@10: %empty  */
#line 553 "surface.yy"
                                                { lexBubble(BAR_COLON | BAR_TO, 1); }
#line 3546 "surface.c"
    break;

  case 61: /* $@11: %empty  */
#line 554 "surface.yy"
                                                { lexBubble(BAR_COMMA | BAR_LEFT_BRACKET | BAR_RIGHT_PAREN, 1); }
#line 3552 "surface.c"
    break;

  case 62: /* mapping: KW_OP $@10 fromSpec KW_TO $@11 toAttributes  */
#line 555 "surface.yy"
                                                {}
#line 3558 "surface.c"
    break;

  case 63: /* $@12: %empty  */
#line 556 "surface.yy"
                                                { currentRenaming->addStratMapping((yyvsp[0].yyToken)); }
#line 3564 "surface.c"
    break;

  case 64: /* mapping: KW_STRAT stratName $@12 fromStratSpec KW_TO stratName  */
#line 558 "surface.yy"
                                                { currentRenaming->addStratTarget((yyvsp[0].yyToken)); }
#line 3570 "surface.c"
    break;

  case 65: /* mapping: KW_CLASS sortName KW_TO sortName  */
#line 560 "surface.yy"
                        {
			  currentRenaming->addClassMapping((yyvsp[-2].yyToken), (yyvsp[0].yyToken));
			}
#line 3578 "surface.c"
    break;

  case 66: /* $@13: %empty  */
#line 564 "surface.yy"
                        {
			  currentRenaming->addAttrMapping((yyvsp[0].yyToken));
			}
#line 3586 "surface.c"
    break;

  case 67: /* mapping: KW_ATTR token $@13 fromAttrSpec KW_TO token  */
#line 568 "surface.yy"
                        {
			  currentRenaming->addAttrTarget((yyvsp[0].yyToken));
			}
#line 3594 "surface.c"
    break;

  case 68: /* $@14: %empty  */
#line 572 "surface.yy"
                        {
			  lexBubble(BAR_COLON | BAR_TO, 1);
			}
#line 3602 "surface.c"
    break;

  case 69: /* $@15: %empty  */
#line 576 "surface.yy"
                        {
			  lexBubble(BAR_COMMA | BAR_LEFT_BRACKET | BAR_RIGHT_PAREN, 1);
			}
#line 3610 "surface.c"
    break;

  case 70: /* mapping: KW_MSG $@14 fromSpec KW_TO $@15 toAttributes  */
#line 580 "surface.yy"
                        {
			  currentRenaming->markAsMsg();
			}
#line 3618 "surface.c"
    break;

  case 71: /* $@16: %empty  */
#line 588 "surface.yy"
                                                { Token::peelParens(lexerBubble); currentRenaming->addOpMapping(lexerBubble); }
#line 3624 "surface.c"
    break;

  case 72: /* fromSpec: ':' $@16 typeList arrow typeName  */
#line 589 "surface.yy"
                                                {}
#line 3630 "surface.c"
    break;

  case 73: /* fromSpec: %empty  */
#line 590 "surface.yy"
                                                { Token::peelParens(lexerBubble); currentRenaming->addOpMapping(lexerBubble); }
#line 3636 "surface.c"
    break;

  case 74: /* fromAttrSpec: ':' typeName1  */
#line 594 "surface.yy"
                        {
			  currentRenaming->addAttrType((yyvsp[0].yyBool) ? tokenSequence : singleton);
			}
#line 3644 "surface.c"
    break;

  case 78: /* $@17: %empty  */
#line 607 "surface.yy"
                                                { Token::peelParens(lexerBubble); currentRenaming->addOpTarget(lexerBubble); }
#line 3650 "surface.c"
    break;

  case 79: /* toAttributes: '[' $@17 toAttributeList ']'  */
#line 608 "surface.yy"
                                                {}
#line 3656 "surface.c"
    break;

  case 80: /* toAttributes: %empty  */
#line 609 "surface.yy"
                                                { Token::peelParens(lexerBubble); currentRenaming->addOpTarget(lexerBubble); }
#line 3662 "surface.c"
    break;

  case 83: /* toAttribute: KW_PREC IDENTIFIER  */
#line 616 "surface.yy"
                                                { currentRenaming->setPrec((yyvsp[0].yyToken)); }
#line 3668 "surface.c"
    break;

  case 84: /* $@18: %empty  */
#line 617 "surface.yy"
                                                { clear(); }
#line 3674 "surface.c"
    break;

  case 85: /* toAttribute: KW_GATHER '(' $@18 idList ')'  */
#line 618 "surface.yy"
                                                { currentRenaming->setGather(tokenSequence); }
#line 3680 "surface.c"
    break;

  case 86: /* $@19: %empty  */
#line 619 "surface.yy"
                                                { clear(); }
#line 3686 "surface.c"
    break;

  case 87: /* toAttribute: KW_FORMAT '(' $@19 idList ')'  */
#line 620 "surface.yy"
                                                { currentRenaming->setFormat(tokenSequence); }
#line 3692 "surface.c"
    break;

  case 88: /* $@20: %empty  */
#line 621 "surface.yy"
                                                { lexerLatexMode(); }
#line 3698 "surface.c"
    break;

  case 89: /* toAttribute: KW_LATEX '(' $@20 LATEX_STRING ')'  */
#line 622 "surface.yy"
                                                { currentRenaming->setLatexMacro((yyvsp[-1].yyString)); }
#line 3704 "surface.c"
    break;

  case 90: /* $@21: %empty  */
#line 628 "surface.yy"
                                                { lexerIdMode(); }
#line 3710 "surface.c"
    break;

  case 91: /* $@22: %empty  */
#line 630 "surface.yy"
                        {
			  fileTable.beginModule((yyvsp[-2].yyToken), (yyvsp[0].yyToken));
			  interpreter.setCurrentView(new SyntacticView((yyvsp[0].yyToken), &interpreter));
			  currentSyntaxContainer = CV;
			}
#line 3720 "surface.c"
    break;

  case 92: /* view: KW_VIEW $@21 token $@22 parameters KW_FROM moduleExpr KW_TO moduleExpr expectedIs viewDecList KW_ENDV  */
#line 638 "surface.yy"
                        {
			  CV->addFrom((yyvsp[-5].yyModuleExpression));
			  CV->addTo((yyvsp[-3].yyModuleExpression));
			  lexerInitialMode();
			  fileTable.endModule(lineNumber);
			  bool displacedView = interpreter.insertView(((yyvsp[-9].yyToken)).code(), CV);
			  CV->finishView();
			  if (displacedView)
			    interpreter.cleanCaches();
			}
#line 3735 "surface.c"
    break;

  case 94: /* viewDecList: %empty  */
#line 651 "surface.yy"
                        {}
#line 3741 "surface.c"
    break;

  case 95: /* skipStrayArrow: KW_ARROW  */
#line 655 "surface.yy"
                        {
			  IssueWarning(LineNumber((yyvsp[0].yyToken).lineNumber()) <<
				       ": skipping " << QUOTE("->") << " in variable declaration.");
			}
#line 3750 "surface.c"
    break;

  case 96: /* skipStrayArrow: %empty  */
#line 659 "surface.yy"
                        {}
#line 3756 "surface.c"
    break;

  case 97: /* viewDeclaration: KW_SORT sortName KW_TO sortDot  */
#line 663 "surface.yy"
                        {
			  CV->addSortMapping((yyvsp[-2].yyToken), (yyvsp[0].yyToken));
			}
#line 3764 "surface.c"
    break;

  case 98: /* viewDeclaration: KW_VAR varNameList ':' skipStrayArrow typeDot  */
#line 666 "surface.yy"
                                                                      {}
#line 3770 "surface.c"
    break;

  case 99: /* $@23: %empty  */
#line 668 "surface.yy"
                        {
			  lexBubble(BAR_COLON | BAR_TO, 1);
			}
#line 3778 "surface.c"
    break;

  case 102: /* viewDeclaration: KW_CLASS sortName KW_TO sortDot  */
#line 674 "surface.yy"
                        {
			  CV->addClassMapping((yyvsp[-2].yyToken), (yyvsp[0].yyToken));
			}
#line 3786 "surface.c"
    break;

  case 103: /* $@24: %empty  */
#line 678 "surface.yy"
                        {
			  CV->addAttrMapping((yyvsp[0].yyToken));
			}
#line 3794 "surface.c"
    break;

  case 104: /* viewDeclaration: KW_ATTR token $@24 fromAttrSpec KW_TO token expectedDot  */
#line 682 "surface.yy"
                        {
			  CV->addAttrTarget((yyvsp[-1].yyToken));
			}
#line 3802 "surface.c"
    break;

  case 105: /* $@25: %empty  */
#line 686 "surface.yy"
                        {
			  lexBubble(BAR_COLON | BAR_TO, 1);
			}
#line 3810 "surface.c"
    break;

  case 108: /* viewDeclaration: error END_OF_INPUT  */
#line 692 "surface.yy"
                        {
			  fileTable.endModule(lineNumber);
			  IssueWarning(LineNumber(lineNumber) <<
			  ": unexpected end-of-input while parsing view " << QUOTE(CV) << ".");
			  YYABORT;  // rely on the caller to clear up view database and lexer
			}
#line 3821 "surface.c"
    break;

  case 109: /* viewDeclaration: error CHANGE_FILE  */
#line 699 "surface.yy"
                        {
			  fileTable.endModule(lineNumber);
			  IssueWarning(LineNumber(lineNumber) <<
			  ": unexpected end-of-file while parsing view " << QUOTE(CV) << ".");
			  YYABORT;  // rely on the caller to clear up view database and lexer
			}
#line 3832 "surface.c"
    break;

  case 110: /* sortDot: sortName expectedDot  */
#line 707 "surface.yy"
                                                        { (yyval.yyToken) = (yyvsp[-1].yyToken); }
#line 3838 "surface.c"
    break;

  case 112: /* $@26: %empty  */
#line 712 "surface.yy"
                        {
			  //
			  //	Specific op->op mapping.
			  //
			  Token::peelParens(lexerBubble);  // remove any enclosing parens from op name
			  CV->addOpMapping(lexerBubble);
			}
#line 3850 "surface.c"
    break;

  case 113: /* $@27: %empty  */
#line 720 "surface.yy"
                        {
			  lexBubble(END_STATEMENT, 1);
			}
#line 3858 "surface.c"
    break;

  case 114: /* viewEndOpMap: ':' $@26 typeList arrow typeName KW_TO $@27 endBubble  */
#line 724 "surface.yy"
                        {
			  Token::peelParens(lexerBubble);  // remove any enclosing parens from op name
			  CV->addOpTarget(lexerBubble);
			}
#line 3867 "surface.c"
    break;

  case 115: /* $@28: %empty  */
#line 729 "surface.yy"
                        {
			  //
			  //	At this point we don't know if we have an op->term mapping
			  //	or a generic op->op mapping so we save the from description and
			  //	press on.
			  //
			  opDescription = lexerBubble;
			  lexBubble(END_STATEMENT, 1);
			}
#line 3881 "surface.c"
    break;

  case 116: /* viewEndOpMap: KW_TO $@28 endBubble  */
#line 739 "surface.yy"
                        {
			  if (lexerBubble[0].code() == Token::encode("term"))
			    {
			      //
			      //	Op->term mapping.
			      //
			      CV->addOpTermMapping(opDescription, lexerBubble);
			    }
			  else
			    {
			      //
			      //	Generic op->op mapping.
			      //
			      Token::peelParens(opDescription);  // remove any enclosing parens from op name
			      CV->addOpMapping(opDescription);
			      Token::peelParens(lexerBubble);  // remove any enclosing parens from op name
			      CV->addOpTarget(lexerBubble);
			    }
			}
#line 3905 "surface.c"
    break;

  case 117: /* $@29: %empty  */
#line 761 "surface.yy"
                        {
			  //
			  //	Specific msg->msg mapping.
			  //
			  Token::peelParens(lexerBubble);  // remove any enclosing parens from op name
			  CV->addOpMapping(lexerBubble);
			}
#line 3917 "surface.c"
    break;

  case 118: /* $@30: %empty  */
#line 769 "surface.yy"
                        {
			  lexBubble(END_STATEMENT, 1);
			}
#line 3925 "surface.c"
    break;

  case 119: /* endMsgMap: ':' $@29 typeList arrow typeName KW_TO $@30 endBubble  */
#line 773 "surface.yy"
                        {
			  Token::peelParens(lexerBubble);  // remove any enclosing parens from op name
			  CV->addOpTarget(lexerBubble);
			  CV->markAsMsg();
			}
#line 3935 "surface.c"
    break;

  case 120: /* $@31: %empty  */
#line 779 "surface.yy"
                        {
			  //
			  //	At this point we don't know if we have an msg->term mapping
			  //	or a generic msg->msg mapping so we save the from description and
			  //	press on.
			  //
			  opDescription = lexerBubble;
			  lexBubble(END_STATEMENT, 1);
			}
#line 3949 "surface.c"
    break;

  case 121: /* endMsgMap: KW_TO $@31 endBubble  */
#line 789 "surface.yy"
                        {
			  if (lexerBubble[0].code() == Token::encode("term"))
			    {
			      //
			      //	msg->term mapping.
			      //
			      CV->addOpTermMapping(opDescription, lexerBubble, true);
			    }
			  else
			    {
			      //
			      //	Generic msg->msg mapping.
			      //
			      Token::peelParens(opDescription);  // remove any enclosing parens from op name
			      CV->addOpMapping(opDescription);
			      Token::peelParens(lexerBubble);  // remove any enclosing parens from op name
			      CV->addOpTarget(lexerBubble);
			      CV->markAsMsg();
			    }
			}
#line 3974 "surface.c"
    break;

  case 122: /* strategyCall: stratName  */
#line 812 "surface.yy"
                        {
			  strategyCall.resize(1);
			  strategyCall[0] = (yyvsp[0].yyToken);
			}
#line 3983 "surface.c"
    break;

  case 123: /* $@32: %empty  */
#line 816 "surface.yy"
                                                        { lexBubble(BAR_RIGHT_PAREN, 1); }
#line 3989 "surface.c"
    break;

  case 124: /* strategyCall: stratName '(' $@32 ')'  */
#line 818 "surface.yy"
                        {
			  // Adds the stratName and parentheses to the lexer bubble
			  int bubbleSize = lexerBubble.length();
			  strategyCall.resize(bubbleSize + 3);
			  strategyCall[0] = (yyvsp[-3].yyToken);
			  strategyCall[1] = (yyvsp[-2].yyToken);
			  for (int i = 0; i < bubbleSize; i++)
			    strategyCall[2 + i] = lexerBubble[i];
			  strategyCall[bubbleSize + 2] = (yyvsp[0].yyToken);
			}
#line 4004 "surface.c"
    break;

  case 125: /* $@33: %empty  */
#line 830 "surface.yy"
                        {
			  CV->addStratMapping((yyvsp[0].yyToken));
			}
#line 4012 "surface.c"
    break;

  case 126: /* viewStratMap: stratName $@33 stratSignature KW_TO stratName '.'  */
#line 834 "surface.yy"
                        {
			  CV->addStratTarget((yyvsp[-1].yyToken));
			}
#line 4020 "surface.c"
    break;

  case 127: /* $@34: %empty  */
#line 838 "surface.yy"
                        {
			  lexBubble(END_STATEMENT, 1);
			}
#line 4028 "surface.c"
    break;

  case 128: /* viewStratMap: strategyCall KW_TO $@34 endBubble  */
#line 842 "surface.yy"
                        {
			  if (lexerBubble[0].code() == Token::encode("expr"))
			    {
			      //
			      //	Strat->expr mapping.
			      //
			      CV->addStratExprMapping(strategyCall, lexerBubble);
			    }
			  else if (strategyCall.length() == 1 && lexerBubble.length() == 1)
			    {
			      //
			      //	Generic strat->strat mapping.
			      //
			      CV->addStratMapping(strategyCall[0]);
			      CV->addStratTarget(lexerBubble[0]);
			    }
			  else {
			    IssueWarning(LineNumber(strategyCall[0].lineNumber()) <<
			      ": bad syntax for strategy mapping.");
			  }
			}
#line 4054 "surface.c"
    break;

  case 129: /* endBubble: '.'  */
#line 865 "surface.yy"
                                        {}
#line 4060 "surface.c"
    break;

  case 130: /* endBubble: tokenDot  */
#line 866 "surface.yy"
                                        { lexerBubble.append((yyvsp[0].yyToken)); }
#line 4066 "surface.c"
    break;

  case 131: /* $@35: %empty  */
#line 869 "surface.yy"
                                        { lexBubble(BAR_RIGHT_PAREN, 1); }
#line 4072 "surface.c"
    break;

  case 132: /* parenBubble: '(' $@35 ')'  */
#line 870 "surface.yy"
                                        {}
#line 4078 "surface.c"
    break;

  case 133: /* $@36: %empty  */
#line 876 "surface.yy"
                                        { lexerIdMode(); }
#line 4084 "surface.c"
    break;

  case 134: /* $@37: %empty  */
#line 878 "surface.yy"
                        {
			  interpreter.setCurrentModule(new SyntacticPreModule((yyvsp[-2].yyToken), (yyvsp[0].yyToken), &interpreter));
			  currentSyntaxContainer = CM;
			  fileTable.beginModule((yyvsp[-2].yyToken), (yyvsp[0].yyToken));
			}
#line 4094 "surface.c"
    break;

  case 135: /* module: KW_MOD $@36 token $@37 parameters expectedIs decList KW_ENDM  */
#line 884 "surface.yy"
                        {
			  lexerInitialMode();
			  fileTable.endModule(lineNumber);
			  CM->finishModule((yyvsp[0].yyToken));
			}
#line 4104 "surface.c"
    break;

  case 136: /* dot: '.'  */
#line 891 "surface.yy"
                                        {}
#line 4110 "surface.c"
    break;

  case 137: /* dot: tokenDot  */
#line 892 "surface.yy"
                                        { store((yyvsp[0].yyToken)); }
#line 4116 "surface.c"
    break;

  case 138: /* parameters: '{' parameterList '}'  */
#line 895 "surface.yy"
                                              {}
#line 4122 "surface.c"
    break;

  case 139: /* parameters: %empty  */
#line 896 "surface.yy"
                        {}
#line 4128 "surface.c"
    break;

  case 142: /* parameter: token colon2 moduleExpr  */
#line 904 "surface.yy"
                        {
			  currentSyntaxContainer->addParameter2((yyvsp[-2].yyToken), (yyvsp[0].yyModuleExpression));
			}
#line 4136 "surface.c"
    break;

  case 143: /* colon2: KW_COLON2  */
#line 909 "surface.yy"
                                  {}
#line 4142 "surface.c"
    break;

  case 144: /* colon2: ':'  */
#line 911 "surface.yy"
                        {
			  IssueWarning(LineNumber((yyvsp[0].yyToken).lineNumber()) <<
			    ": saw " << QUOTE(':') << " instead of " <<
			    QUOTE("::") << " in parameter declaration.");
			}
#line 4152 "surface.c"
    break;

  case 145: /* badType: ENDS_IN_DOT  */
#line 919 "surface.yy"
                        {
			  singleton[0].dropChar((yyvsp[0].yyToken));
			  missingSpace(singleton[0]);
			  currentSyntaxContainer->addType(false, singleton);
			  (yyval.yyToken) = (yyvsp[0].yyToken);  // needed for line number
			}
#line 4163 "surface.c"
    break;

  case 147: /* typeDot: badType  */
#line 928 "surface.yy"
                                {}
#line 4169 "surface.c"
    break;

  case 149: /* decList: %empty  */
#line 932 "surface.yy"
                        {}
#line 4175 "surface.c"
    break;

  case 150: /* declaration: KW_IMPORT moduleExprDot  */
#line 936 "surface.yy"
                        {
			  if ((yyvsp[0].yyModuleExpression))
			    CM->addImport((yyvsp[-1].yyToken), (yyvsp[0].yyModuleExpression));
			  else
			    {
			      IssueWarning(LineNumber((yyvsp[-1].yyToken).lineNumber()) <<
			                   ": missing module expression after " << QUOTE((yyvsp[-1].yyToken)) << ".");
			    }
			}
#line 4189 "surface.c"
    break;

  case 151: /* $@38: %empty  */
#line 946 "surface.yy"
                                                { clear(); }
#line 4195 "surface.c"
    break;

  case 152: /* declaration: KW_SORT $@38 endSortNameList  */
#line 947 "surface.yy"
                                                { CM->addSortDecl(tokenSequence); }
#line 4201 "surface.c"
    break;

  case 153: /* $@39: %empty  */
#line 949 "surface.yy"
                                                { clear(); }
#line 4207 "surface.c"
    break;

  case 154: /* declaration: KW_SUBSORT $@39 endSubsortList  */
#line 950 "surface.yy"
                                                { CM->addSubsortDecl(tokenSequence); }
#line 4213 "surface.c"
    break;

  case 155: /* $@40: %empty  */
#line 952 "surface.yy"
                                                { lexBubble(BAR_COLON, 1); }
#line 4219 "surface.c"
    break;

  case 156: /* $@41: %empty  */
#line 953 "surface.yy"
                                                { Token::peelParens(lexerBubble); CM->addOpDecl(lexerBubble); }
#line 4225 "surface.c"
    break;

  case 157: /* declaration: KW_OP $@40 ':' $@41 domainRangeAttr  */
#line 954 "surface.yy"
                                                {}
#line 4231 "surface.c"
    break;

  case 158: /* declaration: KW_OPS opNameList ':' domainRangeAttr  */
#line 956 "surface.yy"
                                                              {}
#line 4237 "surface.c"
    break;

  case 159: /* declaration: KW_VAR varNameList ':' skipStrayArrow typeDot  */
#line 958 "surface.yy"
                                                                      {}
#line 4243 "surface.c"
    break;

  case 160: /* $@42: %empty  */
#line 960 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), BAR_COLON, 1); }
#line 4249 "surface.c"
    break;

  case 161: /* $@43: %empty  */
#line 961 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_STATEMENT, 1); }
#line 4255 "surface.c"
    break;

  case 162: /* declaration: KW_MB $@42 ':' $@43 endBubble  */
#line 962 "surface.yy"
                                                { CM->addStatement(lexerBubble); }
#line 4261 "surface.c"
    break;

  case 163: /* $@44: %empty  */
#line 964 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), BAR_COLON, 1);  }
#line 4267 "surface.c"
    break;

  case 164: /* $@45: %empty  */
#line 965 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), BAR_IF, 1); }
#line 4273 "surface.c"
    break;

  case 165: /* $@46: %empty  */
#line 966 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_STATEMENT, 1); }
#line 4279 "surface.c"
    break;

  case 166: /* declaration: KW_CMB $@44 ':' $@45 KW_IF $@46 endBubble  */
#line 967 "surface.yy"
                                                { CM->addStatement(lexerBubble); }
#line 4285 "surface.c"
    break;

  case 167: /* $@47: %empty  */
#line 969 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), BAR_EQUALS, 1); }
#line 4291 "surface.c"
    break;

  case 168: /* $@48: %empty  */
#line 970 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_STATEMENT, 1); }
#line 4297 "surface.c"
    break;

  case 169: /* declaration: KW_EQ $@47 '=' $@48 endBubble  */
#line 971 "surface.yy"
                                                { CM->addStatement(lexerBubble); }
#line 4303 "surface.c"
    break;

  case 170: /* $@49: %empty  */
#line 973 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), BAR_EQUALS, 1); }
#line 4309 "surface.c"
    break;

  case 171: /* $@50: %empty  */
#line 974 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), BAR_IF, 1); }
#line 4315 "surface.c"
    break;

  case 172: /* $@51: %empty  */
#line 975 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_STATEMENT, 1); }
#line 4321 "surface.c"
    break;

  case 173: /* declaration: KW_CEQ $@49 '=' $@50 KW_IF $@51 endBubble  */
#line 976 "surface.yy"
                                                { CM->addStatement(lexerBubble); }
#line 4327 "surface.c"
    break;

  case 174: /* $@52: %empty  */
#line 978 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), BAR_ARROW2, 1); }
#line 4333 "surface.c"
    break;

  case 175: /* $@53: %empty  */
#line 979 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_STATEMENT, 1); }
#line 4339 "surface.c"
    break;

  case 176: /* declaration: KW_RL $@52 KW_ARROW2 $@53 endBubble  */
#line 980 "surface.yy"
                                                { CM->addStatement(lexerBubble); }
#line 4345 "surface.c"
    break;

  case 177: /* $@54: %empty  */
#line 982 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), BAR_ARROW2, 1); }
#line 4351 "surface.c"
    break;

  case 178: /* $@55: %empty  */
#line 983 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), BAR_IF, 1); }
#line 4357 "surface.c"
    break;

  case 179: /* $@56: %empty  */
#line 984 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_STATEMENT, 1); }
#line 4363 "surface.c"
    break;

  case 180: /* declaration: KW_CRL $@54 KW_ARROW2 $@55 KW_IF $@56 endBubble  */
#line 985 "surface.yy"
                                                { CM->addStatement(lexerBubble); }
#line 4369 "surface.c"
    break;

  case 181: /* $@57: %empty  */
#line 987 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), BAR_ASSIGN, 1); }
#line 4375 "surface.c"
    break;

  case 182: /* $@58: %empty  */
#line 988 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_STATEMENT, 1); }
#line 4381 "surface.c"
    break;

  case 183: /* declaration: KW_SD $@57 KW_ASSIGN $@58 endBubble  */
#line 989 "surface.yy"
                                                { CM->addStatement(lexerBubble); }
#line 4387 "surface.c"
    break;

  case 184: /* $@59: %empty  */
#line 991 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), BAR_ASSIGN, 1); }
#line 4393 "surface.c"
    break;

  case 185: /* $@60: %empty  */
#line 992 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), BAR_IF, 1); }
#line 4399 "surface.c"
    break;

  case 186: /* $@61: %empty  */
#line 993 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_STATEMENT, 1); }
#line 4405 "surface.c"
    break;

  case 187: /* declaration: KW_CSD $@59 KW_ASSIGN $@60 KW_IF $@61 endBubble  */
#line 994 "surface.yy"
                                                { CM->addStatement(lexerBubble); }
#line 4411 "surface.c"
    break;

  case 188: /* $@62: %empty  */
#line 996 "surface.yy"
                                                { clear(); }
#line 4417 "surface.c"
    break;

  case 189: /* declaration: stratDeclKeyword $@62 stratIdList stratSignature stratAttributes dot  */
#line 1000 "surface.yy"
                                                {}
#line 4423 "surface.c"
    break;

  case 190: /* $@63: %empty  */
#line 1002 "surface.yy"
                                                { lexBubble(BAR_COLON, 1); }
#line 4429 "surface.c"
    break;

  case 191: /* $@64: %empty  */
#line 1003 "surface.yy"
                                                { Token::peelParens(lexerBubble); CM->addOpDecl(lexerBubble); }
#line 4435 "surface.c"
    break;

  case 192: /* declaration: KW_MSG $@63 ':' $@64 domainRangeAttr  */
#line 1004 "surface.yy"
                                                {
						  CM->endMsg();
						}
#line 4443 "surface.c"
    break;

  case 193: /* declaration: KW_MSGS opNameList ':' domainRangeAttr  */
#line 1009 "surface.yy"
                        {
			  CM->endMsg();
			}
#line 4451 "surface.c"
    break;

  case 195: /* $@65: %empty  */
#line 1015 "surface.yy"
                                                { clear(); }
#line 4457 "surface.c"
    break;

  case 196: /* declaration: KW_SUBCLASS $@65 endSubsortList  */
#line 1016 "surface.yy"
                                                { CM->addSubclassDecl(tokenSequence); }
#line 4463 "surface.c"
    break;

  case 197: /* declaration: error '.'  */
#line 1019 "surface.yy"
                        {
			  //
			  //	Fix things that might be in a bad state due
			  //	to a partially processed declaration.
			  //
			  cleanUpModuleExpression();
			  CM->makeDeclsConsistent();
			}
#line 4476 "surface.c"
    break;

  case 198: /* declaration: error END_OF_INPUT  */
#line 1028 "surface.yy"
                        {
			  fileTable.endModule(lineNumber);
			  IssueWarning(LineNumber(lineNumber) <<
			  ": unexpected end-of-input while parsing module " << QUOTE(CM) << ".");
			  YYABORT;  // rely on the caller to clear up module database and lexer
			}
#line 4487 "surface.c"
    break;

  case 199: /* declaration: error CHANGE_FILE  */
#line 1035 "surface.yy"
                        {
			  fileTable.endModule(lineNumber);
			  IssueWarning(LineNumber(lineNumber) <<
			  ": unexpected end-of-file while parsing module " << QUOTE(CM) << ".");
			  YYABORT;  // rely on the caller to clear up module database and lexer
			}
#line 4498 "surface.c"
    break;

  case 200: /* $@66: %empty  */
#line 1044 "surface.yy"
                        {
			  CM->addClassDecl((yyvsp[0].yyToken));
			}
#line 4506 "surface.c"
    break;

  case 201: /* classDecl: sortName $@66 classDef  */
#line 1048 "surface.yy"
                        {
			}
#line 4513 "surface.c"
    break;

  case 202: /* classDecl: tokenDot  */
#line 1051 "surface.yy"
                        {
			  CM->addClassDecl((yyvsp[0].yyToken));
			}
#line 4521 "surface.c"
    break;

  case 204: /* classDef: '|' cPairList finalPair  */
#line 1057 "surface.yy"
                                                {}
#line 4527 "surface.c"
    break;

  case 205: /* finalPair: attributeName ':' typeName1Dot  */
#line 1061 "surface.yy"
                        {
			  CM->addAttributePair((yyvsp[-2].yyToken), (yyvsp[0].yyBool), (yyvsp[0].yyBool) ? tokenSequence : singleton);
			}
#line 4535 "surface.c"
    break;

  case 206: /* finalPair: attributeName typeName1Dot  */
#line 1065 "surface.yy"
                        {
			  CM->addAttributePairNoColon((yyvsp[-1].yyToken), (yyvsp[0].yyBool), (yyvsp[0].yyBool) ? tokenSequence : singleton);
			}
#line 4543 "surface.c"
    break;

  case 209: /* cPair: attributeName ':' typeName1  */
#line 1075 "surface.yy"
                        {
			  CM->addAttributePair((yyvsp[-2].yyToken), (yyvsp[0].yyBool), (yyvsp[0].yyBool) ? tokenSequence : singleton);
			}
#line 4551 "surface.c"
    break;

  case 210: /* cPair: attributeName typeName1  */
#line 1079 "surface.yy"
                        {
			  CM->addAttributePairNoColon((yyvsp[-1].yyToken), (yyvsp[0].yyBool), (yyvsp[0].yyBool) ? tokenSequence : singleton);
			}
#line 4559 "surface.c"
    break;

  case 211: /* varNameList: varNameList tokenBarColon  */
#line 1084 "surface.yy"
                                                        { currentSyntaxContainer->addVarDecl((yyvsp[0].yyToken)); }
#line 4565 "surface.c"
    break;

  case 212: /* varNameList: tokenBarColon  */
#line 1085 "surface.yy"
                                                        { currentSyntaxContainer->addVarDecl((yyvsp[0].yyToken)); }
#line 4571 "surface.c"
    break;

  case 215: /* simpleOpName: tokenBarColon  */
#line 1092 "surface.yy"
                                                { singleton[0] = (yyvsp[0].yyToken); CM->addOpDecl(singleton); }
#line 4577 "surface.c"
    break;

  case 216: /* simpleOpName: parenBubble  */
#line 1093 "surface.yy"
                                                { CM->addOpDecl(lexerBubble); }
#line 4583 "surface.c"
    break;

  case 219: /* domainRangeAttr: badType  */
#line 1099 "surface.yy"
                        {
			  IssueWarning(LineNumber(lineNumber) <<
				       ": missing " << QUOTE("->") << " in constant declaration.");
			}
#line 4592 "surface.c"
    break;

  case 224: /* stratId: stratName  */
#line 1111 "surface.yy"
                                        { CM->addStratDecl((yyvsp[0].yyToken)); }
#line 4598 "surface.c"
    break;

  case 227: /* stratAttributes: '[' stratAttrList ']'  */
#line 1122 "surface.yy"
                                                {}
#line 4604 "surface.c"
    break;

  case 228: /* stratAttributes: %empty  */
#line 1123 "surface.yy"
                        {}
#line 4610 "surface.c"
    break;

  case 229: /* stratAttrList: KW_METADATA IDENTIFIER  */
#line 1127 "surface.yy"
                        {
			  CM->setMetadata((yyvsp[0].yyToken));
			}
#line 4618 "surface.c"
    break;

  case 230: /* skipStrayColon: ':'  */
#line 1133 "surface.yy"
                        {
			  IssueWarning(LineNumber((yyvsp[0].yyToken).lineNumber()) <<
				       ": skipping stray " << QUOTE(":") << " in operator declaration.");

			}
#line 4628 "surface.c"
    break;

  case 231: /* skipStrayColon: %empty  */
#line 1138 "surface.yy"
                        {}
#line 4634 "surface.c"
    break;

  case 233: /* dra2: '.'  */
#line 1143 "surface.yy"
                        {
			  IssueWarning(LineNumber((yyvsp[0].yyToken).lineNumber()) <<
			  ": missing " << QUOTE("->") << " in operator declaration.");
			}
#line 4643 "surface.c"
    break;

  case 234: /* dra2: badType  */
#line 1148 "surface.yy"
                        {
			  IssueWarning(LineNumber((yyvsp[0].yyToken).lineNumber()) <<
			  ": missing " << QUOTE("->") << " in operator declaration.");
			}
#line 4652 "surface.c"
    break;

  case 235: /* rangeAttr: arrow typeAttr  */
#line 1155 "surface.yy"
                        {
			  if ((yyvsp[-1].yyBool))
			    CM->convertSortsToKinds();
			}
#line 4661 "surface.c"
    break;

  case 237: /* typeAttr: badType  */
#line 1162 "surface.yy"
                                {}
#line 4667 "surface.c"
    break;

  case 238: /* arrow: KW_ARROW  */
#line 1165 "surface.yy"
                                                { (yyval.yyBool) = false; }
#line 4673 "surface.c"
    break;

  case 239: /* arrow: KW_PARTIAL  */
#line 1166 "surface.yy"
                                                { (yyval.yyBool) = true; }
#line 4679 "surface.c"
    break;

  case 241: /* typeList: %empty  */
#line 1170 "surface.yy"
                        {}
#line 4685 "surface.c"
    break;

  case 242: /* typeName1: sortName  */
#line 1174 "surface.yy"
                        {
			  singleton[0] = (yyvsp[0].yyToken);
			  (yyval.yyBool) = false;
			}
#line 4694 "surface.c"
    break;

  case 243: /* typeName1: kind  */
#line 1179 "surface.yy"
                        {
			  (yyval.yyBool) = true;
			}
#line 4702 "surface.c"
    break;

  case 244: /* typeName1Dot: sortName expectedDot  */
#line 1185 "surface.yy"
                        {
			  singleton[0] = (yyvsp[-1].yyToken);
			  (yyval.yyBool) = false;
			}
#line 4711 "surface.c"
    break;

  case 245: /* typeName1Dot: tokenDot  */
#line 1190 "surface.yy"
                        {
			  singleton[0] = (yyvsp[0].yyToken);
			  (yyval.yyBool) = false;
			}
#line 4720 "surface.c"
    break;

  case 246: /* typeName1Dot: kind expectedDot  */
#line 1195 "surface.yy"
                        {
			  (yyval.yyBool) = true;
			}
#line 4728 "surface.c"
    break;

  case 247: /* $@67: %empty  */
#line 1200 "surface.yy"
                                                { clear(); }
#line 4734 "surface.c"
    break;

  case 249: /* typeName: sortName  */
#line 1205 "surface.yy"
                        {
			  singleton[0] = (yyvsp[0].yyToken);
			  currentSyntaxContainer->addType(false, singleton);
			}
#line 4743 "surface.c"
    break;

  case 250: /* $@68: %empty  */
#line 1209 "surface.yy"
                                                { clear(); }
#line 4749 "surface.c"
    break;

  case 251: /* typeName: '[' $@68 sortNames ']'  */
#line 1211 "surface.yy"
                        {
			  currentSyntaxContainer->addType(true, tokenSequence);
			}
#line 4757 "surface.c"
    break;

  case 252: /* sortNames: sortNames ',' sortName  */
#line 1216 "surface.yy"
                                                        { store((yyvsp[0].yyToken)); }
#line 4763 "surface.c"
    break;

  case 253: /* sortNames: sortName  */
#line 1217 "surface.yy"
                                                        { store((yyvsp[0].yyToken)); }
#line 4769 "surface.c"
    break;

  case 254: /* attributes: '[' attributeList ']'  */
#line 1220 "surface.yy"
                                                {}
#line 4775 "surface.c"
    break;

  case 255: /* attributes: %empty  */
#line 1221 "surface.yy"
                        {}
#line 4781 "surface.c"
    break;

  case 258: /* idKeyword: KW_ID  */
#line 1229 "surface.yy"
                        {
			  CM->setFlag(SymbolType::LEFT_ID | SymbolType::RIGHT_ID);
			}
#line 4789 "surface.c"
    break;

  case 259: /* idKeyword: KW_LEFT KW_ID  */
#line 1233 "surface.yy"
                        {
			  CM->setFlag(SymbolType::LEFT_ID);
			}
#line 4797 "surface.c"
    break;

  case 260: /* idKeyword: KW_RIGHT KW_ID  */
#line 1237 "surface.yy"
                        {
			  CM->setFlag(SymbolType::RIGHT_ID);
			}
#line 4805 "surface.c"
    break;

  case 261: /* attribute: KW_ASSOC  */
#line 1243 "surface.yy"
                        {
			  CM->setFlag(SymbolType::ASSOC);
			}
#line 4813 "surface.c"
    break;

  case 262: /* attribute: KW_COMM  */
#line 1247 "surface.yy"
                        {
			  CM->setFlag(SymbolType::COMM);
			}
#line 4821 "surface.c"
    break;

  case 263: /* $@69: %empty  */
#line 1250 "surface.yy"
                                                { lexBubble(BAR_RIGHT_BRACKET | BAR_OP_ATTRIBUTE, 1); }
#line 4827 "surface.c"
    break;

  case 264: /* attribute: idKeyword $@69 identity  */
#line 1251 "surface.yy"
                                                { CM->setIdentity(lexerBubble); }
#line 4833 "surface.c"
    break;

  case 265: /* attribute: KW_IDEM  */
#line 1253 "surface.yy"
                        {
			  CM->setFlag(SymbolType::IDEM);
			}
#line 4841 "surface.c"
    break;

  case 266: /* attribute: KW_ITER  */
#line 1257 "surface.yy"
                        {
			  CM->setFlag(SymbolType::ITER);
			}
#line 4849 "surface.c"
    break;

  case 267: /* attribute: KW_PREC IDENTIFIER  */
#line 1260 "surface.yy"
                                                { CM->setPrec((yyvsp[0].yyToken)); }
#line 4855 "surface.c"
    break;

  case 268: /* $@70: %empty  */
#line 1261 "surface.yy"
                                                { clear(); }
#line 4861 "surface.c"
    break;

  case 269: /* attribute: KW_GATHER '(' $@70 idList ')'  */
#line 1262 "surface.yy"
                                                { CM->setGather(tokenSequence); }
#line 4867 "surface.c"
    break;

  case 270: /* $@71: %empty  */
#line 1263 "surface.yy"
                                                { clear(); }
#line 4873 "surface.c"
    break;

  case 271: /* attribute: KW_FORMAT '(' $@71 idList ')'  */
#line 1264 "surface.yy"
                                                { CM->setFormat(tokenSequence); }
#line 4879 "surface.c"
    break;

  case 272: /* $@72: %empty  */
#line 1265 "surface.yy"
                                                { clear(); }
#line 4885 "surface.c"
    break;

  case 273: /* attribute: KW_STRAT '(' $@72 idList ')'  */
#line 1266 "surface.yy"
                                                { CM->setStrat(tokenSequence); }
#line 4891 "surface.c"
    break;

  case 274: /* $@73: %empty  */
#line 1267 "surface.yy"
                                                { clear(); }
#line 4897 "surface.c"
    break;

  case 275: /* attribute: KW_ASTRAT '(' $@73 idList ')'  */
#line 1268 "surface.yy"
                                                { CM->setStrat(tokenSequence); }
#line 4903 "surface.c"
    break;

  case 276: /* $@74: %empty  */
#line 1269 "surface.yy"
                                                { clear(); }
#line 4909 "surface.c"
    break;

  case 277: /* attribute: KW_POLY '(' $@74 idList ')'  */
#line 1270 "surface.yy"
                                                { CM->setPoly(tokenSequence); }
#line 4915 "surface.c"
    break;

  case 278: /* attribute: KW_MEMO  */
#line 1272 "surface.yy"
                        {
			  CM->setFlag(SymbolType::MEMO);
			}
#line 4923 "surface.c"
    break;

  case 279: /* attribute: KW_CTOR  */
#line 1276 "surface.yy"
                        {
			  CM->setFlag(SymbolType::CTOR);
			}
#line 4931 "surface.c"
    break;

  case 280: /* attribute: KW_FROZEN  */
#line 1280 "surface.yy"
                        {
			  clear();
			  CM->setFrozen(tokenSequence);
			}
#line 4940 "surface.c"
    break;

  case 281: /* $@75: %empty  */
#line 1284 "surface.yy"
                                                { clear(); }
#line 4946 "surface.c"
    break;

  case 282: /* attribute: KW_FROZEN '(' $@75 idList ')'  */
#line 1285 "surface.yy"
                                                { CM->setFrozen(tokenSequence); }
#line 4952 "surface.c"
    break;

  case 283: /* attribute: KW_CONFIG  */
#line 1287 "surface.yy"
                        {
			  CM->setFlag(SymbolType::CONFIG);
			}
#line 4960 "surface.c"
    break;

  case 284: /* attribute: KW_OBJ  */
#line 1291 "surface.yy"
                        {
			  CM->setFlag(SymbolType::OBJECT);
			}
#line 4968 "surface.c"
    break;

  case 285: /* attribute: KW_MSG  */
#line 1295 "surface.yy"
                        {
			  CM->setFlag(SymbolType::MESSAGE);
			}
#line 4976 "surface.c"
    break;

  case 286: /* attribute: KW_METADATA IDENTIFIER  */
#line 1299 "surface.yy"
                        {
			  CM->setMetadata((yyvsp[0].yyToken));
			}
#line 4984 "surface.c"
    break;

  case 287: /* $@76: %empty  */
#line 1302 "surface.yy"
                                                { lexerLatexMode(); }
#line 4990 "surface.c"
    break;

  case 288: /* attribute: KW_LATEX '(' $@76 LATEX_STRING ')'  */
#line 1303 "surface.yy"
                                                { CM->setLatexMacro((yyvsp[-1].yyString)); }
#line 4996 "surface.c"
    break;

  case 289: /* attribute: KW_SPECIAL '(' hookList ')'  */
#line 1304 "surface.yy"
                                                        {}
#line 5002 "surface.c"
    break;

  case 290: /* attribute: KW_DITTO  */
#line 1306 "surface.yy"
                        {
			  CM->setFlag(SymbolType::DITTO);
			}
#line 5010 "surface.c"
    break;

  case 291: /* attribute: KW_PCONST  */
#line 1310 "surface.yy"
                        {
			  CM->setFlag(SymbolType::PCONST);
			}
#line 5018 "surface.c"
    break;

  case 293: /* identity: %empty  */
#line 1320 "surface.yy"
                        {}
#line 5024 "surface.c"
    break;

  case 294: /* idList: idList IDENTIFIER  */
#line 1323 "surface.yy"
                                                { store((yyvsp[0].yyToken)); }
#line 5030 "surface.c"
    break;

  case 295: /* idList: IDENTIFIER  */
#line 1324 "surface.yy"
                                                { store((yyvsp[0].yyToken)); }
#line 5036 "surface.c"
    break;

  case 296: /* hookList: hookList hook  */
#line 1327 "surface.yy"
                                                {}
#line 5042 "surface.c"
    break;

  case 297: /* hookList: hook  */
#line 1328 "surface.yy"
                                                {}
#line 5048 "surface.c"
    break;

  case 298: /* hook: KW_ID_HOOK token  */
#line 1331 "surface.yy"
                                                        { clear(); CM->addHook(SyntacticPreModule::ID_HOOK, (yyvsp[0].yyToken), tokenSequence); }
#line 5054 "surface.c"
    break;

  case 299: /* hook: KW_ID_HOOK token parenBubble  */
#line 1332 "surface.yy"
                                                        { CM->addHook(SyntacticPreModule::ID_HOOK, (yyvsp[-1].yyToken), lexerBubble); }
#line 5060 "surface.c"
    break;

  case 300: /* hook: KW_OP_HOOK token parenBubble  */
#line 1333 "surface.yy"
                                                        { CM->addHook(SyntacticPreModule::OP_HOOK, (yyvsp[-1].yyToken), lexerBubble); }
#line 5066 "surface.c"
    break;

  case 301: /* hook: KW_TERM_HOOK token parenBubble  */
#line 1334 "surface.yy"
                                                        { CM->addHook(SyntacticPreModule::TERM_HOOK, (yyvsp[-1].yyToken), lexerBubble); }
#line 5072 "surface.c"
    break;

  case 302: /* expectedIs: KW_IS  */
#line 1340 "surface.yy"
                              {}
#line 5078 "surface.c"
    break;

  case 303: /* expectedIs: %empty  */
#line 1342 "surface.yy"
                        {
			  IssueWarning(LineNumber(lineNumber) << ": missing " <<
				       QUOTE("is") << " keyword.");
			}
#line 5087 "surface.c"
    break;

  case 304: /* expectedDot: '.'  */
#line 1348 "surface.yy"
                            {}
#line 5093 "surface.c"
    break;

  case 305: /* expectedDot: %empty  */
#line 1350 "surface.yy"
                        {
			  IssueWarning(LineNumber(lineNumber) << ": missing period.");
			}
#line 5101 "surface.c"
    break;

  case 306: /* sortNameList: sortNameList sortName  */
#line 1358 "surface.yy"
                                                { store((yyvsp[0].yyToken)); }
#line 5107 "surface.c"
    break;

  case 307: /* sortNameList: sortName  */
#line 1359 "surface.yy"
                                                { store((yyvsp[0].yyToken)); }
#line 5113 "surface.c"
    break;

  case 308: /* endSortNameList: tokenDot  */
#line 1363 "surface.yy"
                                                { store((yyvsp[0].yyToken)); }
#line 5119 "surface.c"
    break;

  case 310: /* subsortList: subsortList sortNameList '<'  */
#line 1370 "surface.yy"
                                                        { store((yyvsp[0].yyToken)); }
#line 5125 "surface.c"
    break;

  case 311: /* subsortList: sortNameList '<'  */
#line 1371 "surface.yy"
                                                        { store((yyvsp[0].yyToken)); }
#line 5131 "surface.c"
    break;

  case 313: /* sortName: sortNameFrag  */
#line 1381 "surface.yy"
                        {
			  Token t;
			  if (fragments.size() == 1)
			    t = fragments[0];
			  else
			    t.tokenize(Token::bubbleToPrefixNameCode(fragments), fragments[0].lineNumber());
			  fragClear();
			  (yyval.yyToken) = t;
			}
#line 5145 "surface.c"
    break;

  case 314: /* sortNameFrag: sortToken  */
#line 1392 "surface.yy"
                                                { fragStore((yyvsp[0].yyToken)); }
#line 5151 "surface.c"
    break;

  case 315: /* $@77: %empty  */
#line 1393 "surface.yy"
                                                { fragStore((yyvsp[0].yyToken)); }
#line 5157 "surface.c"
    break;

  case 316: /* sortNameFrag: sortNameFrag '{' $@77 sortNameFrags '}'  */
#line 1394 "surface.yy"
                                                { fragStore((yyvsp[0].yyToken)); }
#line 5163 "surface.c"
    break;

  case 317: /* $@78: %empty  */
#line 1397 "surface.yy"
                                                { fragStore((yyvsp[0].yyToken)); }
#line 5169 "surface.c"
    break;

  case 318: /* sortNameFrags: sortNameFrags ',' $@78 sortNameFrag  */
#line 1398 "surface.yy"
                                                {}
#line 5175 "surface.c"
    break;

  case 319: /* sortNameFrags: sortNameFrag  */
#line 1399 "surface.yy"
                                                {}
#line 5181 "surface.c"
    break;

  case 320: /* tokenDot: ENDS_IN_DOT  */
#line 1403 "surface.yy"
                        {
			  Token t;
			  t.dropChar((yyvsp[0].yyToken));
			  missingSpace(t);
			  (yyval.yyToken) = t;
			}
#line 5192 "surface.c"
    break;

  case 451: /* $@79: %empty  */
#line 1530 "surface.yy"
                                                { lexBubble(END_COMMAND, 1); }
#line 5198 "surface.c"
    break;

  case 452: /* command: KW_SELECT $@79 endBubble  */
#line 1532 "surface.yy"
                        {
			  interpreter.setCurrentModule(lexerBubble);
			}
#line 5206 "surface.c"
    break;

  case 453: /* $@80: %empty  */
#line 1535 "surface.yy"
                                                { lexBubble(END_COMMAND, 1); }
#line 5212 "surface.c"
    break;

  case 454: /* command: KW_DUMP $@80 endBubble  */
#line 1537 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    CM->dump();
			}
#line 5221 "surface.c"
    break;

  case 455: /* $@81: %empty  */
#line 1542 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			}
#line 5230 "surface.c"
    break;

  case 456: /* command: KW_PARSE $@81 moduleAndTerm  */
#line 1547 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.parse(lexerBubble);
			}
#line 5240 "surface.c"
    break;

  case 457: /* $@82: %empty  */
#line 1554 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			}
#line 5249 "surface.c"
    break;

  case 458: /* command: KW_CREDUCE $@82 moduleAndTerm  */
#line 1559 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.creduce(lexerBubble);
			}
#line 5259 "surface.c"
    break;

  case 459: /* $@83: %empty  */
#line 1566 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			}
#line 5268 "surface.c"
    break;

  case 460: /* command: KW_SREDUCE $@83 moduleAndTerm  */
#line 1571 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.sreduce(lexerBubble);
			}
#line 5278 "surface.c"
    break;

  case 461: /* $@84: %empty  */
#line 1578 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			}
#line 5287 "surface.c"
    break;

  case 462: /* command: optDebug KW_REDUCE $@84 moduleAndTerm  */
#line 1583 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.reduce(lexerBubble, (yyvsp[-3].yyBool));
			}
#line 5297 "surface.c"
    break;

  case 463: /* $@85: %empty  */
#line 1590 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			}
#line 5307 "surface.c"
    break;

  case 464: /* command: optDebug KW_REWRITE $@85 numberModuleTerm  */
#line 1596 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.rewrite(lexerBubble, number, (yyvsp[-3].yyBool));
			}
#line 5317 "surface.c"
    break;

  case 465: /* $@86: %empty  */
#line 1602 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			  number2 = NONE;
			}
#line 5328 "surface.c"
    break;

  case 466: /* command: optDebug KW_EREWRITE $@86 numbersModuleTerm  */
#line 1609 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.eRewrite(lexerBubble, number, number2, (yyvsp[-3].yyBool));
			}
#line 5338 "surface.c"
    break;

  case 467: /* $@87: %empty  */
#line 1615 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			  number2 = NONE;
			}
#line 5349 "surface.c"
    break;

  case 468: /* command: optDebug KW_FREWRITE $@87 numbersModuleTerm  */
#line 1622 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.fRewrite(lexerBubble, number, number2, (yyvsp[-3].yyBool));
			}
#line 5359 "surface.c"
    break;

  case 469: /* $@88: %empty  */
#line 1628 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			}
#line 5369 "surface.c"
    break;

  case 470: /* command: optDebug KW_SREWRITE $@88 numberModuleTerm  */
#line 1634 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.sRewrite(lexerBubble, number, (yyvsp[-3].yyBool));
			}
#line 5379 "surface.c"
    break;

  case 471: /* $@89: %empty  */
#line 1640 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			}
#line 5389 "surface.c"
    break;

  case 472: /* command: optDebug KW_DSREWRITE $@89 numberModuleTerm  */
#line 1646 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.sRewrite(lexerBubble, number, (yyvsp[-3].yyBool), true);
			}
#line 5399 "surface.c"
    break;

  case 473: /* $@90: %empty  */
#line 1653 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			}
#line 5408 "surface.c"
    break;

  case 474: /* command: KW_CHECK $@90 moduleAndTerm  */
#line 1658 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.check(lexerBubble);
			}
#line 5418 "surface.c"
    break;

  case 475: /* $@91: %empty  */
#line 1665 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			  number2 = NONE;
			}
#line 5429 "surface.c"
    break;

  case 476: /* command: optDebug search $@91 numbersModuleTerm  */
#line 1672 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.search(lexerBubble, number, number2, (yyvsp[-2].yySearchKind), (yyvsp[-3].yyBool));
			}
#line 5439 "surface.c"
    break;

  case 477: /* $@92: %empty  */
#line 1678 "surface.yy"
                        {
			  variantOptions = (yyvsp[-1].yyInt64);
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			  number2 = NONE;			  
			}
#line 5451 "surface.c"
    break;

  case 478: /* command: optDebug optOptions KW_VU_NARROW $@92 optionsNumbersModuleTerm  */
#line 1686 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    {
			      interpreter.search(lexerBubble, number, number2,
			                         Interpreter::VU_NARROW, (yyvsp[-4].yyBool), variantOptions);
			    }
			}
#line 5464 "surface.c"
    break;

  case 479: /* $@93: %empty  */
#line 1695 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			}
#line 5474 "surface.c"
    break;

  case 480: /* command: match $@93 numberModuleTerm  */
#line 1701 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.match(lexerBubble, (yyvsp[-2].yyBool), number);
			}
#line 5484 "surface.c"
    break;

  case 481: /* $@94: %empty  */
#line 1707 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			}
#line 5494 "surface.c"
    break;

  case 482: /* command: optIrredundant KW_UNIFY $@94 numberModuleTerm  */
#line 1713 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.unify(lexerBubble, number, (yyvsp[-3].yyBool));
			}
#line 5504 "surface.c"
    break;

  case 483: /* $@95: %empty  */
#line 1719 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			}
#line 5514 "surface.c"
    break;

  case 484: /* command: optDebug KW_VARIANT KW_UNIFY $@95 numberModuleTerm  */
#line 1725 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.variantUnify(lexerBubble, number, false, (yyvsp[-4].yyBool));
			}
#line 5524 "surface.c"
    break;

  case 485: /* $@96: %empty  */
#line 1731 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			}
#line 5534 "surface.c"
    break;

  case 486: /* command: optDebug KW_FILTERED KW_VARIANT KW_UNIFY $@96 numberModuleTerm  */
#line 1737 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.variantUnify(lexerBubble, number, true, (yyvsp[-5].yyBool));
			}
#line 5544 "surface.c"
    break;

  case 487: /* $@97: %empty  */
#line 1743 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			}
#line 5554 "surface.c"
    break;

  case 488: /* command: optDebug KW_VARIANT KW_MATCH $@97 numberModuleTerm  */
#line 1749 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.variantMatch(lexerBubble, number, (yyvsp[-4].yyBool));
			}
#line 5564 "surface.c"
    break;

  case 489: /* $@98: %empty  */
#line 1756 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			  number = NONE;
			}
#line 5574 "surface.c"
    break;

  case 490: /* command: optDebug KW_GET optIrredundant KW_VARIANTS $@98 numberModuleTerm  */
#line 1762 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.getVariants(lexerBubble, number, (yyvsp[-3].yyBool), (yyvsp[-5].yyBool));
			}
#line 5584 "surface.c"
    break;

  case 491: /* command: optDebug KW_CONTINUE optNumber '.'  */
#line 1768 "surface.yy"
                        {
			  interpreter.cont((yyvsp[-1].yyInt64), (yyvsp[-3].yyBool));
			}
#line 5592 "surface.c"
    break;

  case 492: /* $@99: %empty  */
#line 1772 "surface.yy"
                        {
			  //
			  //	test is a generic command to call code with a term for development purposes.
			  //
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			}
#line 5604 "surface.c"
    break;

  case 493: /* command: KW_TEST $@99 moduleAndTerm  */
#line 1780 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.test(lexerBubble);
			    //interpreter.newNarrow(lexerBubble);

			}
#line 5616 "surface.c"
    break;

  case 494: /* $@100: %empty  */
#line 1788 "surface.yy"
                        {
			  lexerCmdMode();
			  moduleExpr.contractTo(0);
			}
#line 5625 "surface.c"
    break;

  case 495: /* command: KW_LOOP $@100 moduleAndTerm  */
#line 1793 "surface.yy"
                        {
			  lexerInitialMode();
			  if (interpreter.setCurrentModule(moduleExpr, 1))
			    interpreter.loop(lexerBubble);
			}
#line 5635 "surface.c"
    break;

  case 496: /* command: parenBubble  */
#line 1799 "surface.yy"
                        {
			  moduleExpr.contractTo(0);
			  if (interpreter.setCurrentModule(moduleExpr))  // HACK
			    interpreter.contLoop(lexerBubble);
			}
#line 5645 "surface.c"
    break;

  case 497: /* $@101: %empty  */
#line 1804 "surface.yy"
                                                { lexerCmdMode(); }
#line 5651 "surface.c"
    break;

  case 498: /* command: KW_TRACE select $@101 opSelect  */
#line 1806 "surface.yy"
                        {
			  lexerInitialMode();
			  interpreter.traceSelect((yyvsp[-2].yyBool));
			}
#line 5660 "surface.c"
    break;

  case 499: /* $@102: %empty  */
#line 1810 "surface.yy"
                                                        { lexerCmdMode(); }
#line 5666 "surface.c"
    break;

  case 500: /* command: KW_TRACE exclude $@102 opSelect  */
#line 1812 "surface.yy"
                        {
			  lexerInitialMode();
			  interpreter.traceExclude((yyvsp[-2].yyBool));
			}
#line 5675 "surface.c"
    break;

  case 501: /* $@103: %empty  */
#line 1816 "surface.yy"
                                                { lexerCmdMode(); }
#line 5681 "surface.c"
    break;

  case 502: /* command: KW_BREAK select $@103 opSelect  */
#line 1818 "surface.yy"
                        {
			  lexerInitialMode();
			  interpreter.breakSelect((yyvsp[-2].yyBool));
			}
#line 5690 "surface.c"
    break;

  case 503: /* $@104: %empty  */
#line 1822 "surface.yy"
                                                        { lexerCmdMode(); }
#line 5696 "surface.c"
    break;

  case 504: /* command: KW_PRINT conceal $@104 opSelect  */
#line 1824 "surface.yy"
                        {
			  lexerInitialMode();
			  interpreter.printConceal((yyvsp[-2].yyBool));
			}
#line 5705 "surface.c"
    break;

  case 505: /* $@105: %empty  */
#line 1828 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5711 "surface.c"
    break;

  case 506: /* command: KW_DO KW_CLEAR KW_MEMO $@105 endBubble  */
#line 1830 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    CM->getFlatSignature()->clearMemo();
			}
#line 5720 "surface.c"
    break;

  case 507: /* $@106: %empty  */
#line 1837 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5726 "surface.c"
    break;

  case 508: /* command: KW_SHOW KW_MOD $@106 endBubble  */
#line 1839 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    CM->showModule();
			}
#line 5735 "surface.c"
    break;

  case 509: /* $@107: %empty  */
#line 1843 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5741 "surface.c"
    break;

  case 510: /* command: KW_SHOW KW_MODULE $@107 endBubble  */
#line 1845 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    CM->showModule();
			}
#line 5750 "surface.c"
    break;

  case 511: /* $@108: %empty  */
#line 1849 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5756 "surface.c"
    break;

  case 512: /* command: KW_SHOW KW_ALL $@108 endBubble  */
#line 1851 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showModule(true);
			}
#line 5765 "surface.c"
    break;

  case 513: /* $@109: %empty  */
#line 1855 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5771 "surface.c"
    break;

  case 514: /* command: KW_SHOW KW_DESUGARED $@109 endBubble  */
#line 1857 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showModule(false);
			}
#line 5780 "surface.c"
    break;

  case 515: /* $@110: %empty  */
#line 1861 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5786 "surface.c"
    break;

  case 516: /* command: KW_SHOW KW_VIEW $@110 endBubble  */
#line 1863 "surface.yy"
                        {
			  if (interpreter.setCurrentView(lexerBubble))
			    interpreter.showView();
			}
#line 5795 "surface.c"
    break;

  case 517: /* $@111: %empty  */
#line 1867 "surface.yy"
                                                        { lexBubble(END_COMMAND, 0); }
#line 5801 "surface.c"
    break;

  case 518: /* command: KW_SHOW KW_PROCESSED KW_VIEW $@111 endBubble  */
#line 1869 "surface.yy"
                        {
			  if (interpreter.setCurrentView(lexerBubble))
			    interpreter.showProcessedView();
			}
#line 5810 "surface.c"
    break;

  case 519: /* command: KW_SHOW KW_MODULES '.'  */
#line 1874 "surface.yy"
                        {
			  interpreter.showModules(true);
			}
#line 5818 "surface.c"
    break;

  case 520: /* command: KW_SHOW KW_VIEWS '.'  */
#line 1878 "surface.yy"
                        {
			  interpreter.showViews(true);
			}
#line 5826 "surface.c"
    break;

  case 521: /* $@112: %empty  */
#line 1881 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5832 "surface.c"
    break;

  case 522: /* command: KW_SHOW KW_SORTS $@112 endBubble  */
#line 1883 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showSortsAndSubsorts();
			}
#line 5841 "surface.c"
    break;

  case 523: /* $@113: %empty  */
#line 1887 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5847 "surface.c"
    break;

  case 524: /* command: KW_SHOW KW_OPS2 $@113 endBubble  */
#line 1889 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showOps();
			}
#line 5856 "surface.c"
    break;

  case 525: /* $@114: %empty  */
#line 1893 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5862 "surface.c"
    break;

  case 526: /* command: KW_SHOW KW_VARS $@114 endBubble  */
#line 1895 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showVars();
			}
#line 5871 "surface.c"
    break;

  case 527: /* $@115: %empty  */
#line 1899 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5877 "surface.c"
    break;

  case 528: /* command: KW_SHOW KW_MBS $@115 endBubble  */
#line 1901 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showMbs();
			}
#line 5886 "surface.c"
    break;

  case 529: /* $@116: %empty  */
#line 1905 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5892 "surface.c"
    break;

  case 530: /* command: KW_SHOW KW_EQS $@116 endBubble  */
#line 1907 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showEqs();
			}
#line 5901 "surface.c"
    break;

  case 531: /* $@117: %empty  */
#line 1911 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5907 "surface.c"
    break;

  case 532: /* command: KW_SHOW KW_RLS $@117 endBubble  */
#line 1913 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showRls();
			}
#line 5916 "surface.c"
    break;

  case 533: /* $@118: %empty  */
#line 1917 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5922 "surface.c"
    break;

  case 534: /* command: KW_SHOW KW_STRATS $@118 endBubble  */
#line 1919 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showStrats();
			}
#line 5931 "surface.c"
    break;

  case 535: /* $@119: %empty  */
#line 1923 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5937 "surface.c"
    break;

  case 536: /* command: KW_SHOW KW_SDS $@119 endBubble  */
#line 1925 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showSds();
			}
#line 5946 "surface.c"
    break;

  case 537: /* $@120: %empty  */
#line 1929 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5952 "surface.c"
    break;

  case 538: /* command: KW_SHOW KW_SUMMARY $@120 endBubble  */
#line 1931 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showSummary();
			}
#line 5961 "surface.c"
    break;

  case 539: /* $@121: %empty  */
#line 1935 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 5967 "surface.c"
    break;

  case 540: /* command: KW_SHOW KW_KINDS $@121 endBubble  */
#line 1937 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showKinds();
			}
#line 5976 "surface.c"
    break;

  case 541: /* command: KW_SHOW KW_PATH SIMPLE_NUMBER '.'  */
#line 1942 "surface.yy"
                        {
			  interpreter.showSearchPath((yyvsp[-1].yyInt64), true);
			}
#line 5984 "surface.c"
    break;

  case 542: /* command: KW_SHOW KW_PATH KW_STATE SIMPLE_NUMBER '.'  */
#line 1946 "surface.yy"
                        {
			  interpreter.showSearchPath((yyvsp[-1].yyInt64), false);
			}
#line 5992 "surface.c"
    break;

  case 543: /* command: KW_SHOW KW_PATH KW_LABEL SIMPLE_NUMBER '.'  */
#line 1950 "surface.yy"
                        {
			  interpreter.showSearchPathLabels((yyvsp[-1].yyInt64));
			}
#line 6000 "surface.c"
    break;

  case 544: /* command: KW_SHOW KW_SEARCH KW_GRAPH '.'  */
#line 1954 "surface.yy"
                        {
			  interpreter.showSearchGraph();
			}
#line 6008 "surface.c"
    break;

  case 545: /* $@122: %empty  */
#line 1957 "surface.yy"
                                                { lexBubble(END_COMMAND, 0); }
#line 6014 "surface.c"
    break;

  case 546: /* command: KW_SHOW KW_PROFILE $@122 endBubble  */
#line 1959 "surface.yy"
                        {
			  if (interpreter.setCurrentModule(lexerBubble))
			    interpreter.showProfile();
			}
#line 6023 "surface.c"
    break;

  case 547: /* command: KW_SET KW_SHOW KW_ADVISE polarity '.'  */
#line 1967 "surface.yy"
                        {
			  globalAdvisoryFlag = alwaysAdviseFlag ? true : (yyvsp[-1].yyBool);
			}
#line 6031 "surface.c"
    break;

  case 548: /* command: KW_SET KW_SHOW KW_STATS polarity '.'  */
#line 1971 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::SHOW_STATS, (yyvsp[-1].yyBool));
			}
#line 6039 "surface.c"
    break;

  case 549: /* command: KW_SET KW_SHOW KW_LOOP KW_STATS polarity '.'  */
#line 1975 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::SHOW_LOOP_STATS, (yyvsp[-1].yyBool));
			}
#line 6047 "surface.c"
    break;

  case 550: /* command: KW_SET KW_SHOW KW_TIMING polarity '.'  */
#line 1979 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::SHOW_TIMING, (yyvsp[-1].yyBool));
			}
#line 6055 "surface.c"
    break;

  case 551: /* command: KW_SET KW_SHOW KW_BREAKDOWN polarity '.'  */
#line 1983 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::SHOW_BREAKDOWN, (yyvsp[-1].yyBool));
			}
#line 6063 "surface.c"
    break;

  case 552: /* command: KW_SET KW_SHOW KW_LOOP KW_TIMING polarity '.'  */
#line 1987 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::SHOW_LOOP_TIMING, (yyvsp[-1].yyBool));
			}
#line 6071 "surface.c"
    break;

  case 553: /* command: KW_SET KW_SHOW KW_CMD polarity '.'  */
#line 1991 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::SHOW_COMMAND, (yyvsp[-1].yyBool));
			}
#line 6079 "surface.c"
    break;

  case 554: /* command: KW_SET KW_SHOW KW_GC polarity '.'  */
#line 1995 "surface.yy"
                        {
			  MemoryCell::setShowGC((yyvsp[-1].yyBool));
			}
#line 6087 "surface.c"
    break;

  case 555: /* command: KW_SET KW_PRINT printOption polarity '.'  */
#line 1999 "surface.yy"
                        {
			  interpreter.setPrintFlag((yyvsp[-2].yyPrintFlags), (yyvsp[-1].yyBool));
			}
#line 6095 "surface.c"
    break;

  case 556: /* command: KW_SET KW_PRINT KW_ATTRIBUTE polarity '.'  */
#line 2003 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::PRINT_ATTRIBUTE, (yyvsp[-1].yyBool));
			}
#line 6103 "surface.c"
    break;

  case 557: /* command: KW_SET KW_PRINT KW_ATTRIBUTE KW_NEWLINE polarity '.'  */
#line 2007 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::PRINT_ATTRIBUTE_NEWLINE, (yyvsp[-1].yyBool));
			}
#line 6111 "surface.c"
    break;

  case 558: /* command: KW_SET KW_TRACE traceOption polarity '.'  */
#line 2011 "surface.yy"
                        {
			  interpreter.setFlag((yyvsp[-2].yyFlags), (yyvsp[-1].yyBool));
			}
#line 6119 "surface.c"
    break;

  case 559: /* command: KW_SET KW_BREAK polarity '.'  */
#line 2015 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::BREAK, (yyvsp[-1].yyBool));
			}
#line 6127 "surface.c"
    break;

  case 560: /* $@123: %empty  */
#line 2018 "surface.yy"
                                                        { lexerCmdMode(); }
#line 6133 "surface.c"
    break;

  case 561: /* $@124: %empty  */
#line 2019 "surface.yy"
                                                        { lexerInitialMode(); }
#line 6139 "surface.c"
    break;

  case 562: /* command: KW_SET importMode $@123 cSimpleTokenBarDot $@124 polarity '.'  */
#line 2021 "surface.yy"
                        {
			  interpreter.setAutoImport((yyvsp[-5].yyImportMode), (yyvsp[-3].yyToken), (yyvsp[-1].yyBool));
			}
#line 6147 "surface.c"
    break;

  case 563: /* $@125: %empty  */
#line 2024 "surface.yy"
                                                        { lexerCmdMode(); }
#line 6153 "surface.c"
    break;

  case 564: /* $@126: %empty  */
#line 2025 "surface.yy"
                                                        { lexerInitialMode(); }
#line 6159 "surface.c"
    break;

  case 565: /* command: KW_SET KW_OO KW_INCLUDE $@125 cSimpleTokenBarDot $@126 polarity '.'  */
#line 2027 "surface.yy"
                        {
			  interpreter.setOoInclude((yyvsp[-3].yyToken), (yyvsp[-1].yyBool));
			}
#line 6167 "surface.c"
    break;

  case 566: /* command: KW_SET KW_VERBOSE polarity '.'  */
#line 2031 "surface.yy"
                        {
			  globalVerboseFlag = (yyvsp[-1].yyBool);
			}
#line 6175 "surface.c"
    break;

  case 567: /* command: KW_SET KW_CLEAR KW_MEMO polarity '.'  */
#line 2035 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::AUTO_CLEAR_MEMO, (yyvsp[-1].yyBool));
			}
#line 6183 "surface.c"
    break;

  case 568: /* command: KW_SET KW_CLEAR KW_RLS polarity '.'  */
#line 2039 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::AUTO_CLEAR_RULES, (yyvsp[-1].yyBool));
			}
#line 6191 "surface.c"
    break;

  case 569: /* command: KW_SET KW_COMPILE KW_COUNT polarity '.'  */
#line 2043 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::COMPILE_COUNT, (yyvsp[-1].yyBool));
			}
#line 6199 "surface.c"
    break;

  case 570: /* command: KW_SET KW_PROFILE polarity '.'  */
#line 2047 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::PROFILE, (yyvsp[-1].yyBool));
			}
#line 6207 "surface.c"
    break;

  case 571: /* command: KW_SET KW_CLEAR KW_PROFILE polarity '.'  */
#line 2051 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::AUTO_CLEAR_PROFILE, (yyvsp[-1].yyBool));
			}
#line 6215 "surface.c"
    break;

  case 572: /* command: KW_RESUME '.'  */
#line 2058 "surface.yy"
                        {
			  PARSE_RESULT = UserLevelRewritingContext::RESUME;
			}
#line 6223 "surface.c"
    break;

  case 573: /* command: KW_ABORT '.'  */
#line 2062 "surface.yy"
                        {
			  PARSE_RESULT = UserLevelRewritingContext::ABORT;
			}
#line 6231 "surface.c"
    break;

  case 574: /* command: KW_STEP '.'  */
#line 2066 "surface.yy"
                        {
			  PARSE_RESULT = UserLevelRewritingContext::STEP;
			}
#line 6239 "surface.c"
    break;

  case 575: /* command: KW_IMPLIED_STEP  */
#line 2070 "surface.yy"
                        {
			  PARSE_RESULT = UserLevelRewritingContext::STEP;
			}
#line 6247 "surface.c"
    break;

  case 576: /* command: KW_WHERE '.'  */
#line 2074 "surface.yy"
                        {
			  PARSE_RESULT = UserLevelRewritingContext::WHERE;
			}
#line 6255 "surface.c"
    break;

  case 577: /* command: KW_SET KW_GC KW_SHOW polarity '.'  */
#line 2081 "surface.yy"
                        {
			  MemoryCell::setShowGC((yyvsp[-1].yyBool));
			}
#line 6263 "surface.c"
    break;

  case 578: /* command: KW_SET KW_STATS polarity '.'  */
#line 2085 "surface.yy"
                        {
			  interpreter.setFlag(Interpreter::SHOW_STATS, (yyvsp[-1].yyBool));
			}
#line 6271 "surface.c"
    break;

  case 579: /* $@127: %empty  */
#line 2091 "surface.yy"
                                                { lexerInitialMode(); }
#line 6277 "surface.c"
    break;

  case 581: /* printOption: KW_MIXFIX  */
#line 2098 "surface.yy"
                                                { (yyval.yyPrintFlags) = Interpreter::PRINT_MIXFIX; }
#line 6283 "surface.c"
    break;

  case 582: /* printOption: KW_FLAT  */
#line 2099 "surface.yy"
                                                { (yyval.yyPrintFlags) = Interpreter::PRINT_FLAT; }
#line 6289 "surface.c"
    break;

  case 583: /* printOption: KW_WITH KW_ALIASES  */
#line 2100 "surface.yy"
                                                { (yyval.yyPrintFlags) = Interpreter::PRINT_WITH_ALIASES; }
#line 6295 "surface.c"
    break;

  case 584: /* printOption: KW_WITH KW_PARENS  */
#line 2101 "surface.yy"
                                                { (yyval.yyPrintFlags) = Interpreter::PRINT_WITH_PARENS; }
#line 6301 "surface.c"
    break;

  case 585: /* printOption: KW_GRAPH  */
#line 2102 "surface.yy"
                                                { (yyval.yyPrintFlags) = Interpreter::PRINT_GRAPH; }
#line 6307 "surface.c"
    break;

  case 586: /* printOption: KW_CONCEAL  */
#line 2103 "surface.yy"
                                                { (yyval.yyPrintFlags) = Interpreter::PRINT_CONCEAL; }
#line 6313 "surface.c"
    break;

  case 587: /* printOption: KW_NUMBER  */
#line 2104 "surface.yy"
                                                { (yyval.yyPrintFlags) = Interpreter::PRINT_NUMBER; }
#line 6319 "surface.c"
    break;

  case 588: /* printOption: KW_RAT  */
#line 2105 "surface.yy"
                                                { (yyval.yyPrintFlags) = Interpreter::PRINT_RAT; }
#line 6325 "surface.c"
    break;

  case 589: /* printOption: KW_COLOR  */
#line 2106 "surface.yy"
                                                { (yyval.yyPrintFlags) = Interpreter::PRINT_COLOR; }
#line 6331 "surface.c"
    break;

  case 590: /* printOption: KW_FORMAT  */
#line 2107 "surface.yy"
                                                { (yyval.yyPrintFlags) = Interpreter::PRINT_FORMAT; }
#line 6337 "surface.c"
    break;

  case 591: /* printOption: KW_CONST KW_WITH KW_SORTS  */
#line 2108 "surface.yy"
                                                        { (yyval.yyPrintFlags) = Interpreter::PRINT_DISAMBIG_CONST; }
#line 6343 "surface.c"
    break;

  case 592: /* traceOption: %empty  */
#line 2111 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE; }
#line 6349 "surface.c"
    break;

  case 593: /* traceOption: KW_CONDITION  */
#line 2112 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_CONDITION; }
#line 6355 "surface.c"
    break;

  case 594: /* traceOption: KW_WHOLE  */
#line 2113 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_WHOLE; }
#line 6361 "surface.c"
    break;

  case 595: /* traceOption: KW_SUBSTITUTION  */
#line 2114 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_SUBSTITUTION; }
#line 6367 "surface.c"
    break;

  case 596: /* traceOption: KW_SELECT  */
#line 2115 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_SELECT; }
#line 6373 "surface.c"
    break;

  case 597: /* traceOption: KW_MBS  */
#line 2116 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_MB; }
#line 6379 "surface.c"
    break;

  case 598: /* traceOption: KW_EQS  */
#line 2117 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_EQ; }
#line 6385 "surface.c"
    break;

  case 599: /* traceOption: KW_RLS  */
#line 2118 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_RL; }
#line 6391 "surface.c"
    break;

  case 600: /* traceOption: KW_SDS  */
#line 2119 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_SD; }
#line 6397 "surface.c"
    break;

  case 601: /* traceOption: KW_REWRITE  */
#line 2120 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_REWRITE; }
#line 6403 "surface.c"
    break;

  case 602: /* traceOption: KW_BODY  */
#line 2121 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_BODY; }
#line 6409 "surface.c"
    break;

  case 603: /* traceOption: KW_BUILTIN  */
#line 2122 "surface.yy"
                                                { (yyval.yyFlags) = Interpreter::TRACE_BUILTIN; }
#line 6415 "surface.c"
    break;

  case 604: /* polarity: KW_ON  */
#line 2125 "surface.yy"
                                                { (yyval.yyBool) = true; }
#line 6421 "surface.c"
    break;

  case 605: /* polarity: KW_OFF  */
#line 2126 "surface.yy"
                                                { (yyval.yyBool) = false; }
#line 6427 "surface.c"
    break;

  case 606: /* select: KW_SELECT  */
#line 2129 "surface.yy"
                                                { (yyval.yyBool) = true; }
#line 6433 "surface.c"
    break;

  case 607: /* select: KW_DESELECT  */
#line 2130 "surface.yy"
                                                { (yyval.yyBool) = false; }
#line 6439 "surface.c"
    break;

  case 608: /* exclude: KW_EXCLUDE  */
#line 2133 "surface.yy"
                                                { (yyval.yyBool) = true; }
#line 6445 "surface.c"
    break;

  case 609: /* exclude: KW_INCLUDE  */
#line 2134 "surface.yy"
                                                { (yyval.yyBool) = false; }
#line 6451 "surface.c"
    break;

  case 610: /* conceal: KW_CONCEAL  */
#line 2137 "surface.yy"
                                                { (yyval.yyBool) = true; }
#line 6457 "surface.c"
    break;

  case 611: /* conceal: KW_REVEAL  */
#line 2138 "surface.yy"
                                                { (yyval.yyBool) = false; }
#line 6463 "surface.c"
    break;

  case 612: /* search: KW_NARROW  */
#line 2143 "surface.yy"
                                                { (yyval.yySearchKind) = Interpreter::NARROW; }
#line 6469 "surface.c"
    break;

  case 613: /* search: KW_XG_NARROW  */
#line 2144 "surface.yy"
                                                { (yyval.yySearchKind) = Interpreter::XG_NARROW; }
#line 6475 "surface.c"
    break;

  case 614: /* search: KW_SEARCH  */
#line 2145 "surface.yy"
                                                { (yyval.yySearchKind) = Interpreter::SEARCH; }
#line 6481 "surface.c"
    break;

  case 615: /* search: KW_SMT_SEARCH  */
#line 2146 "surface.yy"
                                                { (yyval.yySearchKind) = Interpreter::SMT_SEARCH; }
#line 6487 "surface.c"
    break;

  case 616: /* search: KW_FVU_NARROW  */
#line 2147 "surface.yy"
                                                { (yyval.yySearchKind) = Interpreter::FVU_NARROW; }
#line 6493 "surface.c"
    break;

  case 617: /* match: KW_XMATCH  */
#line 2150 "surface.yy"
                                                { (yyval.yyBool) = true; }
#line 6499 "surface.c"
    break;

  case 618: /* match: KW_MATCH  */
#line 2151 "surface.yy"
                                                { (yyval.yyBool) = false; }
#line 6505 "surface.c"
    break;

  case 619: /* optDebug: KW_DEBUG  */
#line 2154 "surface.yy"
                                                { (yyval.yyBool) = true; }
#line 6511 "surface.c"
    break;

  case 620: /* optDebug: %empty  */
#line 2155 "surface.yy"
                                                { (yyval.yyBool) = false; }
#line 6517 "surface.c"
    break;

  case 621: /* optIrredundant: KW_IRREDUNDANT  */
#line 2158 "surface.yy"
                                                { (yyval.yyBool) = true; }
#line 6523 "surface.c"
    break;

  case 622: /* optIrredundant: %empty  */
#line 2159 "surface.yy"
                                                { (yyval.yyBool) = false; }
#line 6529 "surface.c"
    break;

  case 623: /* optNumber: SIMPLE_NUMBER  */
#line 2162 "surface.yy"
                                                { (yyval.yyInt64) = (yyvsp[0].yyInt64); }
#line 6535 "surface.c"
    break;

  case 624: /* optNumber: %empty  */
#line 2163 "surface.yy"
                                                { (yyval.yyInt64) = NONE; }
#line 6541 "surface.c"
    break;

  case 625: /* optOptions: '{' optionsList '}'  */
#line 2166 "surface.yy"
                                                { (yyval.yyInt64) = (yyvsp[-1].yyInt64); }
#line 6547 "surface.c"
    break;

  case 626: /* optOptions: %empty  */
#line 2167 "surface.yy"
                                                { (yyval.yyInt64) = 0; }
#line 6553 "surface.c"
    break;

  case 627: /* optionsList: option  */
#line 2170 "surface.yy"
                                                { (yyval.yyInt64) = (yyvsp[0].yyInt64); }
#line 6559 "surface.c"
    break;

  case 628: /* optionsList: optionsList ',' option  */
#line 2171 "surface.yy"
                                                { (yyval.yyInt64) = (yyvsp[-2].yyInt64) | (yyvsp[0].yyInt64); }
#line 6565 "surface.c"
    break;

  case 629: /* option: KW_FOLD  */
#line 2174 "surface.yy"
                                                { (yyval.yyInt64) = NarrowingSequenceSearch3::FOLD; }
#line 6571 "surface.c"
    break;

  case 630: /* importMode: KW_PROTECT  */
#line 2177 "surface.yy"
                                                { (yyval.yyImportMode) = ImportModule::PROTECTING; }
#line 6577 "surface.c"
    break;

  case 631: /* importMode: KW_EXTEND  */
#line 2178 "surface.yy"
                                                { (yyval.yyImportMode) = ImportModule::EXTENDING; }
#line 6583 "surface.c"
    break;

  case 632: /* importMode: KW_GENERATE_BY  */
#line 2179 "surface.yy"
                                                { (yyval.yyImportMode) = ImportModule::GENERATED_BY; }
#line 6589 "surface.c"
    break;

  case 633: /* importMode: KW_INCLUDE  */
#line 2180 "surface.yy"
                                                { (yyval.yyImportMode) = ImportModule::INCLUDING; }
#line 6595 "surface.c"
    break;

  case 635: /* $@128: %empty  */
#line 2190 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6601 "surface.c"
    break;

  case 637: /* $@129: %empty  */
#line 2194 "surface.yy"
                                                { moduleExpr = lexerBubble; lexBubble(END_COMMAND, 1); }
#line 6607 "surface.c"
    break;

  case 640: /* $@130: %empty  */
#line 2206 "surface.yy"
                                                { lexSave((yyvsp[0].yyToken)); }
#line 6613 "surface.c"
    break;

  case 643: /* $@131: %empty  */
#line 2209 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), END_COMMAND, 0);  }
#line 6619 "surface.c"
    break;

  case 645: /* $@132: %empty  */
#line 2214 "surface.yy"
                                                { lexContinueSave((yyvsp[0].yyToken)); }
#line 6625 "surface.c"
    break;

  case 647: /* $@133: %empty  */
#line 2216 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6631 "surface.c"
    break;

  case 650: /* $@134: %empty  */
#line 2222 "surface.yy"
                                                { number = Token::codeToInt64(lexerBubble[1].code()); }
#line 6637 "surface.c"
    break;

  case 652: /* $@135: %empty  */
#line 2224 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6643 "surface.c"
    break;

  case 655: /* $@136: %empty  */
#line 2240 "surface.yy"
                                                { lexSave((yyvsp[0].yyToken)); }
#line 6649 "surface.c"
    break;

  case 657: /* $@137: %empty  */
#line 2242 "surface.yy"
                                                { lexSave((yyvsp[0].yyToken)); }
#line 6655 "surface.c"
    break;

  case 660: /* $@138: %empty  */
#line 2245 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6661 "surface.c"
    break;

  case 662: /* $@139: %empty  */
#line 2251 "surface.yy"
                        {
			  lexContinueSave((yyvsp[0].yyToken));
			  variantOptions |= VariantUnificationProblem::FILTER_VARIANT_UNIFIERS;
			}
#line 6670 "surface.c"
    break;

  case 664: /* $@140: %empty  */
#line 2257 "surface.yy"
                        {
			  lexContinueSave((yyvsp[0].yyToken));
			  variantOptions |= VariantSearch::IRREDUNDANT_MODE;
			}
#line 6679 "surface.c"
    break;

  case 666: /* $@141: %empty  */
#line 2262 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6685 "surface.c"
    break;

  case 670: /* $@142: %empty  */
#line 2270 "surface.yy"
                                                { lexContinueSave((yyvsp[0].yyToken)); }
#line 6691 "surface.c"
    break;

  case 672: /* $@143: %empty  */
#line 2272 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6697 "surface.c"
    break;

  case 675: /* $@144: %empty  */
#line 2281 "surface.yy"
                                                { lexSave((yyvsp[0].yyToken)); }
#line 6703 "surface.c"
    break;

  case 678: /* $@145: %empty  */
#line 2284 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6709 "surface.c"
    break;

  case 680: /* $@146: %empty  */
#line 2293 "surface.yy"
                                                { lexContinueSave((yyvsp[0].yyToken)); }
#line 6715 "surface.c"
    break;

  case 682: /* $@147: %empty  */
#line 2295 "surface.yy"
                                                { lexContinueSave((yyvsp[0].yyToken)); }
#line 6721 "surface.c"
    break;

  case 684: /* $@148: %empty  */
#line 2297 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6727 "surface.c"
    break;

  case 687: /* $@149: %empty  */
#line 2307 "surface.yy"
                                                { number = Token::codeToInt64(lexerBubble[1].code()); }
#line 6733 "surface.c"
    break;

  case 689: /* $@150: %empty  */
#line 2309 "surface.yy"
                                                { lexContinueSave((yyvsp[0].yyToken)); }
#line 6739 "surface.c"
    break;

  case 691: /* $@151: %empty  */
#line 2311 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6745 "surface.c"
    break;

  case 694: /* $@152: %empty  */
#line 2321 "surface.yy"
                                                { lexContinueSave((yyvsp[0].yyToken)); }
#line 6751 "surface.c"
    break;

  case 696: /* $@153: %empty  */
#line 2323 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6757 "surface.c"
    break;

  case 699: /* $@154: %empty  */
#line 2334 "surface.yy"
                        {
			  number = Token::codeToInt64(lexerBubble[1].code());
			  number2 = Token::codeToInt64(lexerBubble[3].code());
			  clear();
			}
#line 6767 "surface.c"
    break;

  case 701: /* $@155: %empty  */
#line 2340 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6773 "surface.c"
    break;

  case 704: /* $@156: %empty  */
#line 2350 "surface.yy"
                                                { lexContinueSave((yyvsp[0].yyToken)); }
#line 6779 "surface.c"
    break;

  case 706: /* $@157: %empty  */
#line 2352 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6785 "surface.c"
    break;

  case 709: /* $@158: %empty  */
#line 2362 "surface.yy"
                                                { number2 = Token::codeToInt64(lexerBubble[2].code()); }
#line 6791 "surface.c"
    break;

  case 711: /* $@159: %empty  */
#line 2364 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0); }
#line 6797 "surface.c"
    break;

  case 714: /* $@160: %empty  */
#line 2369 "surface.yy"
                                                { lexContinueBubble((yyvsp[0].yyToken), END_COMMAND, 0, 1); }
#line 6803 "surface.c"
    break;

  case 717: /* $@161: %empty  */
#line 2380 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), END_COMMAND, 1, 1); }
#line 6809 "surface.c"
    break;

  case 719: /* $@162: %empty  */
#line 2382 "surface.yy"
                                                { lexBubble((yyvsp[0].yyToken), BAR_COLON | END_COMMAND, 0); }
#line 6815 "surface.c"
    break;

  case 721: /* initialEndBubble: ENDS_IN_DOT  */
#line 2385 "surface.yy"
                        {
			  lexerBubble.resize(1);
			  lexerBubble[0].dropChar((yyvsp[0].yyToken));
			  missingSpace(lexerBubble[0]);
			}
#line 6825 "surface.c"
    break;

  case 802: /* endSelect: '.'  */
#line 2436 "surface.yy"
                                        {}
#line 6831 "surface.c"
    break;

  case 804: /* badSelect: ENDS_IN_DOT  */
#line 2441 "surface.yy"
                        {
			  singleton[0].dropChar((yyvsp[0].yyToken));
			  missingSpace(singleton[0]);
			  interpreter.addSelected(singleton);
			}
#line 6841 "surface.c"
    break;

  case 807: /* cSimpleOpName: cSimpleTokenBarDot  */
#line 2452 "surface.yy"
                        {
			  singleton[0] = (yyvsp[0].yyToken);
			  interpreter.addSelected(singleton);
			}
#line 6850 "surface.c"
    break;

  case 808: /* cSimpleOpName: parenBubble  */
#line 2457 "surface.yy"
                        {
			  interpreter.addSelected(lexerBubble);
			}
#line 6858 "surface.c"
    break;


#line 6862 "surface.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (parseResult, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, parseResult);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, parseResult);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (parseResult, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, parseResult);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, parseResult);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2491 "surface.yy"


static void
yyerror(UserLevelRewritingContext::ParseResult* /*parseResult*/, const char *s)
{
  if (!suppressParserErrorMessage)
    IssueWarning(LineNumber(lineNumber) << ": " << s);
}

void
cleanUpModuleExpression()
{
  //cout << "cleanUpModuleExpression() called" << endl;
  //
  //	Delete pieces of a partly built module expression.
  //
  delete currentRenaming;
  currentRenaming = 0;
}

void
cleanUpParser()
{
  suppressParserErrorMessage = false;
  interpreter.makeClean(lineNumber);
}

void
deepSelfDestructViewExpressionVector(Vector<ViewExpression*>* viewExpressions)
{
  for (ViewExpression* v : *viewExpressions)
    v->deepSelfDestruct();
  delete viewExpressions;
}

void
missingSpace(const Token& token)
{
  IssueWarning(LineNumber(token.lineNumber()) << ": missing space between " <<
	       QUOTE(token) << " and period.");
}
